C...dg_dxddg.f is a part of the VINCIA event generator.
C...This file was generated by MADGRAPH 5
C...Modified by VINCIA Thu  8 Jun 2017 15:37:48 CEST
C...VINCIA is licenced under the GNU GPL version 2.
C...Copyright (C) 2018 Peter Skands
C...Please respect the work of the MadGraph authors by
C...citing MadGraph 5 when this part of VINCIA is used.
C...See: https://arxiv.org/abs/1106.0522
 
      SUBROUTINE SHELdg_dxddg(MCMODE,ICOL,P,HEL,ANS)
      IMPLICIT NONE
C     
C     CONSTANT
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=6)
      INTEGER                 NCOMB
      PARAMETER (             NCOMB=64)
CF2PY INTENT(OUT) :: ANS
CF2PY INTENT(IN) :: HEL
CF2PY INTENT(IN) :: P(0:3,NEXTERNAL)

C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION ANS, P(0:3,NEXTERNAL)
C...VINCIA: Define MCMODE and ICOL variables
C...  MCMODE = 0 : Leading Colour = LC[icol]
C...  MCMODE = 1 : Vincia Colour  = FC * LC[icol]/sum(LC)
C...  MCMODE = 2 : Full Colour    = FC (-> normal MG mode)
      INTEGER MCMODE, ICOL
      INTEGER HEL
C     
C     GLOBAL VARIABLES
C     
      INTEGER USERHEL
      COMMON/HELUSERCHOICE/USERHEL
C     ----------
C     BEGIN CODE
C     ----------
      USERHEL=HEL
      CALL Sdg_dxddg(MCMODE,ICOL,P,ANS)
      USERHEL=-1

      END

      SUBROUTINE Sdg_dxddg(MCMODE,ICOL,P,ANS)
C     
C     Generated by MadGraph5_aMC@NLO v. 2.4.2, 2016-06-10
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C     
C     MadGraph5_aMC@NLO StandAlone Version
C     
C     Returns amplitude squared summed/avg over colors
C     and helicities
C     for the point in phase space P(0:3,NEXTERNAL)
C     
C     Process: d g > d~ d d g WEIGHTED<=4 @210
C     Process: u g > u~ u u g WEIGHTED<=4 @210
C     Process: s g > s~ s s g WEIGHTED<=4 @210
C     Process: c g > c~ c c g WEIGHTED<=4 @210
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=6)
      INTEGER    NINITIAL
      PARAMETER (NINITIAL=2)
      INTEGER NPOLENTRIES
      PARAMETER (NPOLENTRIES=(NEXTERNAL+1)*6)
      INTEGER                 NCOMB
      PARAMETER (             NCOMB=64)
      INTEGER HELAVGFACTOR
      PARAMETER (HELAVGFACTOR=4)
C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION ANS, P(0:3,NEXTERNAL)
C...VINCIA: Define MCMODE and ICOL variables
C...  MCMODE = 0 : Leading Colour = LC[icol]
C...  MCMODE = 1 : Vincia Colour  = FC * LC[icol]/sum(LC)
C...  MCMODE = 2 : Full Colour    = FC (-> normal MG mode)
      INTEGER MCMODE, ICOL
CF2PY INTENT(OUT) :: ANS
CF2PY INTENT(IN) :: P(0:3,NEXTERNAL)
C     
C     LOCAL VARIABLES 
C     
      INTEGER NHEL(NEXTERNAL,NCOMB),NTRY
      DOUBLE PRECISION T
      DOUBLE PRECISION dg_dxddg
      INTEGER IHEL,IDEN, I, J
C     For a 1>N process, them BEAMTWO_HELAVGFACTOR would be set to 1.
      INTEGER BEAMS_HELAVGFACTOR(2)
      DATA (BEAMS_HELAVGFACTOR(I),I=1,2)/2,2/
      INTEGER JC(NEXTERNAL)
      LOGICAL GOODHEL(NCOMB)
      DATA NTRY/0/
      DATA GOODHEL/NCOMB*.FALSE./

C     
C     GLOBAL VARIABLES
C     
      INTEGER USERHEL
      COMMON/HELUSERCHOICE/USERHEL
C...VINCIA: USERHEL is initialised by MG5interface
C      DATA USERHEL/-1/

      DATA (NHEL(I,   1),I=1,6) / 1,-1, 1,-1,-1,-1/
      DATA (NHEL(I,   2),I=1,6) / 1,-1, 1,-1,-1, 1/
      DATA (NHEL(I,   3),I=1,6) / 1,-1, 1,-1, 1,-1/
      DATA (NHEL(I,   4),I=1,6) / 1,-1, 1,-1, 1, 1/
      DATA (NHEL(I,   5),I=1,6) / 1,-1, 1, 1,-1,-1/
      DATA (NHEL(I,   6),I=1,6) / 1,-1, 1, 1,-1, 1/
      DATA (NHEL(I,   7),I=1,6) / 1,-1, 1, 1, 1,-1/
      DATA (NHEL(I,   8),I=1,6) / 1,-1, 1, 1, 1, 1/
      DATA (NHEL(I,   9),I=1,6) / 1,-1,-1,-1,-1,-1/
      DATA (NHEL(I,  10),I=1,6) / 1,-1,-1,-1,-1, 1/
      DATA (NHEL(I,  11),I=1,6) / 1,-1,-1,-1, 1,-1/
      DATA (NHEL(I,  12),I=1,6) / 1,-1,-1,-1, 1, 1/
      DATA (NHEL(I,  13),I=1,6) / 1,-1,-1, 1,-1,-1/
      DATA (NHEL(I,  14),I=1,6) / 1,-1,-1, 1,-1, 1/
      DATA (NHEL(I,  15),I=1,6) / 1,-1,-1, 1, 1,-1/
      DATA (NHEL(I,  16),I=1,6) / 1,-1,-1, 1, 1, 1/
      DATA (NHEL(I,  17),I=1,6) / 1, 1, 1,-1,-1,-1/
      DATA (NHEL(I,  18),I=1,6) / 1, 1, 1,-1,-1, 1/
      DATA (NHEL(I,  19),I=1,6) / 1, 1, 1,-1, 1,-1/
      DATA (NHEL(I,  20),I=1,6) / 1, 1, 1,-1, 1, 1/
      DATA (NHEL(I,  21),I=1,6) / 1, 1, 1, 1,-1,-1/
      DATA (NHEL(I,  22),I=1,6) / 1, 1, 1, 1,-1, 1/
      DATA (NHEL(I,  23),I=1,6) / 1, 1, 1, 1, 1,-1/
      DATA (NHEL(I,  24),I=1,6) / 1, 1, 1, 1, 1, 1/
      DATA (NHEL(I,  25),I=1,6) / 1, 1,-1,-1,-1,-1/
      DATA (NHEL(I,  26),I=1,6) / 1, 1,-1,-1,-1, 1/
      DATA (NHEL(I,  27),I=1,6) / 1, 1,-1,-1, 1,-1/
      DATA (NHEL(I,  28),I=1,6) / 1, 1,-1,-1, 1, 1/
      DATA (NHEL(I,  29),I=1,6) / 1, 1,-1, 1,-1,-1/
      DATA (NHEL(I,  30),I=1,6) / 1, 1,-1, 1,-1, 1/
      DATA (NHEL(I,  31),I=1,6) / 1, 1,-1, 1, 1,-1/
      DATA (NHEL(I,  32),I=1,6) / 1, 1,-1, 1, 1, 1/
      DATA (NHEL(I,  33),I=1,6) /-1,-1, 1,-1,-1,-1/
      DATA (NHEL(I,  34),I=1,6) /-1,-1, 1,-1,-1, 1/
      DATA (NHEL(I,  35),I=1,6) /-1,-1, 1,-1, 1,-1/
      DATA (NHEL(I,  36),I=1,6) /-1,-1, 1,-1, 1, 1/
      DATA (NHEL(I,  37),I=1,6) /-1,-1, 1, 1,-1,-1/
      DATA (NHEL(I,  38),I=1,6) /-1,-1, 1, 1,-1, 1/
      DATA (NHEL(I,  39),I=1,6) /-1,-1, 1, 1, 1,-1/
      DATA (NHEL(I,  40),I=1,6) /-1,-1, 1, 1, 1, 1/
      DATA (NHEL(I,  41),I=1,6) /-1,-1,-1,-1,-1,-1/
      DATA (NHEL(I,  42),I=1,6) /-1,-1,-1,-1,-1, 1/
      DATA (NHEL(I,  43),I=1,6) /-1,-1,-1,-1, 1,-1/
      DATA (NHEL(I,  44),I=1,6) /-1,-1,-1,-1, 1, 1/
      DATA (NHEL(I,  45),I=1,6) /-1,-1,-1, 1,-1,-1/
      DATA (NHEL(I,  46),I=1,6) /-1,-1,-1, 1,-1, 1/
      DATA (NHEL(I,  47),I=1,6) /-1,-1,-1, 1, 1,-1/
      DATA (NHEL(I,  48),I=1,6) /-1,-1,-1, 1, 1, 1/
      DATA (NHEL(I,  49),I=1,6) /-1, 1, 1,-1,-1,-1/
      DATA (NHEL(I,  50),I=1,6) /-1, 1, 1,-1,-1, 1/
      DATA (NHEL(I,  51),I=1,6) /-1, 1, 1,-1, 1,-1/
      DATA (NHEL(I,  52),I=1,6) /-1, 1, 1,-1, 1, 1/
      DATA (NHEL(I,  53),I=1,6) /-1, 1, 1, 1,-1,-1/
      DATA (NHEL(I,  54),I=1,6) /-1, 1, 1, 1,-1, 1/
      DATA (NHEL(I,  55),I=1,6) /-1, 1, 1, 1, 1,-1/
      DATA (NHEL(I,  56),I=1,6) /-1, 1, 1, 1, 1, 1/
      DATA (NHEL(I,  57),I=1,6) /-1, 1,-1,-1,-1,-1/
      DATA (NHEL(I,  58),I=1,6) /-1, 1,-1,-1,-1, 1/
      DATA (NHEL(I,  59),I=1,6) /-1, 1,-1,-1, 1,-1/
      DATA (NHEL(I,  60),I=1,6) /-1, 1,-1,-1, 1, 1/
      DATA (NHEL(I,  61),I=1,6) /-1, 1,-1, 1,-1,-1/
      DATA (NHEL(I,  62),I=1,6) /-1, 1,-1, 1,-1, 1/
      DATA (NHEL(I,  63),I=1,6) /-1, 1,-1, 1, 1,-1/
      DATA (NHEL(I,  64),I=1,6) /-1, 1,-1, 1, 1, 1/
      DATA IDEN/192/

      INTEGER POLARIZATIONS(0:NEXTERNAL,0:5)
      DATA ((POLARIZATIONS(I,J),I=0,NEXTERNAL),J=0,5)/NPOLENTRIES*-1/
C...Vincia: BORN_BEAM_POL not used (POLARIZATIONS local and = -1)
C      COMMON/BORN_BEAM_POL/POLARIZATIONS
C     
C     FUNCTIONS
C     
C...Vincia conversion hardcodes for IS_BORN_HEL_SELECTED = .TRUE.
C      LOGICAL IS_BORN_HEL_SELECTED

C     ----------
C     BEGIN CODE
C     ----------
      IF(USERHEL.EQ.-1) NTRY=0
C...(VINCIA: no NTRY optimisation)
      DO IHEL=1,NEXTERNAL
        JC(IHEL) = +1
      ENDDO
C     When spin-2 particles are involved, the Helicity filtering is
C      dangerous for the 2->1 topology.
C     This is because depending on the MC setup the initial PS points
C      have back-to-back initial states
C     for which some of the spin-2 helicity configurations are zero.
C      But they are no longer zero
C     if the point is boosted on the z-axis. Remember that HELAS
C      helicity amplitudes are no longer
C     lorentz invariant with expternal spin-2 particles (only the
C      helicity sum is).
C     For this reason, we simply remove the filterin when there is
C      only three external particles.
      IF (NEXTERNAL.LE.3) THEN
        DO IHEL=1,NCOMB
          GOODHEL(IHEL)=.TRUE.
        ENDDO
      ENDIF
      ANS = 0D0
      DO IHEL=1,NCOMB
        IF (USERHEL.EQ.-1.OR.USERHEL.EQ.IHEL) THEN
          IF (GOODHEL(IHEL) .OR. NTRY .LT. 20.OR.USERHEL.NE.-1) THEN
            IF(NTRY.GE.2.AND.POLARIZATIONS(0,0).NE.
     $       -1.AND.(.FALSE.)) THEN
              CYCLE
            ENDIF
            T=dg_dxddg(MCMODE,ICOL,P ,NHEL(1,IHEL),JC(1))
            IF(POLARIZATIONS(0,0).EQ.-1.OR..TRUE.)
     $        THEN
              ANS=ANS+T
            ENDIF
            IF (T .NE. 0D0 .AND. .NOT.    GOODHEL(IHEL)) THEN
              GOODHEL(IHEL)=.TRUE.
            ENDIF
          ENDIF
        ENDIF
      ENDDO

C...VINCIA: Only normalise by Bose factor if doing full colour
      IF (MCMODE.EQ.2) ANS=ANS/DBLE(IDEN)
      IF(USERHEL.NE.-1) THEN
C...Cancel helicity-averaging factor when doing helicity amplitudes
        ANS=ANS*HELAVGFACTOR
      ELSE
        DO J=1,NINITIAL
          IF (POLARIZATIONS(J,0).NE.-1) THEN
C...Cancel helicity-averaging factor when doing helicity amplitudes
            ANS=ANS*BEAMS_HELAVGFACTOR(J)
      
C...VINCIA: Only normalise by Bose factor if doing full colour
      IF (MCMODE.EQ.2) ANS=ANS/POLARIZATIONS(J,0)
          ENDIF
        ENDDO
      ENDIF
      END


      DOUBLE PRECISION FUNCTION dg_dxddg(MCMODE,ICOL,P,NHEL,IC)
C     
C     Generated by MadGraph5_aMC@NLO v. 2.4.2, 2016-06-10
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C     
C     Returns amplitude squared summed/avg over colors
C     for the point with external lines W(0:6,NEXTERNAL)
C     
C     Process: d g > d~ d d g WEIGHTED<=4 @210
C     Process: u g > u~ u u g WEIGHTED<=4 @210
C     Process: s g > s~ s s g WEIGHTED<=4 @210
C     Process: c g > c~ c c g WEIGHTED<=4 @210
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=76)
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=6)
      INTEGER    NWAVEFUNCS, NCOLOR
      PARAMETER (NWAVEFUNCS=20, NCOLOR=12)
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
      DOUBLE PRECISION ZLCSUM, FSLC
      COMPLEX*16 IMAG1
      PARAMETER (IMAG1=(0D0,1D0))
C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION P(0:3,NEXTERNAL)
C...VINCIA: Define MCMODE and ICOL variables
C...  MCMODE = 0 : Leading Colour = LC[icol]
C...  MCMODE = 1 : Vincia Colour  = FC * LC[icol]/sum(LC)
C...  MCMODE = 2 : Full Colour    = FC (-> normal MG mode)
      INTEGER MCMODE, ICOL
      INTEGER NHEL(NEXTERNAL), IC(NEXTERNAL)
C     
C     LOCAL VARIABLES 
C     
      INTEGER I,J
      COMPLEX*16 ZTEMP
      DOUBLE PRECISION DENOM(NCOLOR), CF(NCOLOR,NCOLOR)
      COMPLEX*16 AMP(NGRAPHS), JAMP(NCOLOR)
      COMPLEX*16 W(20,NWAVEFUNCS)
      COMPLEX*16 DUM0,DUM1
      DATA DUM0, DUM1/(0D0, 0D0), (1D0, 0D0)/
C     
C     GLOBAL VARIABLES
C     
      INCLUDE 'coupl.inc'

C     
C     COLOR DATA
C     
      DATA DENOM(1)/3/
      DATA (CF(I,  1),I=  1,  6) /   48,   16,   16,    6,    0,   16/
      DATA (CF(I,  1),I=  7, 12) /   -2,    0,    0,   16,   -2,    0/
C     1 T(2,4,1) T(6,5,3)
      DATA DENOM(2)/3/
      DATA (CF(I,  2),I=  1,  6) /   16,   48,    6,   16,   16,    0/
      DATA (CF(I,  2),I=  7, 12) /    0,   -2,   16,    0,    0,   -2/
C     1 T(2,4,3) T(6,5,1)
      DATA DENOM(3)/3/
      DATA (CF(I,  3),I=  1,  6) /   16,    6,   48,   16,   -2,    0/
      DATA (CF(I,  3),I=  7, 12) /    0,   16,   -2,    0,    0,   16/
C     1 T(2,5,1) T(6,4,3)
      DATA DENOM(4)/3/
      DATA (CF(I,  4),I=  1,  6) /    6,   16,   16,   48,    0,   -2/
      DATA (CF(I,  4),I=  7, 12) /   16,    0,    0,   -2,   16,    0/
C     1 T(2,5,3) T(6,4,1)
      DATA DENOM(5)/3/
      DATA (CF(I,  5),I=  1,  6) /    0,   16,   -2,    0,   48,   16/
      DATA (CF(I,  5),I=  7, 12) /   16,    6,    6,   -2,   -2,   -6/
C     1 T(2,6,4,1) T(5,3)
      DATA DENOM(6)/3/
      DATA (CF(I,  6),I=  1,  6) /   16,    0,    0,   -2,   16,   48/
      DATA (CF(I,  6),I=  7, 12) /    6,   16,   -2,    6,   -6,   -2/
C     1 T(2,6,4,3) T(5,1)
      DATA DENOM(7)/3/
      DATA (CF(I,  7),I=  1,  6) /   -2,    0,    0,   16,   16,    6/
      DATA (CF(I,  7),I=  7, 12) /   48,   16,   -2,   -6,    6,   -2/
C     1 T(2,6,5,1) T(4,3)
      DATA DENOM(8)/3/
      DATA (CF(I,  8),I=  1,  6) /    0,   -2,   16,    0,    6,   16/
      DATA (CF(I,  8),I=  7, 12) /   16,   48,   -6,   -2,   -2,    6/
C     1 T(2,6,5,3) T(4,1)
      DATA DENOM(9)/3/
      DATA (CF(I,  9),I=  1,  6) /    0,   16,   -2,    0,    6,   -2/
      DATA (CF(I,  9),I=  7, 12) /   -2,   -6,   48,   16,   16,    6/
C     1 T(4,1) T(6,2,5,3)
      DATA DENOM(10)/3/
      DATA (CF(I, 10),I=  1,  6) /   16,    0,    0,   -2,   -2,    6/
      DATA (CF(I, 10),I=  7, 12) /   -6,   -2,   16,   48,    6,   16/
C     1 T(4,3) T(6,2,5,1)
      DATA DENOM(11)/3/
      DATA (CF(I, 11),I=  1,  6) /   -2,    0,    0,   16,   -2,   -6/
      DATA (CF(I, 11),I=  7, 12) /    6,   -2,   16,    6,   48,   16/
C     1 T(5,1) T(6,2,4,3)
      DATA DENOM(12)/3/
      DATA (CF(I, 12),I=  1,  6) /    0,   -2,   16,    0,   -6,   -2/
      DATA (CF(I, 12),I=  7, 12) /   -2,    6,    6,   16,   16,   48/
C     1 T(5,3) T(6,2,4,1)
C     ----------
C     BEGIN CODE
C     ----------
      CALL IXXXXX(P(0,1),ZERO,NHEL(1),+1*IC(1),W(1,1))
      CALL VXXXXX(P(0,2),ZERO,NHEL(2),-1*IC(2),W(1,2))
      CALL IXXXXX(P(0,3),ZERO,NHEL(3),-1*IC(3),W(1,3))
      CALL OXXXXX(P(0,4),ZERO,NHEL(4),+1*IC(4),W(1,4))
      CALL OXXXXX(P(0,5),ZERO,NHEL(5),+1*IC(5),W(1,5))
      CALL VXXXXX(P(0,6),ZERO,NHEL(6),+1*IC(6),W(1,6))
      CALL FFV1_2(W(1,1),W(1,2),GC_11,ZERO,ZERO,W(1,7))
      CALL FFV1P0_3(W(1,3),W(1,4),GC_11,ZERO,ZERO,W(1,8))
      CALL FFV1P0_3(W(1,7),W(1,5),GC_11,ZERO,ZERO,W(1,9))
C     Amplitude(s) for diagram number 1
      CALL VVV1_0(W(1,8),W(1,6),W(1,9),GC_10,AMP(1))
      CALL FFV1_2(W(1,7),W(1,6),GC_11,ZERO,ZERO,W(1,10))
C     Amplitude(s) for diagram number 2
      CALL FFV1_0(W(1,10),W(1,5),W(1,8),GC_11,AMP(2))
      CALL FFV1_1(W(1,5),W(1,6),GC_11,ZERO,ZERO,W(1,11))
C     Amplitude(s) for diagram number 3
      CALL FFV1_0(W(1,7),W(1,11),W(1,8),GC_11,AMP(3))
      CALL FFV1P0_3(W(1,3),W(1,5),GC_11,ZERO,ZERO,W(1,12))
      CALL FFV1P0_3(W(1,7),W(1,4),GC_11,ZERO,ZERO,W(1,13))
C     Amplitude(s) for diagram number 4
      CALL VVV1_0(W(1,12),W(1,6),W(1,13),GC_10,AMP(4))
C     Amplitude(s) for diagram number 5
      CALL FFV1_0(W(1,10),W(1,4),W(1,12),GC_11,AMP(5))
      CALL FFV1_1(W(1,4),W(1,6),GC_11,ZERO,ZERO,W(1,10))
C     Amplitude(s) for diagram number 6
      CALL FFV1_0(W(1,7),W(1,10),W(1,12),GC_11,AMP(6))
      CALL FFV1_2(W(1,3),W(1,6),GC_11,ZERO,ZERO,W(1,7))
C     Amplitude(s) for diagram number 7
      CALL FFV1_0(W(1,7),W(1,5),W(1,13),GC_11,AMP(7))
C     Amplitude(s) for diagram number 8
      CALL FFV1_0(W(1,7),W(1,4),W(1,9),GC_11,AMP(8))
C     Amplitude(s) for diagram number 9
      CALL FFV1_0(W(1,3),W(1,10),W(1,9),GC_11,AMP(9))
C     Amplitude(s) for diagram number 10
      CALL FFV1_0(W(1,3),W(1,11),W(1,13),GC_11,AMP(10))
      CALL FFV1P0_3(W(1,1),W(1,4),GC_11,ZERO,ZERO,W(1,13))
      CALL FFV1_2(W(1,3),W(1,2),GC_11,ZERO,ZERO,W(1,9))
      CALL FFV1_1(W(1,5),W(1,13),GC_11,ZERO,ZERO,W(1,14))
C     Amplitude(s) for diagram number 11
      CALL FFV1_0(W(1,9),W(1,14),W(1,6),GC_11,AMP(11))
      CALL VVV1P0_1(W(1,13),W(1,6),GC_10,ZERO,ZERO,W(1,15))
C     Amplitude(s) for diagram number 12
      CALL FFV1_0(W(1,9),W(1,5),W(1,15),GC_11,AMP(12))
C     Amplitude(s) for diagram number 13
      CALL FFV1_0(W(1,9),W(1,11),W(1,13),GC_11,AMP(13))
      CALL FFV1_1(W(1,5),W(1,2),GC_11,ZERO,ZERO,W(1,16))
      CALL FFV1_2(W(1,3),W(1,13),GC_11,ZERO,ZERO,W(1,17))
C     Amplitude(s) for diagram number 14
      CALL FFV1_0(W(1,17),W(1,16),W(1,6),GC_11,AMP(14))
C     Amplitude(s) for diagram number 15
      CALL FFV1_0(W(1,3),W(1,16),W(1,15),GC_11,AMP(15))
C     Amplitude(s) for diagram number 16
      CALL FFV1_0(W(1,7),W(1,16),W(1,13),GC_11,AMP(16))
      CALL VVV1P0_1(W(1,2),W(1,6),GC_10,ZERO,ZERO,W(1,18))
C     Amplitude(s) for diagram number 17
      CALL FFV1_0(W(1,17),W(1,5),W(1,18),GC_11,AMP(17))
C     Amplitude(s) for diagram number 18
      CALL FFV1_0(W(1,3),W(1,14),W(1,18),GC_11,AMP(18))
C     Amplitude(s) for diagram number 19
      CALL VVV1_0(W(1,13),W(1,18),W(1,12),GC_10,AMP(19))
C     Amplitude(s) for diagram number 20
      CALL VVVV1_0(W(1,13),W(1,2),W(1,12),W(1,6),GC_12,AMP(20))
      CALL VVVV3_0(W(1,13),W(1,2),W(1,12),W(1,6),GC_12,AMP(21))
      CALL VVVV4_0(W(1,13),W(1,2),W(1,12),W(1,6),GC_12,AMP(22))
      CALL VVV1P0_1(W(1,13),W(1,2),GC_10,ZERO,ZERO,W(1,19))
C     Amplitude(s) for diagram number 21
      CALL VVV1_0(W(1,12),W(1,6),W(1,19),GC_10,AMP(23))
C     Amplitude(s) for diagram number 22
      CALL VVV1_0(W(1,2),W(1,12),W(1,15),GC_10,AMP(24))
C     Amplitude(s) for diagram number 23
      CALL FFV1_0(W(1,7),W(1,5),W(1,19),GC_11,AMP(25))
C     Amplitude(s) for diagram number 24
      CALL FFV1_0(W(1,7),W(1,14),W(1,2),GC_11,AMP(26))
C     Amplitude(s) for diagram number 25
      CALL FFV1_0(W(1,3),W(1,11),W(1,19),GC_11,AMP(27))
C     Amplitude(s) for diagram number 26
      CALL FFV1_0(W(1,17),W(1,11),W(1,2),GC_11,AMP(28))
      CALL FFV1P0_3(W(1,1),W(1,5),GC_11,ZERO,ZERO,W(1,17))
      CALL FFV1_1(W(1,4),W(1,17),GC_11,ZERO,ZERO,W(1,19))
C     Amplitude(s) for diagram number 27
      CALL FFV1_0(W(1,9),W(1,19),W(1,6),GC_11,AMP(29))
      CALL VVV1P0_1(W(1,17),W(1,6),GC_10,ZERO,ZERO,W(1,14))
C     Amplitude(s) for diagram number 28
      CALL FFV1_0(W(1,9),W(1,4),W(1,14),GC_11,AMP(30))
C     Amplitude(s) for diagram number 29
      CALL FFV1_0(W(1,9),W(1,10),W(1,17),GC_11,AMP(31))
      CALL FFV1_1(W(1,4),W(1,2),GC_11,ZERO,ZERO,W(1,15))
      CALL FFV1_2(W(1,3),W(1,17),GC_11,ZERO,ZERO,W(1,13))
C     Amplitude(s) for diagram number 30
      CALL FFV1_0(W(1,13),W(1,15),W(1,6),GC_11,AMP(32))
C     Amplitude(s) for diagram number 31
      CALL FFV1_0(W(1,3),W(1,15),W(1,14),GC_11,AMP(33))
C     Amplitude(s) for diagram number 32
      CALL FFV1_0(W(1,7),W(1,15),W(1,17),GC_11,AMP(34))
C     Amplitude(s) for diagram number 33
      CALL FFV1_0(W(1,13),W(1,4),W(1,18),GC_11,AMP(35))
C     Amplitude(s) for diagram number 34
      CALL FFV1_0(W(1,3),W(1,19),W(1,18),GC_11,AMP(36))
C     Amplitude(s) for diagram number 35
      CALL VVV1_0(W(1,17),W(1,18),W(1,8),GC_10,AMP(37))
C     Amplitude(s) for diagram number 36
      CALL VVVV1_0(W(1,17),W(1,2),W(1,8),W(1,6),GC_12,AMP(38))
      CALL VVVV3_0(W(1,17),W(1,2),W(1,8),W(1,6),GC_12,AMP(39))
      CALL VVVV4_0(W(1,17),W(1,2),W(1,8),W(1,6),GC_12,AMP(40))
      CALL VVV1P0_1(W(1,17),W(1,2),GC_10,ZERO,ZERO,W(1,20))
C     Amplitude(s) for diagram number 37
      CALL VVV1_0(W(1,8),W(1,6),W(1,20),GC_10,AMP(41))
C     Amplitude(s) for diagram number 38
      CALL VVV1_0(W(1,2),W(1,8),W(1,14),GC_10,AMP(42))
C     Amplitude(s) for diagram number 39
      CALL FFV1_0(W(1,7),W(1,4),W(1,20),GC_11,AMP(43))
C     Amplitude(s) for diagram number 40
      CALL FFV1_0(W(1,7),W(1,19),W(1,2),GC_11,AMP(44))
C     Amplitude(s) for diagram number 41
      CALL FFV1_0(W(1,3),W(1,10),W(1,20),GC_11,AMP(45))
C     Amplitude(s) for diagram number 42
      CALL FFV1_0(W(1,13),W(1,10),W(1,2),GC_11,AMP(46))
      CALL FFV1_2(W(1,1),W(1,6),GC_11,ZERO,ZERO,W(1,13))
      CALL FFV1P0_3(W(1,13),W(1,4),GC_11,ZERO,ZERO,W(1,20))
C     Amplitude(s) for diagram number 43
      CALL FFV1_0(W(1,9),W(1,5),W(1,20),GC_11,AMP(47))
      CALL FFV1P0_3(W(1,13),W(1,5),GC_11,ZERO,ZERO,W(1,19))
C     Amplitude(s) for diagram number 44
      CALL FFV1_0(W(1,9),W(1,4),W(1,19),GC_11,AMP(48))
C     Amplitude(s) for diagram number 45
      CALL FFV1_0(W(1,3),W(1,15),W(1,19),GC_11,AMP(49))
C     Amplitude(s) for diagram number 46
      CALL FFV1_0(W(1,13),W(1,15),W(1,12),GC_11,AMP(50))
C     Amplitude(s) for diagram number 47
      CALL FFV1_0(W(1,3),W(1,16),W(1,20),GC_11,AMP(51))
C     Amplitude(s) for diagram number 48
      CALL FFV1_0(W(1,13),W(1,16),W(1,8),GC_11,AMP(52))
      CALL FFV1_2(W(1,13),W(1,2),GC_11,ZERO,ZERO,W(1,14))
C     Amplitude(s) for diagram number 49
      CALL FFV1_0(W(1,14),W(1,5),W(1,8),GC_11,AMP(53))
C     Amplitude(s) for diagram number 50
      CALL VVV1_0(W(1,2),W(1,8),W(1,19),GC_10,AMP(54))
C     Amplitude(s) for diagram number 51
      CALL FFV1_0(W(1,14),W(1,4),W(1,12),GC_11,AMP(55))
C     Amplitude(s) for diagram number 52
      CALL VVV1_0(W(1,2),W(1,12),W(1,20),GC_10,AMP(56))
      CALL FFV1P0_3(W(1,1),W(1,10),GC_11,ZERO,ZERO,W(1,20))
C     Amplitude(s) for diagram number 53
      CALL FFV1_0(W(1,9),W(1,5),W(1,20),GC_11,AMP(57))
      CALL FFV1P0_3(W(1,1),W(1,11),GC_11,ZERO,ZERO,W(1,14))
C     Amplitude(s) for diagram number 54
      CALL FFV1_0(W(1,9),W(1,4),W(1,14),GC_11,AMP(58))
      CALL FFV1P0_3(W(1,1),W(1,15),GC_11,ZERO,ZERO,W(1,9))
C     Amplitude(s) for diagram number 55
      CALL VVV1_0(W(1,12),W(1,6),W(1,9),GC_10,AMP(59))
      CALL FFV1_2(W(1,1),W(1,12),GC_11,ZERO,ZERO,W(1,19))
C     Amplitude(s) for diagram number 56
      CALL FFV1_0(W(1,19),W(1,15),W(1,6),GC_11,AMP(60))
C     Amplitude(s) for diagram number 57
      CALL FFV1_0(W(1,7),W(1,5),W(1,9),GC_11,AMP(61))
C     Amplitude(s) for diagram number 58
      CALL FFV1_0(W(1,3),W(1,11),W(1,9),GC_11,AMP(62))
C     Amplitude(s) for diagram number 59
      CALL FFV1_0(W(1,3),W(1,15),W(1,14),GC_11,AMP(63))
      CALL FFV1P0_3(W(1,1),W(1,16),GC_11,ZERO,ZERO,W(1,15))
C     Amplitude(s) for diagram number 60
      CALL VVV1_0(W(1,8),W(1,6),W(1,15),GC_10,AMP(64))
      CALL FFV1_2(W(1,1),W(1,8),GC_11,ZERO,ZERO,W(1,9))
C     Amplitude(s) for diagram number 61
      CALL FFV1_0(W(1,9),W(1,16),W(1,6),GC_11,AMP(65))
C     Amplitude(s) for diagram number 62
      CALL FFV1_0(W(1,7),W(1,4),W(1,15),GC_11,AMP(66))
C     Amplitude(s) for diagram number 63
      CALL FFV1_0(W(1,3),W(1,10),W(1,15),GC_11,AMP(67))
C     Amplitude(s) for diagram number 64
      CALL FFV1_0(W(1,3),W(1,16),W(1,20),GC_11,AMP(68))
      CALL FFV1_2(W(1,1),W(1,18),GC_11,ZERO,ZERO,W(1,16))
C     Amplitude(s) for diagram number 65
      CALL FFV1_0(W(1,16),W(1,5),W(1,8),GC_11,AMP(69))
C     Amplitude(s) for diagram number 66
      CALL FFV1_0(W(1,9),W(1,5),W(1,18),GC_11,AMP(70))
C     Amplitude(s) for diagram number 67
      CALL FFV1_0(W(1,16),W(1,4),W(1,12),GC_11,AMP(71))
C     Amplitude(s) for diagram number 68
      CALL FFV1_0(W(1,19),W(1,4),W(1,18),GC_11,AMP(72))
C     Amplitude(s) for diagram number 69
      CALL FFV1_0(W(1,9),W(1,11),W(1,2),GC_11,AMP(73))
C     Amplitude(s) for diagram number 70
      CALL VVV1_0(W(1,2),W(1,8),W(1,14),GC_10,AMP(74))
C     Amplitude(s) for diagram number 71
      CALL FFV1_0(W(1,19),W(1,10),W(1,2),GC_11,AMP(75))
C     Amplitude(s) for diagram number 72
      CALL VVV1_0(W(1,2),W(1,12),W(1,20),GC_10,AMP(76))
      JAMP(1)=+1D0/2D0*(+IMAG1*AMP(1)+AMP(3)+1D0/3D0*AMP(7)+AMP(8)+1D0
     $ /3D0*AMP(10)-IMAG1*AMP(33)+AMP(34)-AMP(38)+AMP(40)-AMP(41)
     $ +AMP(42)+IMAG1*AMP(43)+1D0/3D0*AMP(61)+1D0/3D0*AMP(62)+AMP(63)
     $ +IMAG1*AMP(74))
      JAMP(2)=+1D0/2D0*(-IMAG1*AMP(12)-AMP(13)+AMP(20)-AMP(22)+AMP(23)
     $ -AMP(24)+IMAG1*AMP(27)-AMP(47)-1D0/3D0*AMP(48)-1D0/3D0*AMP(49)
     $ -AMP(50)+IMAG1*AMP(56)-1D0/3D0*AMP(58)+IMAG1*AMP(59)-AMP(62)
     $ -1D0/3D0*AMP(63))
      JAMP(3)=+1D0/2D0*(-IMAG1*AMP(4)-AMP(6)-AMP(7)-1D0/3D0*AMP(8)-1D0
     $ /3D0*AMP(9)+IMAG1*AMP(15)-AMP(16)+AMP(20)-AMP(22)+AMP(23)
     $ -AMP(24)-IMAG1*AMP(25)-1D0/3D0*AMP(66)-1D0/3D0*AMP(67)-AMP(68)
     $ -IMAG1*AMP(76))
      JAMP(4)=+1D0/2D0*(+IMAG1*AMP(30)+AMP(31)-AMP(38)+AMP(40)-AMP(41)
     $ +AMP(42)-IMAG1*AMP(45)+1D0/3D0*AMP(47)+AMP(48)+1D0/3D0*AMP(51)
     $ +AMP(52)-IMAG1*AMP(54)+1D0/3D0*AMP(57)-IMAG1*AMP(64)+AMP(67)
     $ +1D0/3D0*AMP(68))
      JAMP(5)=+1D0/2D0*(+AMP(32)+IMAG1*AMP(33)-IMAG1*AMP(35)+AMP(37)
     $ -AMP(39)-AMP(40)-AMP(42)+AMP(49)+1D0/3D0*AMP(50)+AMP(53)+IMAG1
     $ *AMP(54)+1D0/3D0*AMP(55)+1D0/3D0*AMP(60)-IMAG1*AMP(69)-1D0/3D0
     $ *IMAG1*AMP(71)-1D0/3D0*IMAG1*AMP(72))
      JAMP(6)=+1D0/2D0*(+IMAG1*AMP(18)+AMP(19)-AMP(20)-AMP(21)-AMP(23)
     $ +IMAG1*AMP(25)-AMP(26)-1D0/3D0*AMP(32)-1D0/3D0*AMP(34)+1D0/3D0
     $ *IMAG1*AMP(35)+1D0/3D0*IMAG1*AMP(36)-1D0/3D0*AMP(44)-IMAG1
     $ *AMP(59)-AMP(60)-AMP(61)+IMAG1*AMP(72))
      JAMP(7)=+1D0/2D0*(-AMP(14)-IMAG1*AMP(15)+IMAG1*AMP(17)-AMP(19)
     $ +AMP(21)+AMP(22)+AMP(24)-AMP(51)-1D0/3D0*AMP(52)-1D0/3D0*AMP(53)
     $ -AMP(55)-IMAG1*AMP(56)-1D0/3D0*AMP(65)+1D0/3D0*IMAG1*AMP(69)
     $ +1D0/3D0*IMAG1*AMP(70)+IMAG1*AMP(71))
      JAMP(8)=+1D0/2D0*(+1D0/3D0*AMP(14)+1D0/3D0*AMP(16)-1D0/3D0*IMAG1
     $ *AMP(17)-1D0/3D0*IMAG1*AMP(18)+1D0/3D0*AMP(26)-IMAG1*AMP(36)
     $ -AMP(37)+AMP(38)+AMP(39)+AMP(41)-IMAG1*AMP(43)+AMP(44)+IMAG1
     $ *AMP(64)+AMP(65)+AMP(66)-IMAG1*AMP(70))
      JAMP(9)=+1D0/2D0*(+1D0/3D0*AMP(11)+1D0/3D0*AMP(13)+1D0/3D0*IMAG1
     $ *AMP(17)+1D0/3D0*IMAG1*AMP(18)+1D0/3D0*AMP(28)+AMP(29)-IMAG1
     $ *AMP(30)+IMAG1*AMP(36)+AMP(37)-AMP(39)-AMP(40)-AMP(42)+AMP(58)
     $ +IMAG1*AMP(70)+AMP(73)-IMAG1*AMP(74))
      JAMP(10)=+1D0/2D0*(-1D0/3D0*AMP(2)-1D0/3D0*AMP(3)+IMAG1*AMP(4)
     $ -AMP(5)-AMP(10)-IMAG1*AMP(17)+AMP(19)-AMP(20)-AMP(21)-AMP(23)
     $ -IMAG1*AMP(27)-AMP(28)-1D0/3D0*IMAG1*AMP(69)-1D0/3D0*IMAG1
     $ *AMP(70)-IMAG1*AMP(71)-1D0/3D0*AMP(73))
      JAMP(11)=+1D0/2D0*(-AMP(11)+IMAG1*AMP(12)-IMAG1*AMP(18)-AMP(19)
     $ +AMP(21)+AMP(22)+AMP(24)-1D0/3D0*AMP(29)-1D0/3D0*AMP(31)-1D0
     $ /3D0*IMAG1*AMP(35)-1D0/3D0*IMAG1*AMP(36)-1D0/3D0*AMP(46)-AMP(57)
     $ -IMAG1*AMP(72)-AMP(75)+IMAG1*AMP(76))
      JAMP(12)=+1D0/2D0*(-IMAG1*AMP(1)+AMP(2)+1D0/3D0*AMP(5)+1D0/3D0
     $ *AMP(6)+AMP(9)+IMAG1*AMP(35)-AMP(37)+AMP(38)+AMP(39)+AMP(41)
     $ +IMAG1*AMP(45)+AMP(46)+IMAG1*AMP(69)+1D0/3D0*IMAG1*AMP(71)+1D0
     $ /3D0*IMAG1*AMP(72)+1D0/3D0*AMP(75))

C...VINCIA: Leading Color for Diagonal Entry ICOL
      dg_dxddg = CF(ICOL,ICOL)*JAMP(ICOL)
     &         *DCONJG(JAMP(ICOL))/DENOM(ICOL)
C...VINCIA: Absorb subleading color proportional to FSLC = LC/Sum(LC)
      IF (MCMODE.EQ.0) RETURN
      IF (MCMODE.EQ.1.AND.dg_dxddg.LE.ZERO) RETURN
        ZLCSUM = 0D0
        DO I = 1, NCOLOR
          ZLCSUM = ZLCSUM + CF(I,I)*JAMP(I)*DCONJG(JAMP(I))/DENOM(I)
        ENDDO
C...VINCIA: MCMODE = 2 returns full colour-summed ME
        IF (MCMODE.EQ.2) dg_dxddg = ZLCSUM
C...VINCIA: Fraction of subleading color to absorb into this permutation
        FSLC = dg_dxddg/ZLCSUM
C...VINCIA: Sum over subleading contributions multiplied by FSLC
      DO I = 1, NCOLOR
        ZTEMP = (0.D0,0.D0)
        DO J = 1, NCOLOR
          IF (I.NE.J) ZTEMP = ZTEMP + CF(J,I)*JAMP(J)
        ENDDO
        dg_dxddg = dg_dxddg+FSLC*ZTEMP*DCONJG(JAMP(I))/DENOM(I)
      ENDDO

      END

      SUBROUTINE GETdg_dxddg(MCMODE,ICOL,P, ALPHAS, NHEL ,ANS)
      IMPLICIT NONE
C     
C     CONSTANT
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=6)
C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION ANS, P(0:3,NEXTERNAL)
C...VINCIA: Define MCMODE and ICOL variables
C...  MCMODE = 0 : Leading Colour = LC[icol]
C...  MCMODE = 1 : Vincia Colour  = FC * LC[icol]/sum(LC)
C...  MCMODE = 2 : Full Colour    = FC (-> normal MG mode)
      INTEGER MCMODE, ICOL
      INTEGER NHEL
      DOUBLE PRECISION ALPHAS
      DOUBLE PRECISION PI
CF2PY INTENT(OUT) :: ANS
CF2PY INTENT(IN) :: NHEL
CF2PY INTENT(IN) :: P(0:3,NEXTERNAL)
CF2PY INTENT(IN) :: ALPHAS
C     ROUTINE FOR F2PY to read the benchmark point.    
C     the include file with the values of the parameters and masses 
      INCLUDE 'coupl.inc'

      PI = 3.141592653589793D0
      G = 2* DSQRT(ALPHAS*PI)
C...VINCIA: only static MG couplings are interfaced
C      CALL UPDATE_AS_PARAM()
      IF (NHEL.NE.0) THEN
        CALL SHELdg_dxddg(MCMODE,ICOL,P, NHEL, ANS)
      ELSE
        CALL Sdg_dxddg(MCMODE,ICOL,P, ANS)
      ENDIF
      RETURN
      END


