C...dxg_uxdxdxdu.f is a part of the VINCIA event generator.
C...This file was generated by MADGRAPH 5
C...Modified by VINCIA Thu  8 Jun 2017 15:38:03 CEST
C...VINCIA is licenced under the GNU GPL version 2.
C...Copyright (C) 2018 Peter Skands
C...Please respect the work of the MadGraph authors by
C...citing MadGraph 5 when this part of VINCIA is used.
C...See: https://arxiv.org/abs/1106.0522
 
      SUBROUTINE SHELdxg_uxdxdxdu(MCMODE,ICOL,P,HEL,ANS)
      IMPLICIT NONE
C     
C     CONSTANT
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=7)
      INTEGER                 NCOMB
      PARAMETER (             NCOMB=128)
CF2PY INTENT(OUT) :: ANS
CF2PY INTENT(IN) :: HEL
CF2PY INTENT(IN) :: P(0:3,NEXTERNAL)

C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION ANS, P(0:3,NEXTERNAL)
C...VINCIA: Define MCMODE and ICOL variables
C...  MCMODE = 0 : Leading Colour = LC[icol]
C...  MCMODE = 1 : Vincia Colour  = FC * LC[icol]/sum(LC)
C...  MCMODE = 2 : Full Colour    = FC (-> normal MG mode)
      INTEGER MCMODE, ICOL
      INTEGER HEL
C     
C     GLOBAL VARIABLES
C     
      INTEGER USERHEL
      COMMON/HELUSERCHOICE/USERHEL
C     ----------
C     BEGIN CODE
C     ----------
      USERHEL=HEL
      CALL Sdxg_uxdxdxdu(MCMODE,ICOL,P,ANS)
      USERHEL=-1

      END

      SUBROUTINE Sdxg_uxdxdxdu(MCMODE,ICOL,P,ANS)
C     
C     Generated by MadGraph5_aMC@NLO v. 2.4.2, 2016-06-10
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C     
C     MadGraph5_aMC@NLO StandAlone Version
C     
C     Returns amplitude squared summed/avg over colors
C     and helicities
C     for the point in phase space P(0:3,NEXTERNAL)
C     
C     Process: d~ g > u~ d~ d~ d u WEIGHTED<=5 @800
C     Process: d~ g > s~ d~ d~ d s WEIGHTED<=5 @800
C     Process: d~ g > c~ d~ d~ d c WEIGHTED<=5 @800
C     Process: u~ g > s~ u~ u~ u s WEIGHTED<=5 @800
C     Process: u~ g > c~ u~ u~ u c WEIGHTED<=5 @800
C     Process: s~ g > c~ s~ s~ s c WEIGHTED<=5 @800
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=7)
      INTEGER    NINITIAL
      PARAMETER (NINITIAL=2)
      INTEGER NPOLENTRIES
      PARAMETER (NPOLENTRIES=(NEXTERNAL+1)*6)
      INTEGER                 NCOMB
      PARAMETER (             NCOMB=128)
      INTEGER HELAVGFACTOR
      PARAMETER (HELAVGFACTOR=4)
C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION ANS, P(0:3,NEXTERNAL)
C...VINCIA: Define MCMODE and ICOL variables
C...  MCMODE = 0 : Leading Colour = LC[icol]
C...  MCMODE = 1 : Vincia Colour  = FC * LC[icol]/sum(LC)
C...  MCMODE = 2 : Full Colour    = FC (-> normal MG mode)
      INTEGER MCMODE, ICOL
CF2PY INTENT(OUT) :: ANS
CF2PY INTENT(IN) :: P(0:3,NEXTERNAL)
C     
C     LOCAL VARIABLES 
C     
      INTEGER NHEL(NEXTERNAL,NCOMB),NTRY
      DOUBLE PRECISION T
      DOUBLE PRECISION dxg_uxdxdxdu
      INTEGER IHEL,IDEN, I, J
C     For a 1>N process, them BEAMTWO_HELAVGFACTOR would be set to 1.
      INTEGER BEAMS_HELAVGFACTOR(2)
      DATA (BEAMS_HELAVGFACTOR(I),I=1,2)/2,2/
      INTEGER JC(NEXTERNAL)
      LOGICAL GOODHEL(NCOMB)
      DATA NTRY/0/
      DATA GOODHEL/NCOMB*.FALSE./

C     
C     GLOBAL VARIABLES
C     
      INTEGER USERHEL
      COMMON/HELUSERCHOICE/USERHEL
C...VINCIA: USERHEL is initialised by MG5interface
C      DATA USERHEL/-1/

      DATA (NHEL(I,   1),I=1,7) /-1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(I,   2),I=1,7) /-1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(I,   3),I=1,7) /-1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(I,   4),I=1,7) /-1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(I,   5),I=1,7) /-1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(I,   6),I=1,7) /-1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(I,   7),I=1,7) /-1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(I,   8),I=1,7) /-1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(I,   9),I=1,7) /-1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(I,  10),I=1,7) /-1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(I,  11),I=1,7) /-1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(I,  12),I=1,7) /-1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(I,  13),I=1,7) /-1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(I,  14),I=1,7) /-1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(I,  15),I=1,7) /-1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(I,  16),I=1,7) /-1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(I,  17),I=1,7) /-1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(I,  18),I=1,7) /-1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(I,  19),I=1,7) /-1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(I,  20),I=1,7) /-1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(I,  21),I=1,7) /-1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(I,  22),I=1,7) /-1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(I,  23),I=1,7) /-1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(I,  24),I=1,7) /-1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(I,  25),I=1,7) /-1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(I,  26),I=1,7) /-1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(I,  27),I=1,7) /-1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(I,  28),I=1,7) /-1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(I,  29),I=1,7) /-1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(I,  30),I=1,7) /-1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(I,  31),I=1,7) /-1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(I,  32),I=1,7) /-1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(I,  33),I=1,7) /-1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(I,  34),I=1,7) /-1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(I,  35),I=1,7) /-1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(I,  36),I=1,7) /-1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(I,  37),I=1,7) /-1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(I,  38),I=1,7) /-1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(I,  39),I=1,7) /-1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(I,  40),I=1,7) /-1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(I,  41),I=1,7) /-1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(I,  42),I=1,7) /-1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(I,  43),I=1,7) /-1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(I,  44),I=1,7) /-1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(I,  45),I=1,7) /-1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(I,  46),I=1,7) /-1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(I,  47),I=1,7) /-1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(I,  48),I=1,7) /-1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(I,  49),I=1,7) /-1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(I,  50),I=1,7) /-1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(I,  51),I=1,7) /-1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(I,  52),I=1,7) /-1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(I,  53),I=1,7) /-1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(I,  54),I=1,7) /-1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(I,  55),I=1,7) /-1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(I,  56),I=1,7) /-1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(I,  57),I=1,7) /-1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(I,  58),I=1,7) /-1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(I,  59),I=1,7) /-1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(I,  60),I=1,7) /-1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(I,  61),I=1,7) /-1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(I,  62),I=1,7) /-1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(I,  63),I=1,7) /-1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(I,  64),I=1,7) /-1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(I,  65),I=1,7) / 1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(I,  66),I=1,7) / 1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(I,  67),I=1,7) / 1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(I,  68),I=1,7) / 1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(I,  69),I=1,7) / 1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(I,  70),I=1,7) / 1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(I,  71),I=1,7) / 1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(I,  72),I=1,7) / 1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(I,  73),I=1,7) / 1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(I,  74),I=1,7) / 1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(I,  75),I=1,7) / 1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(I,  76),I=1,7) / 1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(I,  77),I=1,7) / 1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(I,  78),I=1,7) / 1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(I,  79),I=1,7) / 1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(I,  80),I=1,7) / 1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(I,  81),I=1,7) / 1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(I,  82),I=1,7) / 1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(I,  83),I=1,7) / 1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(I,  84),I=1,7) / 1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(I,  85),I=1,7) / 1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(I,  86),I=1,7) / 1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(I,  87),I=1,7) / 1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(I,  88),I=1,7) / 1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(I,  89),I=1,7) / 1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(I,  90),I=1,7) / 1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(I,  91),I=1,7) / 1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(I,  92),I=1,7) / 1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(I,  93),I=1,7) / 1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(I,  94),I=1,7) / 1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(I,  95),I=1,7) / 1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(I,  96),I=1,7) / 1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(I,  97),I=1,7) / 1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(I,  98),I=1,7) / 1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(I,  99),I=1,7) / 1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(I, 100),I=1,7) / 1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(I, 101),I=1,7) / 1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(I, 102),I=1,7) / 1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(I, 103),I=1,7) / 1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(I, 104),I=1,7) / 1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(I, 105),I=1,7) / 1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(I, 106),I=1,7) / 1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(I, 107),I=1,7) / 1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(I, 108),I=1,7) / 1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(I, 109),I=1,7) / 1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(I, 110),I=1,7) / 1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(I, 111),I=1,7) / 1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(I, 112),I=1,7) / 1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(I, 113),I=1,7) / 1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(I, 114),I=1,7) / 1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(I, 115),I=1,7) / 1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(I, 116),I=1,7) / 1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(I, 117),I=1,7) / 1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(I, 118),I=1,7) / 1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(I, 119),I=1,7) / 1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(I, 120),I=1,7) / 1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(I, 121),I=1,7) / 1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(I, 122),I=1,7) / 1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(I, 123),I=1,7) / 1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(I, 124),I=1,7) / 1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(I, 125),I=1,7) / 1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(I, 126),I=1,7) / 1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(I, 127),I=1,7) / 1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(I, 128),I=1,7) / 1, 1,-1,-1,-1, 1, 1/
      DATA IDEN/192/

      INTEGER POLARIZATIONS(0:NEXTERNAL,0:5)
      DATA ((POLARIZATIONS(I,J),I=0,NEXTERNAL),J=0,5)/NPOLENTRIES*-1/
C...Vincia: BORN_BEAM_POL not used (POLARIZATIONS local and = -1)
C      COMMON/BORN_BEAM_POL/POLARIZATIONS
C     
C     FUNCTIONS
C     
C...Vincia conversion hardcodes for IS_BORN_HEL_SELECTED = .TRUE.
C      LOGICAL IS_BORN_HEL_SELECTED

C     ----------
C     BEGIN CODE
C     ----------
      IF(USERHEL.EQ.-1) NTRY=0
C...(VINCIA: no NTRY optimisation)
      DO IHEL=1,NEXTERNAL
        JC(IHEL) = +1
      ENDDO
C     When spin-2 particles are involved, the Helicity filtering is
C      dangerous for the 2->1 topology.
C     This is because depending on the MC setup the initial PS points
C      have back-to-back initial states
C     for which some of the spin-2 helicity configurations are zero.
C      But they are no longer zero
C     if the point is boosted on the z-axis. Remember that HELAS
C      helicity amplitudes are no longer
C     lorentz invariant with expternal spin-2 particles (only the
C      helicity sum is).
C     For this reason, we simply remove the filterin when there is
C      only three external particles.
      IF (NEXTERNAL.LE.3) THEN
        DO IHEL=1,NCOMB
          GOODHEL(IHEL)=.TRUE.
        ENDDO
      ENDIF
      ANS = 0D0
      DO IHEL=1,NCOMB
        IF (USERHEL.EQ.-1.OR.USERHEL.EQ.IHEL) THEN
          IF (GOODHEL(IHEL) .OR. NTRY .LT. 20.OR.USERHEL.NE.-1) THEN
            IF(NTRY.GE.2.AND.POLARIZATIONS(0,0).NE.
     $       -1.AND.(.FALSE.)) THEN
              CYCLE
            ENDIF
            T=dxg_uxdxdxdu(MCMODE,ICOL,P ,NHEL(1,IHEL),JC(1))
            IF(POLARIZATIONS(0,0).EQ.-1.OR..TRUE.)
     $        THEN
              ANS=ANS+T
            ENDIF
            IF (T .NE. 0D0 .AND. .NOT.    GOODHEL(IHEL)) THEN
              GOODHEL(IHEL)=.TRUE.
            ENDIF
          ENDIF
        ENDIF
      ENDDO

C...VINCIA: Only normalise by Bose factor if doing full colour
      IF (MCMODE.EQ.2) ANS=ANS/DBLE(IDEN)
      IF(USERHEL.NE.-1) THEN
C...Cancel helicity-averaging factor when doing helicity amplitudes
        ANS=ANS*HELAVGFACTOR
      ELSE
        DO J=1,NINITIAL
          IF (POLARIZATIONS(J,0).NE.-1) THEN
C...Cancel helicity-averaging factor when doing helicity amplitudes
            ANS=ANS*BEAMS_HELAVGFACTOR(J)
      
C...VINCIA: Only normalise by Bose factor if doing full colour
      IF (MCMODE.EQ.2) ANS=ANS/POLARIZATIONS(J,0)
          ENDIF
        ENDDO
      ENDIF
      END


      DOUBLE PRECISION FUNCTION dxg_uxdxdxdu(MCMODE,ICOL,P,NHEL,IC)
C     
C     Generated by MadGraph5_aMC@NLO v. 2.4.2, 2016-06-10
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C     
C     Returns amplitude squared summed/avg over colors
C     for the point with external lines W(0:6,NEXTERNAL)
C     
C     Process: d~ g > u~ d~ d~ d u WEIGHTED<=5 @800
C     Process: d~ g > s~ d~ d~ d s WEIGHTED<=5 @800
C     Process: d~ g > c~ d~ d~ d c WEIGHTED<=5 @800
C     Process: u~ g > s~ u~ u~ u s WEIGHTED<=5 @800
C     Process: u~ g > c~ u~ u~ u c WEIGHTED<=5 @800
C     Process: s~ g > c~ s~ s~ s c WEIGHTED<=5 @800
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=132)
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=7)
      INTEGER    NWAVEFUNCS, NCOLOR
      PARAMETER (NWAVEFUNCS=37, NCOLOR=18)
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
      DOUBLE PRECISION ZLCSUM, FSLC
      COMPLEX*16 IMAG1
      PARAMETER (IMAG1=(0D0,1D0))
C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION P(0:3,NEXTERNAL)
C...VINCIA: Define MCMODE and ICOL variables
C...  MCMODE = 0 : Leading Colour = LC[icol]
C...  MCMODE = 1 : Vincia Colour  = FC * LC[icol]/sum(LC)
C...  MCMODE = 2 : Full Colour    = FC (-> normal MG mode)
      INTEGER MCMODE, ICOL
      INTEGER NHEL(NEXTERNAL), IC(NEXTERNAL)
C     
C     LOCAL VARIABLES 
C     
      INTEGER I,J
      COMPLEX*16 ZTEMP
      DOUBLE PRECISION DENOM(NCOLOR), CF(NCOLOR,NCOLOR)
      COMPLEX*16 AMP(NGRAPHS), JAMP(NCOLOR)
      COMPLEX*16 W(20,NWAVEFUNCS)
      COMPLEX*16 DUM0,DUM1
      DATA DUM0, DUM1/(0D0, 0D0), (1D0, 0D0)/
C     
C     GLOBAL VARIABLES
C     
      INCLUDE 'coupl.inc'

C     
C     COLOR DATA
C     
      DATA DENOM(1)/1/
      DATA (CF(I,  1),I=  1,  6) /   36,   12,   12,    0,   12,    4/
      DATA (CF(I,  1),I=  7, 12) /    4,    0,    4,   12,    0,    4/
      DATA (CF(I,  1),I= 13, 18) /    0,    0,   12,    4,    4,    0/
C     1 T(1,3) T(2,6,4) T(7,5)
      DATA DENOM(2)/1/
      DATA (CF(I,  2),I=  1,  6) /   12,   36,    0,   12,    4,   12/
      DATA (CF(I,  2),I=  7, 12) /    0,    4,   12,    4,    4,    0/
      DATA (CF(I,  2),I= 13, 18) /    0,    0,    4,    0,   12,    4/
C     1 T(1,3) T(2,6,5) T(7,4)
      DATA DENOM(3)/1/
      DATA (CF(I,  3),I=  1,  6) /   12,    0,   36,   12,    4,    0/
      DATA (CF(I,  3),I=  7, 12) /   12,    4,    0,    4,    4,   12/
      DATA (CF(I,  3),I= 13, 18) /    0,    0,    4,   12,    0,    4/
C     1 T(1,3) T(2,7,4) T(6,5)
      DATA DENOM(4)/1/
      DATA (CF(I,  4),I=  1,  6) /    0,   12,   12,   36,    0,    4/
      DATA (CF(I,  4),I=  7, 12) /    4,   12,    4,    0,   12,    4/
      DATA (CF(I,  4),I= 13, 18) /    0,    0,    0,    4,    4,   12/
C     1 T(1,3) T(2,7,5) T(6,4)
      DATA DENOM(5)/1/
      DATA (CF(I,  5),I=  1,  6) /   12,    4,    4,    0,   36,   12/
      DATA (CF(I,  5),I=  7, 12) /   12,    0,   12,    4,    4,    0/
      DATA (CF(I,  5),I= 13, 18) /   12,    4,    0,    0,    0,    4/
C     1 T(1,4) T(2,6,3) T(7,5)
      DATA DENOM(6)/1/
      DATA (CF(I,  6),I=  1,  6) /    4,   12,    0,    4,   12,   36/
      DATA (CF(I,  6),I=  7, 12) /    0,   12,    4,   12,    0,    4/
      DATA (CF(I,  6),I= 13, 18) /    4,    0,    0,    0,    4,   12/
C     1 T(1,4) T(2,6,5) T(7,3)
      DATA DENOM(7)/1/
      DATA (CF(I,  7),I=  1,  6) /    4,    0,   12,    4,   12,    0/
      DATA (CF(I,  7),I=  7, 12) /   36,   12,    4,    0,   12,    4/
      DATA (CF(I,  7),I= 13, 18) /    4,   12,    0,    0,    4,    0/
C     1 T(1,4) T(2,7,3) T(6,5)
      DATA DENOM(8)/1/
      DATA (CF(I,  8),I=  1,  6) /    0,    4,    4,   12,    0,   12/
      DATA (CF(I,  8),I=  7, 12) /   12,   36,    0,    4,    4,   12/
      DATA (CF(I,  8),I= 13, 18) /    0,    4,    0,    0,   12,    4/
C     1 T(1,4) T(2,7,5) T(6,3)
      DATA DENOM(9)/1/
      DATA (CF(I,  9),I=  1,  6) /    4,   12,    0,    4,   12,    4/
      DATA (CF(I,  9),I=  7, 12) /    4,    0,   36,   12,   12,    0/
      DATA (CF(I,  9),I= 13, 18) /    4,   12,    0,    4,    0,    0/
C     1 T(1,5) T(2,6,3) T(7,4)
      DATA DENOM(10)/1/
      DATA (CF(I, 10),I=  1,  6) /   12,    4,    4,    0,    4,   12/
      DATA (CF(I, 10),I=  7, 12) /    0,    4,   12,   36,    0,   12/
      DATA (CF(I, 10),I= 13, 18) /    0,    4,    4,   12,    0,    0/
C     1 T(1,5) T(2,6,4) T(7,3)
      DATA DENOM(11)/1/
      DATA (CF(I, 11),I=  1,  6) /    0,    4,    4,   12,    4,    0/
      DATA (CF(I, 11),I=  7, 12) /   12,    4,   12,    0,   36,   12/
      DATA (CF(I, 11),I= 13, 18) /   12,    4,    4,    0,    0,    0/
C     1 T(1,5) T(2,7,3) T(6,4)
      DATA DENOM(12)/1/
      DATA (CF(I, 12),I=  1,  6) /    4,    0,   12,    4,    0,    4/
      DATA (CF(I, 12),I=  7, 12) /    4,   12,    0,   12,   12,   36/
      DATA (CF(I, 12),I= 13, 18) /    4,    0,   12,    4,    0,    0/
C     1 T(1,5) T(2,7,4) T(6,3)
      DATA DENOM(13)/1/
      DATA (CF(I, 13),I=  1,  6) /    0,    0,    0,    0,   12,    4/
      DATA (CF(I, 13),I=  7, 12) /    4,    0,    4,    0,   12,    4/
      DATA (CF(I, 13),I= 13, 18) /   36,   12,   12,    4,    4,   12/
C     1 T(2,1,3) T(6,4) T(7,5)
      DATA DENOM(14)/1/
      DATA (CF(I, 14),I=  1,  6) /    0,    0,    0,    0,    4,    0/
      DATA (CF(I, 14),I=  7, 12) /   12,    4,   12,    4,    4,    0/
      DATA (CF(I, 14),I= 13, 18) /   12,   36,    4,   12,   12,    4/
C     1 T(2,1,3) T(6,5) T(7,4)
      DATA DENOM(15)/1/
      DATA (CF(I, 15),I=  1,  6) /   12,    4,    4,    0,    0,    0/
      DATA (CF(I, 15),I=  7, 12) /    0,    0,    0,    4,    4,   12/
      DATA (CF(I, 15),I= 13, 18) /   12,    4,   36,   12,   12,    4/
C     1 T(2,1,4) T(6,3) T(7,5)
      DATA DENOM(16)/1/
      DATA (CF(I, 16),I=  1,  6) /    4,    0,   12,    4,    0,    0/
      DATA (CF(I, 16),I=  7, 12) /    0,    0,    4,   12,    0,    4/
      DATA (CF(I, 16),I= 13, 18) /    4,   12,   12,   36,    4,   12/
C     1 T(2,1,4) T(6,5) T(7,3)
      DATA DENOM(17)/1/
      DATA (CF(I, 17),I=  1,  6) /    4,   12,    0,    4,    0,    4/
      DATA (CF(I, 17),I=  7, 12) /    4,   12,    0,    0,    0,    0/
      DATA (CF(I, 17),I= 13, 18) /    4,   12,   12,    4,   36,   12/
C     1 T(2,1,5) T(6,3) T(7,4)
      DATA DENOM(18)/1/
      DATA (CF(I, 18),I=  1,  6) /    0,    4,    4,   12,    4,   12/
      DATA (CF(I, 18),I=  7, 12) /    0,    4,    0,    0,    0,    0/
      DATA (CF(I, 18),I= 13, 18) /   12,    4,    4,   12,   12,   36/
C     1 T(2,1,5) T(6,4) T(7,3)
C     ----------
C     BEGIN CODE
C     ----------
      CALL OXXXXX(P(0,1),ZERO,NHEL(1),-1*IC(1),W(1,1))
      CALL VXXXXX(P(0,2),ZERO,NHEL(2),-1*IC(2),W(1,2))
      CALL IXXXXX(P(0,3),ZERO,NHEL(3),-1*IC(3),W(1,3))
      CALL IXXXXX(P(0,4),ZERO,NHEL(4),-1*IC(4),W(1,4))
      CALL IXXXXX(P(0,5),ZERO,NHEL(5),-1*IC(5),W(1,5))
      CALL OXXXXX(P(0,6),ZERO,NHEL(6),+1*IC(6),W(1,6))
      CALL OXXXXX(P(0,7),ZERO,NHEL(7),+1*IC(7),W(1,7))
      CALL FFV1_1(W(1,1),W(1,2),GC_11,ZERO,ZERO,W(1,8))
      CALL FFV1P0_3(W(1,3),W(1,7),GC_11,ZERO,ZERO,W(1,9))
      CALL FFV1P0_3(W(1,4),W(1,8),GC_11,ZERO,ZERO,W(1,10))
      CALL FFV1_2(W(1,5),W(1,9),GC_11,ZERO,ZERO,W(1,11))
C     Amplitude(s) for diagram number 1
      CALL FFV1_0(W(1,11),W(1,6),W(1,10),GC_11,AMP(1))
      CALL FFV1_1(W(1,6),W(1,9),GC_11,ZERO,ZERO,W(1,12))
C     Amplitude(s) for diagram number 2
      CALL FFV1_0(W(1,5),W(1,12),W(1,10),GC_11,AMP(2))
      CALL FFV1P0_3(W(1,5),W(1,8),GC_11,ZERO,ZERO,W(1,13))
      CALL FFV1_2(W(1,4),W(1,9),GC_11,ZERO,ZERO,W(1,14))
C     Amplitude(s) for diagram number 3
      CALL FFV1_0(W(1,14),W(1,6),W(1,13),GC_11,AMP(3))
C     Amplitude(s) for diagram number 4
      CALL FFV1_0(W(1,4),W(1,12),W(1,13),GC_11,AMP(4))
      CALL FFV1P0_3(W(1,4),W(1,6),GC_11,ZERO,ZERO,W(1,15))
      CALL FFV1_1(W(1,8),W(1,9),GC_11,ZERO,ZERO,W(1,16))
C     Amplitude(s) for diagram number 5
      CALL FFV1_0(W(1,5),W(1,16),W(1,15),GC_11,AMP(5))
      CALL FFV1_1(W(1,8),W(1,15),GC_11,ZERO,ZERO,W(1,17))
C     Amplitude(s) for diagram number 6
      CALL FFV1_0(W(1,5),W(1,17),W(1,9),GC_11,AMP(6))
C     Amplitude(s) for diagram number 7
      CALL VVV1_0(W(1,9),W(1,15),W(1,13),GC_10,AMP(7))
      CALL FFV1P0_3(W(1,5),W(1,6),GC_11,ZERO,ZERO,W(1,17))
C     Amplitude(s) for diagram number 8
      CALL FFV1_0(W(1,4),W(1,16),W(1,17),GC_11,AMP(8))
C     Amplitude(s) for diagram number 9
      CALL VVV1_0(W(1,9),W(1,17),W(1,10),GC_10,AMP(9))
      CALL FFV1_1(W(1,8),W(1,17),GC_11,ZERO,ZERO,W(1,16))
C     Amplitude(s) for diagram number 10
      CALL FFV1_0(W(1,4),W(1,16),W(1,9),GC_11,AMP(10))
      CALL FFV1_2(W(1,3),W(1,15),GC_11,ZERO,ZERO,W(1,16))
C     Amplitude(s) for diagram number 11
      CALL FFV1_0(W(1,16),W(1,7),W(1,13),GC_11,AMP(11))
      CALL FFV1_1(W(1,7),W(1,15),GC_11,ZERO,ZERO,W(1,8))
C     Amplitude(s) for diagram number 12
      CALL FFV1_0(W(1,3),W(1,8),W(1,13),GC_11,AMP(12))
      CALL FFV1_2(W(1,3),W(1,17),GC_11,ZERO,ZERO,W(1,13))
C     Amplitude(s) for diagram number 13
      CALL FFV1_0(W(1,13),W(1,7),W(1,10),GC_11,AMP(13))
      CALL FFV1_1(W(1,7),W(1,17),GC_11,ZERO,ZERO,W(1,18))
C     Amplitude(s) for diagram number 14
      CALL FFV1_0(W(1,3),W(1,18),W(1,10),GC_11,AMP(14))
      CALL FFV1P0_3(W(1,4),W(1,1),GC_11,ZERO,ZERO,W(1,10))
      CALL FFV1_2(W(1,3),W(1,2),GC_11,ZERO,ZERO,W(1,19))
      CALL FFV1_2(W(1,5),W(1,10),GC_11,ZERO,ZERO,W(1,20))
      CALL FFV1P0_3(W(1,19),W(1,7),GC_11,ZERO,ZERO,W(1,21))
C     Amplitude(s) for diagram number 15
      CALL FFV1_0(W(1,20),W(1,6),W(1,21),GC_11,AMP(15))
      CALL FFV1_1(W(1,6),W(1,10),GC_11,ZERO,ZERO,W(1,22))
C     Amplitude(s) for diagram number 16
      CALL FFV1_0(W(1,5),W(1,22),W(1,21),GC_11,AMP(16))
      CALL FFV1_2(W(1,19),W(1,10),GC_11,ZERO,ZERO,W(1,23))
C     Amplitude(s) for diagram number 17
      CALL FFV1_0(W(1,23),W(1,7),W(1,17),GC_11,AMP(17))
      CALL VVV1P0_1(W(1,10),W(1,17),GC_10,ZERO,ZERO,W(1,23))
C     Amplitude(s) for diagram number 18
      CALL FFV1_0(W(1,19),W(1,7),W(1,23),GC_11,AMP(18))
      CALL FFV1_1(W(1,7),W(1,10),GC_11,ZERO,ZERO,W(1,24))
C     Amplitude(s) for diagram number 19
      CALL FFV1_0(W(1,19),W(1,24),W(1,17),GC_11,AMP(19))
      CALL FFV1_2(W(1,5),W(1,2),GC_11,ZERO,ZERO,W(1,25))
      CALL FFV1_2(W(1,3),W(1,10),GC_11,ZERO,ZERO,W(1,26))
      CALL FFV1P0_3(W(1,25),W(1,6),GC_11,ZERO,ZERO,W(1,27))
C     Amplitude(s) for diagram number 20
      CALL FFV1_0(W(1,26),W(1,7),W(1,27),GC_11,AMP(20))
C     Amplitude(s) for diagram number 21
      CALL FFV1_0(W(1,3),W(1,24),W(1,27),GC_11,AMP(21))
      CALL FFV1_2(W(1,25),W(1,10),GC_11,ZERO,ZERO,W(1,28))
C     Amplitude(s) for diagram number 22
      CALL FFV1_0(W(1,28),W(1,6),W(1,9),GC_11,AMP(22))
      CALL VVV1P0_1(W(1,10),W(1,9),GC_10,ZERO,ZERO,W(1,28))
C     Amplitude(s) for diagram number 23
      CALL FFV1_0(W(1,25),W(1,6),W(1,28),GC_11,AMP(23))
C     Amplitude(s) for diagram number 24
      CALL FFV1_0(W(1,25),W(1,22),W(1,9),GC_11,AMP(24))
      CALL FFV1_1(W(1,6),W(1,2),GC_11,ZERO,ZERO,W(1,29))
      CALL FFV1P0_3(W(1,5),W(1,29),GC_11,ZERO,ZERO,W(1,30))
C     Amplitude(s) for diagram number 25
      CALL FFV1_0(W(1,26),W(1,7),W(1,30),GC_11,AMP(25))
C     Amplitude(s) for diagram number 26
      CALL FFV1_0(W(1,3),W(1,24),W(1,30),GC_11,AMP(26))
      CALL FFV1_1(W(1,29),W(1,10),GC_11,ZERO,ZERO,W(1,31))
C     Amplitude(s) for diagram number 27
      CALL FFV1_0(W(1,5),W(1,31),W(1,9),GC_11,AMP(27))
C     Amplitude(s) for diagram number 28
      CALL FFV1_0(W(1,5),W(1,29),W(1,28),GC_11,AMP(28))
C     Amplitude(s) for diagram number 29
      CALL FFV1_0(W(1,20),W(1,29),W(1,9),GC_11,AMP(29))
      CALL FFV1_1(W(1,7),W(1,2),GC_11,ZERO,ZERO,W(1,31))
      CALL FFV1P0_3(W(1,3),W(1,31),GC_11,ZERO,ZERO,W(1,32))
C     Amplitude(s) for diagram number 30
      CALL FFV1_0(W(1,20),W(1,6),W(1,32),GC_11,AMP(30))
C     Amplitude(s) for diagram number 31
      CALL FFV1_0(W(1,5),W(1,22),W(1,32),GC_11,AMP(31))
      CALL FFV1_1(W(1,31),W(1,10),GC_11,ZERO,ZERO,W(1,33))
C     Amplitude(s) for diagram number 32
      CALL FFV1_0(W(1,3),W(1,33),W(1,17),GC_11,AMP(32))
C     Amplitude(s) for diagram number 33
      CALL FFV1_0(W(1,26),W(1,31),W(1,17),GC_11,AMP(33))
C     Amplitude(s) for diagram number 34
      CALL FFV1_0(W(1,3),W(1,31),W(1,23),GC_11,AMP(34))
      CALL VVV1P0_1(W(1,10),W(1,2),GC_10,ZERO,ZERO,W(1,33))
C     Amplitude(s) for diagram number 35
      CALL FFV1_0(W(1,11),W(1,6),W(1,33),GC_11,AMP(35))
C     Amplitude(s) for diagram number 36
      CALL FFV1_0(W(1,5),W(1,12),W(1,33),GC_11,AMP(36))
      CALL VVV1P0_1(W(1,2),W(1,9),GC_10,ZERO,ZERO,W(1,34))
C     Amplitude(s) for diagram number 37
      CALL FFV1_0(W(1,20),W(1,6),W(1,34),GC_11,AMP(37))
C     Amplitude(s) for diagram number 38
      CALL FFV1_0(W(1,20),W(1,12),W(1,2),GC_11,AMP(38))
C     Amplitude(s) for diagram number 39
      CALL FFV1_0(W(1,5),W(1,22),W(1,34),GC_11,AMP(39))
C     Amplitude(s) for diagram number 40
      CALL FFV1_0(W(1,11),W(1,22),W(1,2),GC_11,AMP(40))
C     Amplitude(s) for diagram number 41
      CALL VVVV1_0(W(1,10),W(1,2),W(1,9),W(1,17),GC_12,AMP(41))
      CALL VVVV3_0(W(1,10),W(1,2),W(1,9),W(1,17),GC_12,AMP(42))
      CALL VVVV4_0(W(1,10),W(1,2),W(1,9),W(1,17),GC_12,AMP(43))
C     Amplitude(s) for diagram number 42
      CALL VVV1_0(W(1,9),W(1,17),W(1,33),GC_10,AMP(44))
C     Amplitude(s) for diagram number 43
      CALL VVV1_0(W(1,2),W(1,17),W(1,28),GC_10,AMP(45))
C     Amplitude(s) for diagram number 44
      CALL VVV1_0(W(1,2),W(1,9),W(1,23),GC_10,AMP(46))
C     Amplitude(s) for diagram number 45
      CALL FFV1_0(W(1,13),W(1,7),W(1,33),GC_11,AMP(47))
C     Amplitude(s) for diagram number 46
      CALL FFV1_0(W(1,3),W(1,18),W(1,33),GC_11,AMP(48))
      CALL VVV1P0_1(W(1,2),W(1,17),GC_10,ZERO,ZERO,W(1,33))
C     Amplitude(s) for diagram number 47
      CALL FFV1_0(W(1,26),W(1,7),W(1,33),GC_11,AMP(49))
C     Amplitude(s) for diagram number 48
      CALL FFV1_0(W(1,26),W(1,18),W(1,2),GC_11,AMP(50))
C     Amplitude(s) for diagram number 49
      CALL FFV1_0(W(1,3),W(1,24),W(1,33),GC_11,AMP(51))
C     Amplitude(s) for diagram number 50
      CALL FFV1_0(W(1,13),W(1,24),W(1,2),GC_11,AMP(52))
      CALL FFV1P0_3(W(1,5),W(1,1),GC_11,ZERO,ZERO,W(1,24))
      CALL FFV1_2(W(1,4),W(1,24),GC_11,ZERO,ZERO,W(1,26))
C     Amplitude(s) for diagram number 51
      CALL FFV1_0(W(1,26),W(1,6),W(1,21),GC_11,AMP(53))
      CALL FFV1_1(W(1,6),W(1,24),GC_11,ZERO,ZERO,W(1,23))
C     Amplitude(s) for diagram number 52
      CALL FFV1_0(W(1,4),W(1,23),W(1,21),GC_11,AMP(54))
      CALL FFV1_2(W(1,19),W(1,24),GC_11,ZERO,ZERO,W(1,28))
C     Amplitude(s) for diagram number 53
      CALL FFV1_0(W(1,28),W(1,7),W(1,15),GC_11,AMP(55))
      CALL VVV1P0_1(W(1,24),W(1,15),GC_10,ZERO,ZERO,W(1,28))
C     Amplitude(s) for diagram number 54
      CALL FFV1_0(W(1,19),W(1,7),W(1,28),GC_11,AMP(56))
      CALL FFV1_1(W(1,7),W(1,24),GC_11,ZERO,ZERO,W(1,10))
C     Amplitude(s) for diagram number 55
      CALL FFV1_0(W(1,19),W(1,10),W(1,15),GC_11,AMP(57))
      CALL FFV1_2(W(1,4),W(1,2),GC_11,ZERO,ZERO,W(1,19))
      CALL FFV1_2(W(1,3),W(1,24),GC_11,ZERO,ZERO,W(1,22))
      CALL FFV1P0_3(W(1,19),W(1,6),GC_11,ZERO,ZERO,W(1,20))
C     Amplitude(s) for diagram number 56
      CALL FFV1_0(W(1,22),W(1,7),W(1,20),GC_11,AMP(58))
C     Amplitude(s) for diagram number 57
      CALL FFV1_0(W(1,3),W(1,10),W(1,20),GC_11,AMP(59))
      CALL FFV1_2(W(1,19),W(1,24),GC_11,ZERO,ZERO,W(1,35))
C     Amplitude(s) for diagram number 58
      CALL FFV1_0(W(1,35),W(1,6),W(1,9),GC_11,AMP(60))
      CALL VVV1P0_1(W(1,24),W(1,9),GC_10,ZERO,ZERO,W(1,35))
C     Amplitude(s) for diagram number 59
      CALL FFV1_0(W(1,19),W(1,6),W(1,35),GC_11,AMP(61))
C     Amplitude(s) for diagram number 60
      CALL FFV1_0(W(1,19),W(1,23),W(1,9),GC_11,AMP(62))
      CALL FFV1P0_3(W(1,4),W(1,29),GC_11,ZERO,ZERO,W(1,36))
C     Amplitude(s) for diagram number 61
      CALL FFV1_0(W(1,22),W(1,7),W(1,36),GC_11,AMP(63))
C     Amplitude(s) for diagram number 62
      CALL FFV1_0(W(1,3),W(1,10),W(1,36),GC_11,AMP(64))
      CALL FFV1_1(W(1,29),W(1,24),GC_11,ZERO,ZERO,W(1,37))
C     Amplitude(s) for diagram number 63
      CALL FFV1_0(W(1,4),W(1,37),W(1,9),GC_11,AMP(65))
C     Amplitude(s) for diagram number 64
      CALL FFV1_0(W(1,4),W(1,29),W(1,35),GC_11,AMP(66))
C     Amplitude(s) for diagram number 65
      CALL FFV1_0(W(1,26),W(1,29),W(1,9),GC_11,AMP(67))
C     Amplitude(s) for diagram number 66
      CALL FFV1_0(W(1,26),W(1,6),W(1,32),GC_11,AMP(68))
C     Amplitude(s) for diagram number 67
      CALL FFV1_0(W(1,4),W(1,23),W(1,32),GC_11,AMP(69))
      CALL FFV1_1(W(1,31),W(1,24),GC_11,ZERO,ZERO,W(1,29))
C     Amplitude(s) for diagram number 68
      CALL FFV1_0(W(1,3),W(1,29),W(1,15),GC_11,AMP(70))
C     Amplitude(s) for diagram number 69
      CALL FFV1_0(W(1,22),W(1,31),W(1,15),GC_11,AMP(71))
C     Amplitude(s) for diagram number 70
      CALL FFV1_0(W(1,3),W(1,31),W(1,28),GC_11,AMP(72))
      CALL VVV1P0_1(W(1,24),W(1,2),GC_10,ZERO,ZERO,W(1,31))
C     Amplitude(s) for diagram number 71
      CALL FFV1_0(W(1,14),W(1,6),W(1,31),GC_11,AMP(73))
C     Amplitude(s) for diagram number 72
      CALL FFV1_0(W(1,4),W(1,12),W(1,31),GC_11,AMP(74))
C     Amplitude(s) for diagram number 73
      CALL FFV1_0(W(1,26),W(1,6),W(1,34),GC_11,AMP(75))
C     Amplitude(s) for diagram number 74
      CALL FFV1_0(W(1,26),W(1,12),W(1,2),GC_11,AMP(76))
C     Amplitude(s) for diagram number 75
      CALL FFV1_0(W(1,4),W(1,23),W(1,34),GC_11,AMP(77))
C     Amplitude(s) for diagram number 76
      CALL FFV1_0(W(1,14),W(1,23),W(1,2),GC_11,AMP(78))
C     Amplitude(s) for diagram number 77
      CALL VVVV1_0(W(1,24),W(1,2),W(1,9),W(1,15),GC_12,AMP(79))
      CALL VVVV3_0(W(1,24),W(1,2),W(1,9),W(1,15),GC_12,AMP(80))
      CALL VVVV4_0(W(1,24),W(1,2),W(1,9),W(1,15),GC_12,AMP(81))
C     Amplitude(s) for diagram number 78
      CALL VVV1_0(W(1,9),W(1,15),W(1,31),GC_10,AMP(82))
C     Amplitude(s) for diagram number 79
      CALL VVV1_0(W(1,2),W(1,15),W(1,35),GC_10,AMP(83))
C     Amplitude(s) for diagram number 80
      CALL VVV1_0(W(1,2),W(1,9),W(1,28),GC_10,AMP(84))
C     Amplitude(s) for diagram number 81
      CALL FFV1_0(W(1,16),W(1,7),W(1,31),GC_11,AMP(85))
C     Amplitude(s) for diagram number 82
      CALL FFV1_0(W(1,3),W(1,8),W(1,31),GC_11,AMP(86))
      CALL VVV1P0_1(W(1,2),W(1,15),GC_10,ZERO,ZERO,W(1,31))
C     Amplitude(s) for diagram number 83
      CALL FFV1_0(W(1,22),W(1,7),W(1,31),GC_11,AMP(87))
C     Amplitude(s) for diagram number 84
      CALL FFV1_0(W(1,22),W(1,8),W(1,2),GC_11,AMP(88))
C     Amplitude(s) for diagram number 85
      CALL FFV1_0(W(1,3),W(1,10),W(1,31),GC_11,AMP(89))
C     Amplitude(s) for diagram number 86
      CALL FFV1_0(W(1,16),W(1,10),W(1,2),GC_11,AMP(90))
      CALL FFV1_1(W(1,1),W(1,15),GC_11,ZERO,ZERO,W(1,10))
C     Amplitude(s) for diagram number 87
      CALL FFV1_0(W(1,5),W(1,10),W(1,21),GC_11,AMP(91))
      CALL FFV1_2(W(1,5),W(1,15),GC_11,ZERO,ZERO,W(1,22))
C     Amplitude(s) for diagram number 88
      CALL FFV1_0(W(1,22),W(1,1),W(1,21),GC_11,AMP(92))
      CALL FFV1_1(W(1,1),W(1,17),GC_11,ZERO,ZERO,W(1,28))
C     Amplitude(s) for diagram number 89
      CALL FFV1_0(W(1,4),W(1,28),W(1,21),GC_11,AMP(93))
      CALL FFV1_2(W(1,4),W(1,17),GC_11,ZERO,ZERO,W(1,35))
C     Amplitude(s) for diagram number 90
      CALL FFV1_0(W(1,35),W(1,1),W(1,21),GC_11,AMP(94))
      CALL FFV1P0_3(W(1,19),W(1,1),GC_11,ZERO,ZERO,W(1,21))
C     Amplitude(s) for diagram number 91
      CALL FFV1_0(W(1,11),W(1,6),W(1,21),GC_11,AMP(95))
C     Amplitude(s) for diagram number 92
      CALL FFV1_0(W(1,5),W(1,12),W(1,21),GC_11,AMP(96))
      CALL FFV1_1(W(1,1),W(1,9),GC_11,ZERO,ZERO,W(1,24))
C     Amplitude(s) for diagram number 93
      CALL FFV1_0(W(1,5),W(1,24),W(1,20),GC_11,AMP(97))
C     Amplitude(s) for diagram number 94
      CALL FFV1_0(W(1,11),W(1,1),W(1,20),GC_11,AMP(98))
C     Amplitude(s) for diagram number 95
      CALL VVV1_0(W(1,9),W(1,17),W(1,21),GC_10,AMP(99))
C     Amplitude(s) for diagram number 96
      CALL FFV1_0(W(1,19),W(1,24),W(1,17),GC_11,AMP(100))
C     Amplitude(s) for diagram number 97
      CALL FFV1_0(W(1,19),W(1,28),W(1,9),GC_11,AMP(101))
C     Amplitude(s) for diagram number 98
      CALL FFV1_0(W(1,13),W(1,7),W(1,21),GC_11,AMP(102))
C     Amplitude(s) for diagram number 99
      CALL FFV1_0(W(1,3),W(1,18),W(1,21),GC_11,AMP(103))
      CALL FFV1P0_3(W(1,25),W(1,1),GC_11,ZERO,ZERO,W(1,21))
C     Amplitude(s) for diagram number 100
      CALL FFV1_0(W(1,14),W(1,6),W(1,21),GC_11,AMP(104))
C     Amplitude(s) for diagram number 101
      CALL FFV1_0(W(1,4),W(1,12),W(1,21),GC_11,AMP(105))
C     Amplitude(s) for diagram number 102
      CALL FFV1_0(W(1,4),W(1,24),W(1,27),GC_11,AMP(106))
C     Amplitude(s) for diagram number 103
      CALL FFV1_0(W(1,14),W(1,1),W(1,27),GC_11,AMP(107))
C     Amplitude(s) for diagram number 104
      CALL VVV1_0(W(1,9),W(1,15),W(1,21),GC_10,AMP(108))
C     Amplitude(s) for diagram number 105
      CALL FFV1_0(W(1,25),W(1,24),W(1,15),GC_11,AMP(109))
C     Amplitude(s) for diagram number 106
      CALL FFV1_0(W(1,25),W(1,10),W(1,9),GC_11,AMP(110))
C     Amplitude(s) for diagram number 107
      CALL FFV1_0(W(1,16),W(1,7),W(1,21),GC_11,AMP(111))
C     Amplitude(s) for diagram number 108
      CALL FFV1_0(W(1,3),W(1,8),W(1,21),GC_11,AMP(112))
C     Amplitude(s) for diagram number 109
      CALL FFV1_0(W(1,5),W(1,24),W(1,36),GC_11,AMP(113))
C     Amplitude(s) for diagram number 110
      CALL FFV1_0(W(1,4),W(1,24),W(1,30),GC_11,AMP(114))
C     Amplitude(s) for diagram number 111
      CALL FFV1_0(W(1,11),W(1,1),W(1,36),GC_11,AMP(115))
C     Amplitude(s) for diagram number 112
      CALL FFV1_0(W(1,14),W(1,1),W(1,30),GC_11,AMP(116))
C     Amplitude(s) for diagram number 113
      CALL FFV1_0(W(1,5),W(1,10),W(1,32),GC_11,AMP(117))
C     Amplitude(s) for diagram number 114
      CALL FFV1_0(W(1,22),W(1,1),W(1,32),GC_11,AMP(118))
C     Amplitude(s) for diagram number 115
      CALL FFV1_0(W(1,4),W(1,28),W(1,32),GC_11,AMP(119))
C     Amplitude(s) for diagram number 116
      CALL FFV1_0(W(1,35),W(1,1),W(1,32),GC_11,AMP(120))
C     Amplitude(s) for diagram number 117
      CALL FFV1_0(W(1,5),W(1,24),W(1,31),GC_11,AMP(121))
C     Amplitude(s) for diagram number 118
      CALL FFV1_0(W(1,22),W(1,24),W(1,2),GC_11,AMP(122))
C     Amplitude(s) for diagram number 119
      CALL FFV1_0(W(1,5),W(1,10),W(1,34),GC_11,AMP(123))
C     Amplitude(s) for diagram number 120
      CALL FFV1_0(W(1,11),W(1,10),W(1,2),GC_11,AMP(124))
C     Amplitude(s) for diagram number 121
      CALL FFV1_0(W(1,22),W(1,1),W(1,34),GC_11,AMP(125))
C     Amplitude(s) for diagram number 122
      CALL FFV1_0(W(1,11),W(1,1),W(1,31),GC_11,AMP(126))
C     Amplitude(s) for diagram number 123
      CALL FFV1_0(W(1,4),W(1,24),W(1,33),GC_11,AMP(127))
C     Amplitude(s) for diagram number 124
      CALL FFV1_0(W(1,35),W(1,24),W(1,2),GC_11,AMP(128))
C     Amplitude(s) for diagram number 125
      CALL FFV1_0(W(1,4),W(1,28),W(1,34),GC_11,AMP(129))
C     Amplitude(s) for diagram number 126
      CALL FFV1_0(W(1,14),W(1,28),W(1,2),GC_11,AMP(130))
C     Amplitude(s) for diagram number 127
      CALL FFV1_0(W(1,35),W(1,1),W(1,34),GC_11,AMP(131))
C     Amplitude(s) for diagram number 128
      CALL FFV1_0(W(1,14),W(1,1),W(1,33),GC_11,AMP(132))
      JAMP(1)=+1D0/4D0*(+AMP(25)+AMP(27)-IMAG1*AMP(28)+IMAG1*AMP(35)
     $ +AMP(42)+AMP(41)+AMP(44)+AMP(45)+IMAG1*AMP(48)+IMAG1*AMP(49)
     $ +AMP(50)+1D0/3D0*AMP(58)+1D0/3D0*AMP(59)+1D0/3D0*AMP(63)+1D0
     $ /3D0*AMP(64)+AMP(95)+1D0/3D0*AMP(97)+1D0/3D0*AMP(98)-IMAG1
     $ *AMP(99)+AMP(100)+AMP(103)+1D0/3D0*AMP(113)+AMP(114)+1D0/3D0
     $ *AMP(115)+IMAG1*AMP(127))
      JAMP(2)=+1D0/4D0*(-1D0/3D0*AMP(20)-1D0/3D0*AMP(21)-1D0/3D0
     $ *AMP(25)-1D0/3D0*AMP(26)-AMP(63)-AMP(65)+IMAG1*AMP(66)-IMAG1
     $ *AMP(73)-AMP(80)-AMP(79)-AMP(82)-AMP(83)-IMAG1*AMP(86)-IMAG1
     $ *AMP(87)-AMP(88)-AMP(104)-1D0/3D0*AMP(106)-1D0/3D0*AMP(107)
     $ +IMAG1*AMP(108)-AMP(109)-AMP(112)-AMP(113)-1D0/3D0*AMP(114)-1D0
     $ /3D0*AMP(116)-IMAG1*AMP(121))
      JAMP(3)=+1D0/4D0*(-1D0/3D0*AMP(32)-1D0/3D0*AMP(33)-1D0/3D0*IMAG1
     $ *AMP(47)-1D0/3D0*IMAG1*AMP(48)-1D0/3D0*AMP(50)-AMP(58)+IMAG1
     $ *AMP(61)-AMP(62)-AMP(69)-AMP(71)-IMAG1*AMP(72)-IMAG1*AMP(77)
     $ +AMP(81)+AMP(80)+AMP(83)+AMP(84)+IMAG1*AMP(87)-AMP(97)-1D0/3D0
     $ *AMP(100)-1D0/3D0*AMP(101)-1D0/3D0*AMP(102)-1D0/3D0*AMP(103)
     $ -AMP(118)-1D0/3D0*AMP(119)-1D0/3D0*AMP(120)+IMAG1*AMP(121)
     $ -AMP(122)-IMAG1*AMP(125)-1D0/3D0*AMP(128)-1D0/3D0*IMAG1*AMP(129)
     $ -1D0/3D0*IMAG1*AMP(131))
      JAMP(4)=+1D0/4D0*(+AMP(20)-IMAG1*AMP(23)+AMP(24)+AMP(31)+AMP(33)
     $ +IMAG1*AMP(34)+IMAG1*AMP(39)-AMP(43)-AMP(42)-AMP(45)-AMP(46)
     $ -IMAG1*AMP(49)+1D0/3D0*AMP(70)+1D0/3D0*AMP(71)+1D0/3D0*IMAG1
     $ *AMP(85)+1D0/3D0*IMAG1*AMP(86)+1D0/3D0*AMP(88)+AMP(106)+1D0/3D0
     $ *AMP(109)+1D0/3D0*AMP(110)+1D0/3D0*AMP(111)+1D0/3D0*AMP(112)
     $ +1D0/3D0*AMP(117)+1D0/3D0*AMP(118)+AMP(120)+1D0/3D0*AMP(122)
     $ +1D0/3D0*IMAG1*AMP(123)+1D0/3D0*IMAG1*AMP(125)-IMAG1*AMP(127)
     $ +AMP(128)+IMAG1*AMP(131))
      JAMP(5)=+1D0/4D0*(-1D0/3D0*AMP(15)-1D0/3D0*AMP(16)-1D0/3D0
     $ *AMP(17)-1D0/3D0*AMP(19)-1D0/3D0*AMP(25)-1D0/3D0*AMP(26)-1D0
     $ /3D0*AMP(27)-1D0/3D0*AMP(29)+1D0/3D0*IMAG1*AMP(37)+1D0/3D0
     $ *IMAG1*AMP(39)-1D0/3D0*AMP(40)-1D0/3D0*IMAG1*AMP(49)-1D0/3D0
     $ *AMP(50)-1D0/3D0*IMAG1*AMP(51)-AMP(53)+IMAG1*AMP(56)-AMP(57)
     $ -AMP(64)-IMAG1*AMP(66)-AMP(67)+IMAG1*AMP(75)+AMP(81)+AMP(80)
     $ +AMP(83)+AMP(84)-IMAG1*AMP(89)-AMP(91)-AMP(115)+IMAG1*AMP(123)
     $ -AMP(124)-IMAG1*AMP(126))
      JAMP(6)=+1D0/4D0*(+1D0/9D0*AMP(20)+1D0/9D0*AMP(21)+1D0/9D0
     $ *AMP(22)+1D0/9D0*AMP(24)+1D0/9D0*AMP(25)+1D0/9D0*AMP(26)+1D0
     $ /9D0*AMP(27)+1D0/9D0*AMP(29)+1D0/9D0*AMP(38)+1D0/9D0*AMP(40)
     $ +1D0/3D0*AMP(65)+1D0/3D0*AMP(67)+1D0/3D0*IMAG1*AMP(73)+1D0/3D0
     $ *IMAG1*AMP(74)+1D0/3D0*AMP(76)+1D0/3D0*AMP(104)+1D0/3D0*AMP(105)
     $ +1D0/9D0*AMP(106)+1D0/9D0*AMP(107)+1D0/3D0*AMP(109)+1D0/3D0
     $ *AMP(110)+1D0/3D0*AMP(113)+1D0/9D0*AMP(114)+1D0/3D0*AMP(115)
     $ +1D0/9D0*AMP(116)+1D0/3D0*IMAG1*AMP(121)+1D0/3D0*AMP(124)+1D0
     $ /3D0*IMAG1*AMP(126))
      JAMP(7)=+1D0/4D0*(+1D0/9D0*AMP(15)+1D0/9D0*AMP(16)+1D0/9D0
     $ *AMP(17)+1D0/9D0*AMP(19)+1D0/9D0*AMP(30)+1D0/9D0*AMP(31)+1D0
     $ /9D0*AMP(32)+1D0/9D0*AMP(33)+1D0/9D0*AMP(50)+1D0/9D0*AMP(52)
     $ +1D0/3D0*AMP(53)+1D0/3D0*AMP(54)+1D0/3D0*AMP(68)+1D0/3D0*AMP(69)
     $ +1D0/3D0*AMP(91)+1D0/3D0*AMP(92)+1D0/9D0*AMP(93)+1D0/9D0*AMP(94)
     $ +1D0/3D0*AMP(117)+1D0/3D0*AMP(118)+1D0/9D0*AMP(119)+1D0/9D0
     $ *AMP(120))
      JAMP(8)=+1D0/4D0*(-1D0/3D0*AMP(20)-1D0/3D0*AMP(21)-1D0/3D0
     $ *AMP(22)-1D0/3D0*AMP(24)-1D0/3D0*AMP(30)-1D0/3D0*AMP(31)-1D0
     $ /3D0*AMP(32)-1D0/3D0*AMP(33)-1D0/3D0*IMAG1*AMP(37)-1D0/3D0
     $ *AMP(38)-1D0/3D0*IMAG1*AMP(39)+1D0/3D0*IMAG1*AMP(49)+1D0/3D0
     $ *IMAG1*AMP(51)-1D0/3D0*AMP(52)-AMP(68)-AMP(70)+IMAG1*AMP(72)
     $ -IMAG1*AMP(74)-IMAG1*AMP(75)-AMP(76)-AMP(81)+AMP(79)+AMP(82)
     $ -AMP(84)-IMAG1*AMP(85)-AMP(105)-IMAG1*AMP(108)-AMP(110)-AMP(111)
     $ -AMP(117)-IMAG1*AMP(123))
      JAMP(9)=+1D0/4D0*(+AMP(15)-IMAG1*AMP(18)+AMP(19)+AMP(26)+IMAG1
     $ *AMP(28)+AMP(29)-IMAG1*AMP(37)-AMP(43)-AMP(42)-AMP(45)-AMP(46)
     $ +IMAG1*AMP(51)+1D0/3D0*AMP(53)+1D0/3D0*AMP(54)+1D0/3D0*AMP(55)
     $ +1D0/3D0*AMP(57)+1D0/3D0*AMP(63)+1D0/3D0*AMP(64)+1D0/3D0*AMP(65)
     $ +1D0/3D0*AMP(67)-1D0/3D0*IMAG1*AMP(75)-1D0/3D0*IMAG1*AMP(77)
     $ +1D0/3D0*AMP(78)+1D0/3D0*IMAG1*AMP(87)+1D0/3D0*AMP(88)+1D0/3D0
     $ *IMAG1*AMP(89)+AMP(93)+AMP(116)-IMAG1*AMP(129)+AMP(130)+IMAG1
     $ *AMP(132))
      JAMP(10)=+1D0/4D0*(-1D0/3D0*AMP(27)-1D0/3D0*AMP(29)-1D0/3D0
     $ *IMAG1*AMP(35)-1D0/3D0*IMAG1*AMP(36)-1D0/3D0*AMP(38)-1D0/9D0
     $ *AMP(58)-1D0/9D0*AMP(59)-1D0/9D0*AMP(60)-1D0/9D0*AMP(62)-1D0
     $ /9D0*AMP(63)-1D0/9D0*AMP(64)-1D0/9D0*AMP(65)-1D0/9D0*AMP(67)
     $ -1D0/9D0*AMP(76)-1D0/9D0*AMP(78)-1D0/3D0*AMP(95)-1D0/3D0*AMP(96)
     $ -1D0/9D0*AMP(97)-1D0/9D0*AMP(98)-1D0/3D0*AMP(100)-1D0/3D0
     $ *AMP(101)-1D0/9D0*AMP(113)-1D0/3D0*AMP(114)-1D0/9D0*AMP(115)
     $ -1D0/3D0*AMP(116)-1D0/3D0*IMAG1*AMP(127)-1D0/3D0*AMP(130)-1D0
     $ /3D0*IMAG1*AMP(132))
      JAMP(11)=+1D0/4D0*(-1D0/3D0*AMP(15)-1D0/3D0*AMP(16)-1D0/3D0
     $ *AMP(30)-1D0/3D0*AMP(31)-1D0/9D0*AMP(53)-1D0/9D0*AMP(54)-1D0
     $ /9D0*AMP(55)-1D0/9D0*AMP(57)-1D0/9D0*AMP(68)-1D0/9D0*AMP(69)
     $ -1D0/9D0*AMP(70)-1D0/9D0*AMP(71)-1D0/9D0*AMP(88)-1D0/9D0*AMP(90)
     $ -1D0/9D0*AMP(91)-1D0/9D0*AMP(92)-1D0/3D0*AMP(93)-1D0/3D0*AMP(94)
     $ -1D0/9D0*AMP(117)-1D0/9D0*AMP(118)-1D0/3D0*AMP(119)-1D0/3D0
     $ *AMP(120))
      JAMP(12)=+1D0/4D0*(+AMP(30)+AMP(32)-IMAG1*AMP(34)+IMAG1*AMP(36)
     $ +IMAG1*AMP(37)+AMP(38)+AMP(43)-AMP(41)-AMP(44)+AMP(46)+IMAG1
     $ *AMP(47)+1D0/3D0*AMP(58)+1D0/3D0*AMP(59)+1D0/3D0*AMP(60)+1D0
     $ /3D0*AMP(62)+1D0/3D0*AMP(68)+1D0/3D0*AMP(69)+1D0/3D0*AMP(70)
     $ +1D0/3D0*AMP(71)+1D0/3D0*IMAG1*AMP(75)+1D0/3D0*AMP(76)+1D0/3D0
     $ *IMAG1*AMP(77)-1D0/3D0*IMAG1*AMP(87)-1D0/3D0*IMAG1*AMP(89)+1D0
     $ /3D0*AMP(90)+AMP(96)+IMAG1*AMP(99)+AMP(101)+AMP(102)+AMP(119)
     $ +IMAG1*AMP(129))
      JAMP(13)=+1D0/4D0*(+AMP(1)+1D0/3D0*AMP(5)+1D0/3D0*AMP(6)+AMP(8)
     $ -IMAG1*AMP(9)+1D0/3D0*AMP(11)+1D0/3D0*AMP(12)+AMP(14)+AMP(16)
     $ +AMP(17)+IMAG1*AMP(18)-IMAG1*AMP(35)-IMAG1*AMP(39)+AMP(40)
     $ +AMP(43)-AMP(41)-AMP(44)+AMP(46)-IMAG1*AMP(48)+1D0/3D0*AMP(55)
     $ +1D0/3D0*AMP(57)-1D0/3D0*IMAG1*AMP(85)-1D0/3D0*IMAG1*AMP(86)
     $ +1D0/3D0*AMP(90)+1D0/3D0*AMP(91)+1D0/3D0*AMP(92)+AMP(94)-1D0
     $ /3D0*IMAG1*AMP(123)+1D0/3D0*AMP(124)-1D0/3D0*IMAG1*AMP(125)
     $ -IMAG1*AMP(131))
      JAMP(14)=+1D0/4D0*(-AMP(3)-AMP(5)+IMAG1*AMP(7)-1D0/3D0*AMP(8)
     $ -1D0/3D0*AMP(10)-AMP(12)-1D0/3D0*AMP(13)-1D0/3D0*AMP(14)-1D0
     $ /3D0*AMP(17)-1D0/3D0*AMP(19)+1D0/3D0*IMAG1*AMP(47)+1D0/3D0
     $ *IMAG1*AMP(48)-1D0/3D0*AMP(52)-AMP(54)-AMP(55)-IMAG1*AMP(56)
     $ +IMAG1*AMP(73)+IMAG1*AMP(77)-AMP(78)-AMP(81)+AMP(79)+AMP(82)
     $ -AMP(84)+IMAG1*AMP(86)-AMP(92)-1D0/3D0*AMP(93)-1D0/3D0*AMP(94)
     $ +IMAG1*AMP(125)+1D0/3D0*IMAG1*AMP(129)-1D0/3D0*AMP(130)+1D0/3D0
     $ *IMAG1*AMP(131))
      JAMP(15)=+1D0/4D0*(-1D0/3D0*AMP(1)-1D0/3D0*AMP(2)-AMP(4)-AMP(6)
     $ -IMAG1*AMP(7)-AMP(11)-1D0/3D0*AMP(13)-1D0/3D0*AMP(14)-AMP(59)
     $ -AMP(60)-IMAG1*AMP(61)+IMAG1*AMP(74)-AMP(80)-AMP(79)-AMP(82)
     $ -AMP(83)+IMAG1*AMP(85)+IMAG1*AMP(89)-AMP(90)-1D0/3D0*AMP(95)
     $ -1D0/3D0*AMP(96)-AMP(98)-1D0/3D0*AMP(102)-1D0/3D0*AMP(103)
     $ +IMAG1*AMP(126))
      JAMP(16)=+1D0/4D0*(+1D0/9D0*AMP(1)+1D0/9D0*AMP(2)+1D0/3D0*AMP(3)
     $ +1D0/3D0*AMP(4)+1D0/3D0*AMP(5)+1D0/3D0*AMP(6)+1D0/9D0*AMP(8)
     $ +1D0/9D0*AMP(10)+1D0/9D0*AMP(13)+1D0/9D0*AMP(14)+1D0/3D0*AMP(60)
     $ +1D0/3D0*AMP(62)-1D0/3D0*IMAG1*AMP(73)-1D0/3D0*IMAG1*AMP(74)
     $ +1D0/3D0*AMP(78)+1D0/9D0*AMP(95)+1D0/9D0*AMP(96)+1D0/3D0*AMP(97)
     $ +1D0/3D0*AMP(98)+1D0/9D0*AMP(100)+1D0/9D0*AMP(101)+1D0/9D0
     $ *AMP(102)+1D0/9D0*AMP(103)-1D0/3D0*IMAG1*AMP(121)+1D0/3D0
     $ *AMP(122)-1D0/3D0*IMAG1*AMP(126)+1D0/9D0*AMP(128)+1D0/9D0
     $ *AMP(130))
      JAMP(17)=+1D0/4D0*(+AMP(2)+1D0/3D0*AMP(3)+1D0/3D0*AMP(4)+IMAG1
     $ *AMP(9)+AMP(10)+1D0/3D0*AMP(11)+1D0/3D0*AMP(12)+AMP(13)+AMP(21)
     $ +AMP(22)+IMAG1*AMP(23)-IMAG1*AMP(36)+AMP(42)+AMP(41)+AMP(44)
     $ +AMP(45)-IMAG1*AMP(47)-IMAG1*AMP(51)+AMP(52)+1D0/3D0*AMP(104)
     $ +1D0/3D0*AMP(105)+AMP(107)+1D0/3D0*AMP(111)+1D0/3D0*AMP(112)
     $ -IMAG1*AMP(132))
      JAMP(18)=+1D0/4D0*(-1D0/3D0*AMP(1)-1D0/3D0*AMP(2)-1D0/9D0*AMP(3)
     $ -1D0/9D0*AMP(4)-1D0/9D0*AMP(5)-1D0/9D0*AMP(6)-1D0/3D0*AMP(8)
     $ -1D0/3D0*AMP(10)-1D0/9D0*AMP(11)-1D0/9D0*AMP(12)-1D0/3D0*AMP(22)
     $ -1D0/3D0*AMP(24)+1D0/3D0*IMAG1*AMP(35)+1D0/3D0*IMAG1*AMP(36)
     $ -1D0/3D0*AMP(40)-1D0/9D0*AMP(104)-1D0/9D0*AMP(105)-1D0/3D0
     $ *AMP(106)-1D0/3D0*AMP(107)-1D0/9D0*AMP(109)-1D0/9D0*AMP(110)
     $ -1D0/9D0*AMP(111)-1D0/9D0*AMP(112)-1D0/9D0*AMP(122)-1D0/9D0
     $ *AMP(124)+1D0/3D0*IMAG1*AMP(127)-1D0/3D0*AMP(128)+1D0/3D0*IMAG1
     $ *AMP(132))

C...VINCIA: Leading Color for Diagonal Entry ICOL
      dxg_uxdxdxdu = CF(ICOL,ICOL)*JAMP(ICOL)
     &         *DCONJG(JAMP(ICOL))/DENOM(ICOL)
C...VINCIA: Absorb subleading color proportional to FSLC = LC/Sum(LC)
      IF (MCMODE.EQ.0) RETURN
      IF (MCMODE.EQ.1.AND.dxg_uxdxdxdu.LE.ZERO) RETURN
        ZLCSUM = 0D0
        DO I = 1, NCOLOR
          ZLCSUM = ZLCSUM + CF(I,I)*JAMP(I)*DCONJG(JAMP(I))/DENOM(I)
        ENDDO
C...VINCIA: MCMODE = 2 returns full colour-summed ME
        IF (MCMODE.EQ.2) dxg_uxdxdxdu = ZLCSUM
C...VINCIA: Fraction of subleading color to absorb into this permutation
        FSLC = dxg_uxdxdxdu/ZLCSUM
C...VINCIA: Sum over subleading contributions multiplied by FSLC
      DO I = 1, NCOLOR
        ZTEMP = (0.D0,0.D0)
        DO J = 1, NCOLOR
          IF (I.NE.J) ZTEMP = ZTEMP + CF(J,I)*JAMP(J)
        ENDDO
        dxg_uxdxdxdu = dxg_uxdxdxdu+FSLC*ZTEMP*DCONJG(JAMP(I))/DENOM(I)
      ENDDO

      END

      SUBROUTINE GETdxg_uxdxdxdu(MCMODE,ICOL,P, ALPHAS, NHEL ,ANS)
      IMPLICIT NONE
C     
C     CONSTANT
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=7)
C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION ANS, P(0:3,NEXTERNAL)
C...VINCIA: Define MCMODE and ICOL variables
C...  MCMODE = 0 : Leading Colour = LC[icol]
C...  MCMODE = 1 : Vincia Colour  = FC * LC[icol]/sum(LC)
C...  MCMODE = 2 : Full Colour    = FC (-> normal MG mode)
      INTEGER MCMODE, ICOL
      INTEGER NHEL
      DOUBLE PRECISION ALPHAS
      DOUBLE PRECISION PI
CF2PY INTENT(OUT) :: ANS
CF2PY INTENT(IN) :: NHEL
CF2PY INTENT(IN) :: P(0:3,NEXTERNAL)
CF2PY INTENT(IN) :: ALPHAS
C     ROUTINE FOR F2PY to read the benchmark point.    
C     the include file with the values of the parameters and masses 
      INCLUDE 'coupl.inc'

      PI = 3.141592653589793D0
      G = 2* DSQRT(ALPHAS*PI)
C...VINCIA: only static MG couplings are interfaced
C      CALL UPDATE_AS_PARAM()
      IF (NHEL.NE.0) THEN
        CALL SHELdxg_uxdxdxdu(MCMODE,ICOL,P, NHEL, ANS)
      ELSE
        CALL Sdxg_uxdxdxdu(MCMODE,ICOL,P, ANS)
      ENDIF
      RETURN
      END


