C...ug_dxdugg.f is a part of the VINCIA event generator.
C...This file was generated by MADGRAPH 5
C...Modified by VINCIA Thu  8 Jun 2017 15:37:50 CEST
C...VINCIA is licenced under the GNU GPL version 2.
C...Copyright (C) 2018 Peter Skands
C...Please respect the work of the MadGraph authors by
C...citing MadGraph 5 when this part of VINCIA is used.
C...See: https://arxiv.org/abs/1106.0522
 
      SUBROUTINE SHELug_dxdugg(MCMODE,ICOL,P,HEL,ANS)
      IMPLICIT NONE
C     
C     CONSTANT
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=7)
      INTEGER                 NCOMB
      PARAMETER (             NCOMB=128)
CF2PY INTENT(OUT) :: ANS
CF2PY INTENT(IN) :: HEL
CF2PY INTENT(IN) :: P(0:3,NEXTERNAL)

C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION ANS, P(0:3,NEXTERNAL)
C...VINCIA: Define MCMODE and ICOL variables
C...  MCMODE = 0 : Leading Colour = LC[icol]
C...  MCMODE = 1 : Vincia Colour  = FC * LC[icol]/sum(LC)
C...  MCMODE = 2 : Full Colour    = FC (-> normal MG mode)
      INTEGER MCMODE, ICOL
      INTEGER HEL
C     
C     GLOBAL VARIABLES
C     
      INTEGER USERHEL
      COMMON/HELUSERCHOICE/USERHEL
C     ----------
C     BEGIN CODE
C     ----------
      USERHEL=HEL
      CALL Sug_dxdugg(MCMODE,ICOL,P,ANS)
      USERHEL=-1

      END

      SUBROUTINE Sug_dxdugg(MCMODE,ICOL,P,ANS)
C     
C     Generated by MadGraph5_aMC@NLO v. 2.4.2, 2016-06-10
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C     
C     MadGraph5_aMC@NLO StandAlone Version
C     
C     Returns amplitude squared summed/avg over colors
C     and helicities
C     for the point in phase space P(0:3,NEXTERNAL)
C     
C     Process: u g > d~ d u g g WEIGHTED<=5 @220
C     Process: s g > d~ d s g g WEIGHTED<=5 @220
C     Process: s g > u~ u s g g WEIGHTED<=5 @220
C     Process: c g > d~ d c g g WEIGHTED<=5 @220
C     Process: c g > u~ u c g g WEIGHTED<=5 @220
C     Process: c g > s~ s c g g WEIGHTED<=5 @220
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=7)
      INTEGER    NINITIAL
      PARAMETER (NINITIAL=2)
      INTEGER NPOLENTRIES
      PARAMETER (NPOLENTRIES=(NEXTERNAL+1)*6)
      INTEGER                 NCOMB
      PARAMETER (             NCOMB=128)
      INTEGER HELAVGFACTOR
      PARAMETER (HELAVGFACTOR=4)
C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION ANS, P(0:3,NEXTERNAL)
C...VINCIA: Define MCMODE and ICOL variables
C...  MCMODE = 0 : Leading Colour = LC[icol]
C...  MCMODE = 1 : Vincia Colour  = FC * LC[icol]/sum(LC)
C...  MCMODE = 2 : Full Colour    = FC (-> normal MG mode)
      INTEGER MCMODE, ICOL
CF2PY INTENT(OUT) :: ANS
CF2PY INTENT(IN) :: P(0:3,NEXTERNAL)
C     
C     LOCAL VARIABLES 
C     
      INTEGER NHEL(NEXTERNAL,NCOMB),NTRY
      DOUBLE PRECISION T
      DOUBLE PRECISION ug_dxdugg
      INTEGER IHEL,IDEN, I, J
C     For a 1>N process, them BEAMTWO_HELAVGFACTOR would be set to 1.
      INTEGER BEAMS_HELAVGFACTOR(2)
      DATA (BEAMS_HELAVGFACTOR(I),I=1,2)/2,2/
      INTEGER JC(NEXTERNAL)
      LOGICAL GOODHEL(NCOMB)
      DATA NTRY/0/
      DATA GOODHEL/NCOMB*.FALSE./

C     
C     GLOBAL VARIABLES
C     
      INTEGER USERHEL
      COMMON/HELUSERCHOICE/USERHEL
C...VINCIA: USERHEL is initialised by MG5interface
C      DATA USERHEL/-1/

      DATA (NHEL(I,   1),I=1,7) / 1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(I,   2),I=1,7) / 1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(I,   3),I=1,7) / 1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(I,   4),I=1,7) / 1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(I,   5),I=1,7) / 1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(I,   6),I=1,7) / 1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(I,   7),I=1,7) / 1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(I,   8),I=1,7) / 1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(I,   9),I=1,7) / 1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(I,  10),I=1,7) / 1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(I,  11),I=1,7) / 1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(I,  12),I=1,7) / 1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(I,  13),I=1,7) / 1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(I,  14),I=1,7) / 1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(I,  15),I=1,7) / 1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(I,  16),I=1,7) / 1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(I,  17),I=1,7) / 1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(I,  18),I=1,7) / 1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(I,  19),I=1,7) / 1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(I,  20),I=1,7) / 1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(I,  21),I=1,7) / 1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(I,  22),I=1,7) / 1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(I,  23),I=1,7) / 1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(I,  24),I=1,7) / 1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(I,  25),I=1,7) / 1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(I,  26),I=1,7) / 1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(I,  27),I=1,7) / 1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(I,  28),I=1,7) / 1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(I,  29),I=1,7) / 1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(I,  30),I=1,7) / 1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(I,  31),I=1,7) / 1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(I,  32),I=1,7) / 1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(I,  33),I=1,7) / 1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(I,  34),I=1,7) / 1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(I,  35),I=1,7) / 1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(I,  36),I=1,7) / 1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(I,  37),I=1,7) / 1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(I,  38),I=1,7) / 1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(I,  39),I=1,7) / 1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(I,  40),I=1,7) / 1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(I,  41),I=1,7) / 1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(I,  42),I=1,7) / 1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(I,  43),I=1,7) / 1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(I,  44),I=1,7) / 1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(I,  45),I=1,7) / 1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(I,  46),I=1,7) / 1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(I,  47),I=1,7) / 1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(I,  48),I=1,7) / 1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(I,  49),I=1,7) / 1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(I,  50),I=1,7) / 1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(I,  51),I=1,7) / 1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(I,  52),I=1,7) / 1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(I,  53),I=1,7) / 1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(I,  54),I=1,7) / 1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(I,  55),I=1,7) / 1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(I,  56),I=1,7) / 1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(I,  57),I=1,7) / 1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(I,  58),I=1,7) / 1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(I,  59),I=1,7) / 1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(I,  60),I=1,7) / 1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(I,  61),I=1,7) / 1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(I,  62),I=1,7) / 1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(I,  63),I=1,7) / 1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(I,  64),I=1,7) / 1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(I,  65),I=1,7) /-1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(I,  66),I=1,7) /-1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(I,  67),I=1,7) /-1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(I,  68),I=1,7) /-1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(I,  69),I=1,7) /-1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(I,  70),I=1,7) /-1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(I,  71),I=1,7) /-1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(I,  72),I=1,7) /-1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(I,  73),I=1,7) /-1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(I,  74),I=1,7) /-1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(I,  75),I=1,7) /-1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(I,  76),I=1,7) /-1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(I,  77),I=1,7) /-1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(I,  78),I=1,7) /-1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(I,  79),I=1,7) /-1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(I,  80),I=1,7) /-1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(I,  81),I=1,7) /-1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(I,  82),I=1,7) /-1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(I,  83),I=1,7) /-1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(I,  84),I=1,7) /-1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(I,  85),I=1,7) /-1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(I,  86),I=1,7) /-1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(I,  87),I=1,7) /-1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(I,  88),I=1,7) /-1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(I,  89),I=1,7) /-1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(I,  90),I=1,7) /-1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(I,  91),I=1,7) /-1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(I,  92),I=1,7) /-1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(I,  93),I=1,7) /-1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(I,  94),I=1,7) /-1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(I,  95),I=1,7) /-1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(I,  96),I=1,7) /-1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(I,  97),I=1,7) /-1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(I,  98),I=1,7) /-1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(I,  99),I=1,7) /-1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(I, 100),I=1,7) /-1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(I, 101),I=1,7) /-1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(I, 102),I=1,7) /-1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(I, 103),I=1,7) /-1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(I, 104),I=1,7) /-1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(I, 105),I=1,7) /-1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(I, 106),I=1,7) /-1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(I, 107),I=1,7) /-1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(I, 108),I=1,7) /-1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(I, 109),I=1,7) /-1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(I, 110),I=1,7) /-1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(I, 111),I=1,7) /-1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(I, 112),I=1,7) /-1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(I, 113),I=1,7) /-1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(I, 114),I=1,7) /-1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(I, 115),I=1,7) /-1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(I, 116),I=1,7) /-1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(I, 117),I=1,7) /-1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(I, 118),I=1,7) /-1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(I, 119),I=1,7) /-1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(I, 120),I=1,7) /-1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(I, 121),I=1,7) /-1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(I, 122),I=1,7) /-1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(I, 123),I=1,7) /-1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(I, 124),I=1,7) /-1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(I, 125),I=1,7) /-1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(I, 126),I=1,7) /-1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(I, 127),I=1,7) /-1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(I, 128),I=1,7) /-1, 1,-1, 1, 1, 1, 1/
      DATA IDEN/192/

      INTEGER POLARIZATIONS(0:NEXTERNAL,0:5)
      DATA ((POLARIZATIONS(I,J),I=0,NEXTERNAL),J=0,5)/NPOLENTRIES*-1/
C...Vincia: BORN_BEAM_POL not used (POLARIZATIONS local and = -1)
C      COMMON/BORN_BEAM_POL/POLARIZATIONS
C     
C     FUNCTIONS
C     
C...Vincia conversion hardcodes for IS_BORN_HEL_SELECTED = .TRUE.
C      LOGICAL IS_BORN_HEL_SELECTED

C     ----------
C     BEGIN CODE
C     ----------
      IF(USERHEL.EQ.-1) NTRY=0
C...(VINCIA: no NTRY optimisation)
      DO IHEL=1,NEXTERNAL
        JC(IHEL) = +1
      ENDDO
C     When spin-2 particles are involved, the Helicity filtering is
C      dangerous for the 2->1 topology.
C     This is because depending on the MC setup the initial PS points
C      have back-to-back initial states
C     for which some of the spin-2 helicity configurations are zero.
C      But they are no longer zero
C     if the point is boosted on the z-axis. Remember that HELAS
C      helicity amplitudes are no longer
C     lorentz invariant with expternal spin-2 particles (only the
C      helicity sum is).
C     For this reason, we simply remove the filterin when there is
C      only three external particles.
      IF (NEXTERNAL.LE.3) THEN
        DO IHEL=1,NCOMB
          GOODHEL(IHEL)=.TRUE.
        ENDDO
      ENDIF
      ANS = 0D0
      DO IHEL=1,NCOMB
        IF (USERHEL.EQ.-1.OR.USERHEL.EQ.IHEL) THEN
          IF (GOODHEL(IHEL) .OR. NTRY .LT. 20.OR.USERHEL.NE.-1) THEN
            IF(NTRY.GE.2.AND.POLARIZATIONS(0,0).NE.
     $       -1.AND.(.FALSE.)) THEN
              CYCLE
            ENDIF
            T=ug_dxdugg(MCMODE,ICOL,P ,NHEL(1,IHEL),JC(1))
            IF(POLARIZATIONS(0,0).EQ.-1.OR..TRUE.)
     $        THEN
              ANS=ANS+T
            ENDIF
            IF (T .NE. 0D0 .AND. .NOT.    GOODHEL(IHEL)) THEN
              GOODHEL(IHEL)=.TRUE.
            ENDIF
          ENDIF
        ENDIF
      ENDDO

C...VINCIA: Only normalise by Bose factor if doing full colour
      IF (MCMODE.EQ.2) ANS=ANS/DBLE(IDEN)
      IF(USERHEL.NE.-1) THEN
C...Cancel helicity-averaging factor when doing helicity amplitudes
        ANS=ANS*HELAVGFACTOR
      ELSE
        DO J=1,NINITIAL
          IF (POLARIZATIONS(J,0).NE.-1) THEN
C...Cancel helicity-averaging factor when doing helicity amplitudes
            ANS=ANS*BEAMS_HELAVGFACTOR(J)
      
C...VINCIA: Only normalise by Bose factor if doing full colour
      IF (MCMODE.EQ.2) ANS=ANS/POLARIZATIONS(J,0)
          ENDIF
        ENDDO
      ENDIF
      END


      DOUBLE PRECISION FUNCTION ug_dxdugg(MCMODE,ICOL,P,NHEL,IC)
C     
C     Generated by MadGraph5_aMC@NLO v. 2.4.2, 2016-06-10
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C     
C     Returns amplitude squared summed/avg over colors
C     for the point with external lines W(0:6,NEXTERNAL)
C     
C     Process: u g > d~ d u g g WEIGHTED<=5 @220
C     Process: s g > d~ d s g g WEIGHTED<=5 @220
C     Process: s g > u~ u s g g WEIGHTED<=5 @220
C     Process: c g > d~ d c g g WEIGHTED<=5 @220
C     Process: c g > u~ u c g g WEIGHTED<=5 @220
C     Process: c g > s~ s c g g WEIGHTED<=5 @220
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=393)
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=7)
      INTEGER    NWAVEFUNCS, NCOLOR
      PARAMETER (NWAVEFUNCS=66, NCOLOR=48)
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
      DOUBLE PRECISION ZLCSUM, FSLC
      COMPLEX*16 IMAG1
      PARAMETER (IMAG1=(0D0,1D0))
C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION P(0:3,NEXTERNAL)
C...VINCIA: Define MCMODE and ICOL variables
C...  MCMODE = 0 : Leading Colour = LC[icol]
C...  MCMODE = 1 : Vincia Colour  = FC * LC[icol]/sum(LC)
C...  MCMODE = 2 : Full Colour    = FC (-> normal MG mode)
      INTEGER MCMODE, ICOL
      INTEGER NHEL(NEXTERNAL), IC(NEXTERNAL)
C     
C     LOCAL VARIABLES 
C     
      INTEGER I,J
      COMPLEX*16 ZTEMP
      DOUBLE PRECISION DENOM(NCOLOR), CF(NCOLOR,NCOLOR)
      COMPLEX*16 AMP(NGRAPHS), JAMP(NCOLOR)
      COMPLEX*16 W(20,NWAVEFUNCS)
      COMPLEX*16 DUM0,DUM1
      DATA DUM0, DUM1/(0D0, 0D0), (1D0, 0D0)/
C     
C     GLOBAL VARIABLES
C     
      INCLUDE 'coupl.inc'

C     
C     COLOR DATA
C     
      DATA DENOM(1)/9/
      DATA (CF(I,  1),I=  1,  6) /  192,  -24,   64,   -8,   64,   -8/
      DATA (CF(I,  1),I=  7, 12) /   21,   -6,    0,   -8,   -8,   -3/
      DATA (CF(I,  1),I= 13, 18) /   24,   64,    1,    0,    0,   64/
      DATA (CF(I,  1),I= 19, 24) /    1,   24,   24,   -8,   10,    0/
      DATA (CF(I,  1),I= 25, 30) /    0,    0,    0,    0,   -8,   64/
      DATA (CF(I,  1),I= 31, 36) /    1,   -8,   -8,    1,    1,   10/
      DATA (CF(I,  1),I= 37, 42) /   -3,   24,   -3,   24,    0,    1/
      DATA (CF(I,  1),I= 43, 48) /   64,   24,   -3,   -8,   -8,    0/
C     1 T(2,4,1) T(6,7,5,3)
      DATA DENOM(2)/9/
      DATA (CF(I,  2),I=  1,  6) /  -24,  192,   -8,   64,   -8,   64/
      DATA (CF(I,  2),I=  7, 12) /   -6,   21,    0,   64,    1,   24/
      DATA (CF(I,  2),I= 13, 18) /   24,   -8,   10,    0,    0,   -8/
      DATA (CF(I,  2),I= 19, 24) /   -8,   -3,   24,   64,    1,    0/
      DATA (CF(I,  2),I= 25, 30) /    0,    0,    0,    0,    1,   -8/
      DATA (CF(I,  2),I= 31, 36) /   -8,   64,    1,   10,   -8,    1/
      DATA (CF(I,  2),I= 37, 42) /   -3,   24,   -3,   24,    0,   -8/
      DATA (CF(I,  2),I= 43, 48) /   -8,   -3,   24,   64,    1,    0/
C     1 T(2,4,1) T(7,6,5,3)
      DATA DENOM(3)/9/
      DATA (CF(I,  3),I=  1,  6) /   64,   -8,  192,  -24,   21,   -6/
      DATA (CF(I,  3),I=  7, 12) /   64,   -8,   -8,    0,   -3,   -8/
      DATA (CF(I,  3),I= 13, 18) /   64,   24,    0,    1,   64,    0/
      DATA (CF(I,  3),I= 19, 24) /   24,    1,   -8,   24,    0,   10/
      DATA (CF(I,  3),I= 25, 30) /   -8,   64,    1,   -8,    0,    0/
      DATA (CF(I,  3),I= 31, 36) /    0,    0,   -3,   24,   -3,   24/
      DATA (CF(I,  3),I= 37, 42) /   -8,    1,    1,   10,    1,    0/
      DATA (CF(I,  3),I= 43, 48) /   24,   64,   -8,   -3,    0,   -8/
C     1 T(2,4,3) T(6,7,5,1)
      DATA DENOM(4)/9/
      DATA (CF(I,  4),I=  1,  6) /   -8,   64,  -24,  192,   -6,   21/
      DATA (CF(I,  4),I=  7, 12) /   -8,   64,   64,    0,   24,    1/
      DATA (CF(I,  4),I= 13, 18) /   -8,   24,    0,   10,   -8,    0/
      DATA (CF(I,  4),I= 19, 24) /   -3,   -8,   64,   24,    0,    1/
      DATA (CF(I,  4),I= 25, 30) /    1,   -8,   -8,   64,    0,    0/
      DATA (CF(I,  4),I= 31, 36) /    0,    0,   -3,   24,   -3,   24/
      DATA (CF(I,  4),I= 37, 42) /    1,   10,   -8,    1,   -8,    0/
      DATA (CF(I,  4),I= 43, 48) /   -3,   -8,   64,   24,    0,    1/
C     1 T(2,4,3) T(7,6,5,1)
      DATA DENOM(5)/9/
      DATA (CF(I,  5),I=  1,  6) /   64,   -8,   21,   -6,  192,  -24/
      DATA (CF(I,  5),I=  7, 12) /   64,   -8,   -8,   -3,    0,   -8/
      DATA (CF(I,  5),I= 13, 18) /    1,    0,   24,   64,    1,   24/
      DATA (CF(I,  5),I= 19, 24) /    0,   64,   10,    0,   24,   -8/
      DATA (CF(I,  5),I= 25, 30) /   -8,    1,    1,   10,   -3,   24/
      DATA (CF(I,  5),I= 31, 36) /   -3,   24,    0,    0,    0,    0/
      DATA (CF(I,  5),I= 37, 42) /   -8,   64,    1,   -8,   64,   24/
      DATA (CF(I,  5),I= 43, 48) /    0,    1,   -8,    0,   -3,   -8/
C     1 T(2,5,1) T(6,7,4,3)
      DATA DENOM(6)/9/
      DATA (CF(I,  6),I=  1,  6) /   -8,   64,   -6,   21,  -24,  192/
      DATA (CF(I,  6),I=  7, 12) /   -8,   64,    1,   24,    0,   64/
      DATA (CF(I,  6),I= 13, 18) /   10,    0,   24,   -8,   -8,   -3/
      DATA (CF(I,  6),I= 19, 24) /    0,   -8,    1,    0,   24,   64/
      DATA (CF(I,  6),I= 25, 30) /    1,   10,   -8,    1,   -3,   24/
      DATA (CF(I,  6),I= 31, 36) /   -3,   24,    0,    0,    0,    0/
      DATA (CF(I,  6),I= 37, 42) /    1,   -8,   -8,   64,   -8,   -3/
      DATA (CF(I,  6),I= 43, 48) /    0,   -8,    1,    0,   24,   64/
C     1 T(2,5,1) T(7,6,4,3)
      DATA DENOM(7)/9/
      DATA (CF(I,  7),I=  1,  6) /   21,   -6,   64,   -8,   64,   -8/
      DATA (CF(I,  7),I=  7, 12) /  192,  -24,   -3,   -8,   -8,    0/
      DATA (CF(I,  7),I= 13, 18) /    0,    1,   64,   24,   24,    1/
      DATA (CF(I,  7),I= 19, 24) /   64,    0,    0,   10,   -8,   24/
      DATA (CF(I,  7),I= 25, 30) /   -3,   24,   -3,   24,   -8,    1/
      DATA (CF(I,  7),I= 31, 36) /    1,   10,   -8,   64,    1,   -8/
      DATA (CF(I,  7),I= 37, 42) /    0,    0,    0,    0,   24,   64/
      DATA (CF(I,  7),I= 43, 48) /    1,    0,    0,   -8,   -8,   -3/
C     1 T(2,5,3) T(6,7,4,1)
      DATA DENOM(8)/9/
      DATA (CF(I,  8),I=  1,  6) /   -6,   21,   -8,   64,   -8,   64/
      DATA (CF(I,  8),I=  7, 12) /  -24,  192,   24,    1,   64,    0/
      DATA (CF(I,  8),I= 13, 18) /    0,   10,   -8,   24,   -3,   -8/
      DATA (CF(I,  8),I= 19, 24) /   -8,    0,    0,    1,   64,   24/
      DATA (CF(I,  8),I= 25, 30) /   -3,   24,   -3,   24,    1,   10/
      DATA (CF(I,  8),I= 31, 36) /   -8,    1,    1,   -8,   -8,   64/
      DATA (CF(I,  8),I= 37, 42) /    0,    0,    0,    0,   -3,   -8/
      DATA (CF(I,  8),I= 43, 48) /   -8,    0,    0,    1,   64,   24/
C     1 T(2,5,3) T(7,6,4,1)
      DATA DENOM(9)/9/
      DATA (CF(I,  9),I=  1,  6) /    0,    0,   -8,   64,   -8,    1/
      DATA (CF(I,  9),I=  7, 12) /   -3,   24,  192,   64,   64,   21/
      DATA (CF(I,  9),I= 13, 18) /    0,   64,    1,   24,   24,   64/
      DATA (CF(I,  9),I= 19, 24) /    1,    0,    0,   -8,   -8,   -3/
      DATA (CF(I,  9),I= 25, 30) /   24,   -3,   24,   24,   10,    1/
      DATA (CF(I,  9),I= 31, 36) /   64,   -8,   -8,    1,    1,   10/
      DATA (CF(I,  9),I= 37, 42) /    0,    0,    0,    0,  -24,   -8/
      DATA (CF(I,  9),I= 43, 48) /   -8,   -6,    0,   -8,   -8,   -3/
C     1 T(2,6,4,1) T(7,5,3)
      DATA DENOM(10)/9/
      DATA (CF(I, 10),I=  1,  6) /   -8,   64,    0,    0,   -3,   24/
      DATA (CF(I, 10),I=  7, 12) /   -8,    1,   64,  192,   21,   64/
      DATA (CF(I, 10),I= 13, 18) /   64,    0,   24,    1,   64,   24/
      DATA (CF(I, 10),I= 19, 24) /    0,    1,   -8,    0,   -3,   -8/
      DATA (CF(I, 10),I= 25, 30) /   10,    1,   64,   -8,   24,   -3/
      DATA (CF(I, 10),I= 31, 36) /   24,   24,    0,    0,    0,    0/
      DATA (CF(I, 10),I= 37, 42) /   -8,    1,    1,   10,   -8,  -24/
      DATA (CF(I, 10),I= 43, 48) /   -6,   -8,   -8,    0,   -3,   -8/
C     1 T(2,6,4,3) T(7,5,1)
      DATA DENOM(11)/9/
      DATA (CF(I, 11),I=  1,  6) /   -8,    1,   -3,   24,    0,    0/
      DATA (CF(I, 11),I=  7, 12) /   -8,   64,   64,   21,  192,   64/
      DATA (CF(I, 11),I= 13, 18) /    1,   24,    0,   64,    1,    0/
      DATA (CF(I, 11),I= 19, 24) /   24,   64,   -8,   -3,    0,   -8/
      DATA (CF(I, 11),I= 25, 30) /   -8,    1,    1,   10,    0,    0/
      DATA (CF(I, 11),I= 31, 36) /    0,    0,   24,   -3,   24,   24/
      DATA (CF(I, 11),I= 37, 42) /   10,    1,   64,   -8,   -8,   -6/
      DATA (CF(I, 11),I= 43, 48) /  -24,   -8,   -8,   -3,    0,   -8/
C     1 T(2,6,5,1) T(7,4,3)
      DATA DENOM(12)/9/
      DATA (CF(I, 12),I=  1,  6) /   -3,   24,   -8,    1,   -8,   64/
      DATA (CF(I, 12),I=  7, 12) /    0,    0,   21,   64,   64,  192/
      DATA (CF(I, 12),I= 13, 18) /   24,    1,   64,    0,    0,    1/
      DATA (CF(I, 12),I= 19, 24) /   64,   24,   -3,   -8,   -8,    0/
      DATA (CF(I, 12),I= 25, 30) /    0,    0,    0,    0,   -8,    1/
      DATA (CF(I, 12),I= 31, 36) /    1,   10,   10,    1,   64,   -8/
      DATA (CF(I, 12),I= 37, 42) /   24,   -3,   24,   24,   -6,   -8/
      DATA (CF(I, 12),I= 43, 48) /   -8,  -24,   -3,   -8,   -8,    0/
C     1 T(2,6,5,3) T(7,4,1)
      DATA DENOM(13)/9/
      DATA (CF(I, 13),I=  1,  6) /   24,   24,   64,   -8,    1,   10/
      DATA (CF(I, 13),I=  7, 12) /    0,    0,    0,   64,    1,   24/
      DATA (CF(I, 13),I= 13, 18) /  192,   64,   64,   21,    0,   -8/
      DATA (CF(I, 13),I= 19, 24) /   -8,   -3,  -24,   -8,   -8,   -6/
      DATA (CF(I, 13),I= 25, 30) /   -6,   21,   21,   -6,   -8,    1/
      DATA (CF(I, 13),I= 31, 36) /    1,   10,   -8,    1,    1,   10/
      DATA (CF(I, 13),I= 37, 42) /  -24,    3,    3,   30,    0,   -8/
      DATA (CF(I, 13),I= 43, 48) /   10,   24,   -3,    1,    1,    0/
C     1 T(2,6,7,4,1) T(5,3)
      DATA DENOM(14)/9/
      DATA (CF(I, 14),I=  1,  6) /   64,   -8,   24,   24,    0,    0/
      DATA (CF(I, 14),I=  7, 12) /    1,   10,   64,    0,   24,    1/
      DATA (CF(I, 14),I= 13, 18) /   64,  192,   21,   64,   -8,    0/
      DATA (CF(I, 14),I= 19, 24) /   -3,   -8,   -8,  -24,   -6,   -8/
      DATA (CF(I, 14),I= 25, 30) /   -8,    1,    1,   10,   -6,   21/
      DATA (CF(I, 14),I= 31, 36) /   21,   -6,  -24,    3,    3,   30/
      DATA (CF(I, 14),I= 37, 42) /   -8,    1,    1,   10,   -8,    0/
      DATA (CF(I, 14),I= 43, 48) /   24,   10,    1,   -3,    0,    1/
C     1 T(2,6,7,4,3) T(5,1)
      DATA DENOM(15)/9/
      DATA (CF(I, 15),I=  1,  6) /    1,   10,    0,    0,   24,   24/
      DATA (CF(I, 15),I=  7, 12) /   64,   -8,    1,   24,    0,   64/
      DATA (CF(I, 15),I= 13, 18) /   64,   21,  192,   64,   -8,   -3/
      DATA (CF(I, 15),I= 19, 24) /    0,   -8,   -8,   -6,  -24,   -8/
      DATA (CF(I, 15),I= 25, 30) /   -8,    1,    1,   10,  -24,    3/
      DATA (CF(I, 15),I= 31, 36) /    3,   30,   -6,   21,   21,   -6/
      DATA (CF(I, 15),I= 37, 42) /   -8,    1,    1,   10,   10,   24/
      DATA (CF(I, 15),I= 43, 48) /    0,   -8,    1,    0,   -3,    1/
C     1 T(2,6,7,5,1) T(4,3)
      DATA DENOM(16)/9/
      DATA (CF(I, 16),I=  1,  6) /    0,    0,    1,   10,   64,   -8/
      DATA (CF(I, 16),I=  7, 12) /   24,   24,   24,    1,   64,    0/
      DATA (CF(I, 16),I= 13, 18) /   21,   64,   64,  192,   -3,   -8/
      DATA (CF(I, 16),I= 19, 24) /   -8,    0,   -6,   -8,   -8,  -24/
      DATA (CF(I, 16),I= 25, 30) /  -24,    3,    3,   30,   -8,    1/
      DATA (CF(I, 16),I= 31, 36) /    1,   10,   -8,    1,    1,   10/
      DATA (CF(I, 16),I= 37, 42) /   -6,   21,   21,   -6,   24,   10/
      DATA (CF(I, 16),I= 43, 48) /   -8,    0,    0,    1,    1,   -3/
C     1 T(2,6,7,5,3) T(4,1)
      DATA DENOM(17)/9/
      DATA (CF(I, 17),I=  1,  6) /    0,    0,   64,   -8,    1,   -8/
      DATA (CF(I, 17),I=  7, 12) /   24,   -3,   24,   64,    1,    0/
      DATA (CF(I, 17),I= 13, 18) /    0,   -8,   -8,   -3,  192,   64/
      DATA (CF(I, 17),I= 19, 24) /   64,   21,    0,   64,    1,   24/
      DATA (CF(I, 17),I= 25, 30) /   24,   24,   24,   -3,   64,   -8/
      DATA (CF(I, 17),I= 31, 36) /   10,    1,    1,   10,   -8,    1/
      DATA (CF(I, 17),I= 37, 42) /    0,    0,    0,    0,   -3,   -8/
      DATA (CF(I, 17),I= 43, 48) /   -8,    0,   -6,   -8,   -8,  -24/
C     1 T(2,7,4,1) T(6,5,3)
      DATA DENOM(18)/9/
      DATA (CF(I, 18),I=  1,  6) /   64,   -8,    0,    0,   24,   -3/
      DATA (CF(I, 18),I=  7, 12) /    1,   -8,   64,   24,    0,    1/
      DATA (CF(I, 18),I= 13, 18) /   -8,    0,   -3,   -8,   64,  192/
      DATA (CF(I, 18),I= 19, 24) /   21,   64,   64,    0,   24,    1/
      DATA (CF(I, 18),I= 25, 30) /   64,   -8,   10,    1,   24,   24/
      DATA (CF(I, 18),I= 31, 36) /   24,   -3,    0,    0,    0,    0/
      DATA (CF(I, 18),I= 37, 42) /    1,   10,   -8,    1,   -8,   -3/
      DATA (CF(I, 18),I= 43, 48) /    0,   -8,   -8,   -6,  -24,   -8/
C     1 T(2,7,4,3) T(6,5,1)
      DATA DENOM(19)/9/
      DATA (CF(I, 19),I=  1,  6) /    1,   -8,   24,   -3,    0,    0/
      DATA (CF(I, 19),I=  7, 12) /   64,   -8,    1,    0,   24,   64/
      DATA (CF(I, 19),I= 13, 18) /   -8,   -3,    0,   -8,   64,   21/
      DATA (CF(I, 19),I= 19, 24) /  192,   64,    1,   24,    0,   64/
      DATA (CF(I, 19),I= 25, 30) /    1,   10,   -8,    1,    0,    0/
      DATA (CF(I, 19),I= 31, 36) /    0,    0,   24,   24,   24,   -3/
      DATA (CF(I, 19),I= 37, 42) /   64,   -8,   10,    1,   -8,    0/
      DATA (CF(I, 19),I= 43, 48) /   -3,   -8,   -8,  -24,   -6,   -8/
C     1 T(2,7,5,1) T(6,4,3)
      DATA DENOM(20)/9/
      DATA (CF(I, 20),I=  1,  6) /   24,   -3,    1,   -8,   64,   -8/
      DATA (CF(I, 20),I=  7, 12) /    0,    0,    0,    1,   64,   24/
      DATA (CF(I, 20),I= 13, 18) /   -3,   -8,   -8,    0,   21,   64/
      DATA (CF(I, 20),I= 19, 24) /   64,  192,   24,    1,   64,    0/
      DATA (CF(I, 20),I= 25, 30) /    0,    0,    0,    0,    1,   10/
      DATA (CF(I, 20),I= 31, 36) /   -8,    1,   64,   -8,   10,    1/
      DATA (CF(I, 20),I= 37, 42) /   24,   24,   24,   -3,    0,   -8/
      DATA (CF(I, 20),I= 43, 48) /   -8,   -3,  -24,   -8,   -8,   -6/
C     1 T(2,7,5,3) T(6,4,1)
      DATA DENOM(21)/9/
      DATA (CF(I, 21),I=  1,  6) /   24,   24,   -8,   64,   10,    1/
      DATA (CF(I, 21),I=  7, 12) /    0,    0,    0,   -8,   -8,   -3/
      DATA (CF(I, 21),I= 13, 18) /  -24,   -8,   -8,   -6,    0,   64/
      DATA (CF(I, 21),I= 19, 24) /    1,   24,  192,   64,   64,   21/
      DATA (CF(I, 21),I= 25, 30) /   21,   -6,   -6,   21,    1,   10/
      DATA (CF(I, 21),I= 31, 36) /   -8,    1,    1,   10,   -8,    1/
      DATA (CF(I, 21),I= 37, 42) /    3,   30,  -24,    3,    0,    1/
      DATA (CF(I, 21),I= 43, 48) /    1,   -3,   24,   10,   -8,    0/
C     1 T(2,7,6,4,1) T(5,3)
      DATA DENOM(22)/9/
      DATA (CF(I, 22),I=  1,  6) /   -8,   64,   24,   24,    0,    0/
      DATA (CF(I, 22),I=  7, 12) /   10,    1,   -8,    0,   -3,   -8/
      DATA (CF(I, 22),I= 13, 18) /   -8,  -24,   -6,   -8,   64,    0/
      DATA (CF(I, 22),I= 19, 24) /   24,    1,   64,  192,   21,   64/
      DATA (CF(I, 22),I= 25, 30) /    1,   10,   -8,    1,   21,   -6/
      DATA (CF(I, 22),I= 31, 36) /   -6,   21,    3,   30,  -24,    3/
      DATA (CF(I, 22),I= 37, 42) /    1,   10,   -8,    1,    1,    0/
      DATA (CF(I, 22),I= 43, 48) /   -3,    1,   10,   24,    0,   -8/
C     1 T(2,7,6,4,3) T(5,1)
      DATA DENOM(23)/9/
      DATA (CF(I, 23),I=  1,  6) /   10,    1,    0,    0,   24,   24/
      DATA (CF(I, 23),I=  7, 12) /   -8,   64,   -8,   -3,    0,   -8/
      DATA (CF(I, 23),I= 13, 18) /   -8,   -6,  -24,   -8,    1,   24/
      DATA (CF(I, 23),I= 19, 24) /    0,   64,   64,   21,  192,   64/
      DATA (CF(I, 23),I= 25, 30) /    1,   10,   -8,    1,    3,   30/
      DATA (CF(I, 23),I= 31, 36) /  -24,    3,   21,   -6,   -6,   21/
      DATA (CF(I, 23),I= 37, 42) /    1,   10,   -8,    1,    1,   -3/
      DATA (CF(I, 23),I= 43, 48) /    0,    1,   -8,    0,   24,   10/
C     1 T(2,7,6,5,1) T(4,3)
      DATA DENOM(24)/9/
      DATA (CF(I, 24),I=  1,  6) /    0,    0,   10,    1,   -8,   64/
      DATA (CF(I, 24),I=  7, 12) /   24,   24,   -3,   -8,   -8,    0/
      DATA (CF(I, 24),I= 13, 18) /   -6,   -8,   -8,  -24,   24,    1/
      DATA (CF(I, 24),I= 19, 24) /   64,    0,   21,   64,   64,  192/
      DATA (CF(I, 24),I= 25, 30) /    3,   30,  -24,    3,    1,   10/
      DATA (CF(I, 24),I= 31, 36) /   -8,    1,    1,   10,   -8,    1/
      DATA (CF(I, 24),I= 37, 42) /   21,   -6,   -6,   21,   -3,    1/
      DATA (CF(I, 24),I= 43, 48) /    1,    0,    0,   -8,   10,   24/
C     1 T(2,7,6,5,3) T(4,1)
      DATA DENOM(25)/9/
      DATA (CF(I, 25),I=  1,  6) /    0,    0,   -8,    1,   -8,    1/
      DATA (CF(I, 25),I=  7, 12) /   -3,   -3,   24,   10,   -8,    0/
      DATA (CF(I, 25),I= 13, 18) /   -6,   -8,   -8,  -24,   24,   64/
      DATA (CF(I, 25),I= 19, 24) /    1,    0,   21,    1,    1,    3/
      DATA (CF(I, 25),I= 25, 30) /  192,  -24,   30,    3,   64,   -8/
      DATA (CF(I, 25),I= 31, 36) /   10,    1,   64,   -8,   10,    1/
      DATA (CF(I, 25),I= 37, 42) /   21,   -6,   -6,   21,   24,    1/
      DATA (CF(I, 25),I= 43, 48) /   64,    0,    0,   10,   -8,   24/
C     1 T(4,1) T(6,2,7,5,3)
      DATA DENOM(26)/9/
      DATA (CF(I, 26),I=  1,  6) /    0,    0,   64,   -8,    1,   10/
      DATA (CF(I, 26),I=  7, 12) /   24,   24,   -3,    1,    1,    0/
      DATA (CF(I, 26),I= 13, 18) /   21,    1,    1,    3,   24,   -8/
      DATA (CF(I, 26),I= 19, 24) /   10,    0,   -6,   10,   10,   30/
      DATA (CF(I, 26),I= 25, 30) /  -24,  192,    3,  -24,   -8,   64/
      DATA (CF(I, 26),I= 31, 36) /    1,   -8,   -8,   64,    1,   -8/
      DATA (CF(I, 26),I= 37, 42) /   -6,   21,   21,   -6,   -3,   -8/
      DATA (CF(I, 26),I= 43, 48) /   -8,    0,    0,    1,   64,   24/
C     1 T(4,1) T(6,7,2,5,3)
      DATA DENOM(27)/9/
      DATA (CF(I, 27),I=  1,  6) /    0,    0,    1,   -8,    1,   -8/
      DATA (CF(I, 27),I=  7, 12) /   -3,   -3,   24,   64,    1,    0/
      DATA (CF(I, 27),I= 13, 18) /   21,    1,    1,    3,   24,   10/
      DATA (CF(I, 27),I= 19, 24) /   -8,    0,   -6,   -8,   -8,  -24/
      DATA (CF(I, 27),I= 25, 30) /   30,    3,  192,  -24,   10,    1/
      DATA (CF(I, 27),I= 31, 36) /   64,   -8,   10,    1,   64,   -8/
      DATA (CF(I, 27),I= 37, 42) /   -6,   21,   21,   -6,   24,   -8/
      DATA (CF(I, 27),I= 43, 48) /   10,    0,    0,   64,    1,   24/
C     1 T(4,1) T(7,2,6,5,3)
      DATA DENOM(28)/9/
      DATA (CF(I, 28),I=  1,  6) /    0,    0,   -8,   64,   10,    1/
      DATA (CF(I, 28),I=  7, 12) /   24,   24,   24,   -8,   10,    0/
      DATA (CF(I, 28),I= 13, 18) /   -6,   10,   10,   30,   -3,    1/
      DATA (CF(I, 28),I= 19, 24) /    1,    0,   21,    1,    1,    3/
      DATA (CF(I, 28),I= 25, 30) /    3,  -24,  -24,  192,    1,   -8/
      DATA (CF(I, 28),I= 31, 36) /   -8,   64,    1,   -8,   -8,   64/
      DATA (CF(I, 28),I= 37, 42) /   21,   -6,   -6,   21,   24,   64/
      DATA (CF(I, 28),I= 43, 48) /    1,    0,    0,   -8,   -8,   -3/
C     1 T(4,1) T(7,6,2,5,3)
      DATA DENOM(29)/9/
      DATA (CF(I, 29),I=  1,  6) /   -8,    1,    0,    0,   -3,   -3/
      DATA (CF(I, 29),I=  7, 12) /   -8,    1,   10,   24,    0,   -8/
      DATA (CF(I, 29),I= 13, 18) /   -8,   -6,  -24,   -8,   64,   24/
      DATA (CF(I, 29),I= 19, 24) /    0,    1,    1,   21,    3,    1/
      DATA (CF(I, 29),I= 25, 30) /   64,   -8,   10,    1,  192,  -24/
      DATA (CF(I, 29),I= 31, 36) /   30,    3,   21,   -6,   -6,   21/
      DATA (CF(I, 29),I= 37, 42) /   64,   -8,   10,    1,    1,   24/
      DATA (CF(I, 29),I= 43, 48) /    0,   64,   10,    0,   24,   -8/
C     1 T(4,3) T(6,2,7,5,1)
      DATA DENOM(30)/9/
      DATA (CF(I, 30),I=  1,  6) /   64,   -8,    0,    0,   24,   24/
      DATA (CF(I, 30),I=  7, 12) /    1,   10,    1,   -3,    0,    1/
      DATA (CF(I, 30),I= 13, 18) /    1,   21,    3,    1,   -8,   24/
      DATA (CF(I, 30),I= 19, 24) /    0,   10,   10,   -6,   30,   10/
      DATA (CF(I, 30),I= 25, 30) /   -8,   64,    1,   -8,  -24,  192/
      DATA (CF(I, 30),I= 31, 36) /    3,  -24,   -6,   21,   21,   -6/
      DATA (CF(I, 30),I= 37, 42) /   -8,   64,    1,   -8,   -8,   -3/
      DATA (CF(I, 30),I= 43, 48) /    0,   -8,    1,    0,   24,   64/
C     1 T(4,3) T(6,7,2,5,1)
      DATA DENOM(31)/9/
      DATA (CF(I, 31),I=  1,  6) /    1,   -8,    0,    0,   -3,   -3/
      DATA (CF(I, 31),I=  7, 12) /    1,   -8,   64,   24,    0,    1/
      DATA (CF(I, 31),I= 13, 18) /    1,   21,    3,    1,   10,   24/
      DATA (CF(I, 31),I= 19, 24) /    0,   -8,   -8,   -6,  -24,   -8/
      DATA (CF(I, 31),I= 25, 30) /   10,    1,   64,   -8,   30,    3/
      DATA (CF(I, 31),I= 31, 36) /  192,  -24,   -6,   21,   21,   -6/
      DATA (CF(I, 31),I= 37, 42) /   10,    1,   64,   -8,   -8,   24/
      DATA (CF(I, 31),I= 43, 48) /    0,   10,   64,    0,   24,    1/
C     1 T(4,3) T(7,2,6,5,1)
      DATA DENOM(32)/9/
      DATA (CF(I, 32),I=  1,  6) /   -8,   64,    0,    0,   24,   24/
      DATA (CF(I, 32),I=  7, 12) /   10,    1,   -8,   24,    0,   10/
      DATA (CF(I, 32),I= 13, 18) /   10,   -6,   30,   10,    1,   -3/
      DATA (CF(I, 32),I= 19, 24) /    0,    1,    1,   21,    3,    1/
      DATA (CF(I, 32),I= 25, 30) /    1,   -8,   -8,   64,    3,  -24/
      DATA (CF(I, 32),I= 31, 36) /  -24,  192,   21,   -6,   -6,   21/
      DATA (CF(I, 32),I= 37, 42) /    1,   -8,   -8,   64,   64,   24/
      DATA (CF(I, 32),I= 43, 48) /    0,    1,   -8,    0,   -3,   -8/
C     1 T(4,3) T(7,6,2,5,1)
      DATA DENOM(33)/9/
      DATA (CF(I, 33),I=  1,  6) /   -8,    1,   -3,   -3,    0,    0/
      DATA (CF(I, 33),I=  7, 12) /   -8,    1,   -8,    0,   24,   10/
      DATA (CF(I, 33),I= 13, 18) /   -8,  -24,   -6,   -8,    1,    0/
      DATA (CF(I, 33),I= 19, 24) /   24,   64,    1,    3,   21,    1/
      DATA (CF(I, 33),I= 25, 30) /   64,   -8,   10,    1,   21,   -6/
      DATA (CF(I, 33),I= 31, 36) /   -6,   21,  192,  -24,   30,    3/
      DATA (CF(I, 33),I= 37, 42) /   64,   -8,   10,    1,   64,    0/
      DATA (CF(I, 33),I= 43, 48) /   24,    1,   -8,   24,    0,   10/
C     1 T(5,1) T(6,2,7,4,3)
      DATA DENOM(34)/9/
      DATA (CF(I, 34),I=  1,  6) /    1,   10,   24,   24,    0,    0/
      DATA (CF(I, 34),I=  7, 12) /   64,   -8,    1,    0,   -3,    1/
      DATA (CF(I, 34),I= 13, 18) /    1,    3,   21,    1,   10,    0/
      DATA (CF(I, 34),I= 19, 24) /   24,   -8,   10,   30,   -6,   10/
      DATA (CF(I, 34),I= 25, 30) /   -8,   64,    1,   -8,   -6,   21/
      DATA (CF(I, 34),I= 31, 36) /   21,   -6,  -24,  192,    3,  -24/
      DATA (CF(I, 34),I= 37, 42) /   -8,   64,    1,   -8,   -8,    0/
      DATA (CF(I, 34),I= 43, 48) /   -3,   -8,   64,   24,    0,    1/
C     1 T(5,1) T(6,7,2,4,3)
      DATA DENOM(35)/9/
      DATA (CF(I, 35),I=  1,  6) /    1,   -8,   -3,   -3,    0,    0/
      DATA (CF(I, 35),I=  7, 12) /    1,   -8,    1,    0,   24,   64/
      DATA (CF(I, 35),I= 13, 18) /    1,    3,   21,    1,   -8,    0/
      DATA (CF(I, 35),I= 19, 24) /   24,   10,   -8,  -24,   -6,   -8/
      DATA (CF(I, 35),I= 25, 30) /   10,    1,   64,   -8,   -6,   21/
      DATA (CF(I, 35),I= 31, 36) /   21,   -6,   30,    3,  192,  -24/
      DATA (CF(I, 35),I= 37, 42) /   10,    1,   64,   -8,   10,    0/
      DATA (CF(I, 35),I= 43, 48) /   24,   -8,    1,   24,    0,   64/
C     1 T(5,1) T(7,2,6,4,3)
      DATA DENOM(36)/9/
      DATA (CF(I, 36),I=  1,  6) /   10,    1,   24,   24,    0,    0/
      DATA (CF(I, 36),I=  7, 12) /   -8,   64,   10,    0,   24,   -8/
      DATA (CF(I, 36),I= 13, 18) /   10,   30,   -6,   10,    1,    0/
      DATA (CF(I, 36),I= 19, 24) /   -3,    1,    1,    3,   21,    1/
      DATA (CF(I, 36),I= 25, 30) /    1,   -8,   -8,   64,   21,   -6/
      DATA (CF(I, 36),I= 31, 36) /   -6,   21,    3,  -24,  -24,  192/
      DATA (CF(I, 36),I= 37, 42) /    1,   -8,   -8,   64,    1,    0/
      DATA (CF(I, 36),I= 43, 48) /   24,   64,   -8,   -3,    0,   -8/
C     1 T(5,1) T(7,6,2,4,3)
      DATA DENOM(37)/9/
      DATA (CF(I, 37),I=  1,  6) /   -3,   -3,   -8,    1,   -8,    1/
      DATA (CF(I, 37),I=  7, 12) /    0,    0,    0,   -8,   10,   24/
      DATA (CF(I, 37),I= 13, 18) /  -24,   -8,   -8,   -6,    0,    1/
      DATA (CF(I, 37),I= 19, 24) /   64,   24,    3,    1,    1,   21/
      DATA (CF(I, 37),I= 25, 30) /   21,   -6,   -6,   21,   64,   -8/
      DATA (CF(I, 37),I= 31, 36) /   10,    1,   64,   -8,   10,    1/
      DATA (CF(I, 37),I= 37, 42) /  192,  -24,   30,    3,    0,   64/
      DATA (CF(I, 37),I= 43, 48) /    1,   24,   24,   -8,   10,    0/
C     1 T(5,3) T(6,2,7,4,1)
      DATA DENOM(38)/9/
      DATA (CF(I, 38),I=  1,  6) /   24,   24,    1,   10,   64,   -8/
      DATA (CF(I, 38),I=  7, 12) /    0,    0,    0,    1,    1,   -3/
      DATA (CF(I, 38),I= 13, 18) /    3,    1,    1,   21,    0,   10/
      DATA (CF(I, 38),I= 19, 24) /   -8,   24,   30,   10,   10,   -6/
      DATA (CF(I, 38),I= 25, 30) /   -6,   21,   21,   -6,   -8,   64/
      DATA (CF(I, 38),I= 31, 36) /    1,   -8,   -8,   64,    1,   -8/
      DATA (CF(I, 38),I= 37, 42) /  -24,  192,    3,  -24,    0,   -8/
      DATA (CF(I, 38),I= 43, 48) /   -8,   -3,   24,   64,    1,    0/
C     1 T(5,3) T(6,7,2,4,1)
      DATA DENOM(39)/9/
      DATA (CF(I, 39),I=  1,  6) /   -3,   -3,    1,   -8,    1,   -8/
      DATA (CF(I, 39),I=  7, 12) /    0,    0,    0,    1,   64,   24/
      DATA (CF(I, 39),I= 13, 18) /    3,    1,    1,   21,    0,   -8/
      DATA (CF(I, 39),I= 19, 24) /   10,   24,  -24,   -8,   -8,   -6/
      DATA (CF(I, 39),I= 25, 30) /   -6,   21,   21,   -6,   10,    1/
      DATA (CF(I, 39),I= 31, 36) /   64,   -8,   10,    1,   64,   -8/
      DATA (CF(I, 39),I= 37, 42) /   30,    3,  192,  -24,    0,   10/
      DATA (CF(I, 39),I= 43, 48) /   -8,   24,   24,    1,   64,    0/
C     1 T(5,3) T(7,2,6,4,1)
      DATA DENOM(40)/9/
      DATA (CF(I, 40),I=  1,  6) /   24,   24,   10,    1,   -8,   64/
      DATA (CF(I, 40),I=  7, 12) /    0,    0,    0,   10,   -8,   24/
      DATA (CF(I, 40),I= 13, 18) /   30,   10,   10,   -6,    0,    1/
      DATA (CF(I, 40),I= 19, 24) /    1,   -3,    3,    1,    1,   21/
      DATA (CF(I, 40),I= 25, 30) /   21,   -6,   -6,   21,    1,   -8/
      DATA (CF(I, 40),I= 31, 36) /   -8,   64,    1,   -8,   -8,   64/
      DATA (CF(I, 40),I= 37, 42) /    3,  -24,  -24,  192,    0,    1/
      DATA (CF(I, 40),I= 43, 48) /   64,   24,   -3,   -8,   -8,    0/
C     1 T(5,3) T(7,6,2,4,1)
      DATA DENOM(41)/9/
      DATA (CF(I, 41),I=  1,  6) /    0,    0,    1,   -8,   64,   -8/
      DATA (CF(I, 41),I=  7, 12) /   24,   -3,  -24,   -8,   -8,   -6/
      DATA (CF(I, 41),I= 13, 18) /    0,   -8,   10,   24,   -3,   -8/
      DATA (CF(I, 41),I= 19, 24) /   -8,    0,    0,    1,    1,   -3/
      DATA (CF(I, 41),I= 25, 30) /   24,   -3,   24,   24,    1,   -8/
      DATA (CF(I, 41),I= 31, 36) /   -8,   64,   64,   -8,   10,    1/
      DATA (CF(I, 41),I= 37, 42) /    0,    0,    0,    0,  192,   64/
      DATA (CF(I, 41),I= 43, 48) /   64,   21,    0,   64,    1,   24/
C     1 T(6,2,4,1) T(7,5,3)
      DATA DENOM(42)/9/
      DATA (CF(I, 42),I=  1,  6) /    1,   -8,    0,    0,   24,   -3/
      DATA (CF(I, 42),I=  7, 12) /   64,   -8,   -8,  -24,   -6,   -8/
      DATA (CF(I, 42),I= 13, 18) /   -8,    0,   24,   10,   -8,   -3/
      DATA (CF(I, 42),I= 19, 24) /    0,   -8,    1,    0,   -3,    1/
      DATA (CF(I, 42),I= 25, 30) /    1,   -8,   -8,   64,   24,   -3/
      DATA (CF(I, 42),I= 31, 36) /   24,   24,    0,    0,    0,    0/
      DATA (CF(I, 42),I= 37, 42) /   64,   -8,   10,    1,   64,  192/
      DATA (CF(I, 42),I= 43, 48) /   21,   64,   64,    0,   24,    1/
C     1 T(6,2,4,3) T(7,5,1)
      DATA DENOM(43)/9/
      DATA (CF(I, 43),I=  1,  6) /   64,   -8,   24,   -3,    0,    0/
      DATA (CF(I, 43),I=  7, 12) /    1,   -8,   -8,   -6,  -24,   -8/
      DATA (CF(I, 43),I= 13, 18) /   10,   24,    0,   -8,   -8,    0/
      DATA (CF(I, 43),I= 19, 24) /   -3,   -8,    1,   -3,    0,    1/
      DATA (CF(I, 43),I= 25, 30) /   64,   -8,   10,    1,    0,    0/
      DATA (CF(I, 43),I= 31, 36) /    0,    0,   24,   -3,   24,   24/
      DATA (CF(I, 43),I= 37, 42) /    1,   -8,   -8,   64,   64,   21/
      DATA (CF(I, 43),I= 43, 48) /  192,   64,    1,   24,    0,   64/
C     1 T(6,2,5,1) T(7,4,3)
      DATA DENOM(44)/9/
      DATA (CF(I, 44),I=  1,  6) /   24,   -3,   64,   -8,    1,   -8/
      DATA (CF(I, 44),I=  7, 12) /    0,    0,   -6,   -8,   -8,  -24/
      DATA (CF(I, 44),I= 13, 18) /   24,   10,   -8,    0,    0,   -8/
      DATA (CF(I, 44),I= 19, 24) /   -8,   -3,   -3,    1,    1,    0/
      DATA (CF(I, 44),I= 25, 30) /    0,    0,    0,    0,   64,   -8/
      DATA (CF(I, 44),I= 31, 36) /   10,    1,    1,   -8,   -8,   64/
      DATA (CF(I, 44),I= 37, 42) /   24,   -3,   24,   24,   21,   64/
      DATA (CF(I, 44),I= 43, 48) /   64,  192,   24,    1,   64,    0/
C     1 T(6,2,5,3) T(7,4,1)
      DATA DENOM(45)/9/
      DATA (CF(I, 45),I=  1,  6) /   -3,   24,   -8,   64,   -8,    1/
      DATA (CF(I, 45),I=  7, 12) /    0,    0,    0,   -8,   -8,   -3/
      DATA (CF(I, 45),I= 13, 18) /   -3,    1,    1,    0,   -6,   -8/
      DATA (CF(I, 45),I= 19, 24) /   -8,  -24,   24,   10,   -8,    0/
      DATA (CF(I, 45),I= 25, 30) /    0,    0,    0,    0,   10,    1/
      DATA (CF(I, 45),I= 31, 36) /   64,   -8,   -8,   64,    1,   -8/
      DATA (CF(I, 45),I= 37, 42) /   24,   24,   24,   -3,    0,   64/
      DATA (CF(I, 45),I= 43, 48) /    1,   24,  192,   64,   64,   21/
C     1 T(6,4,1) T(7,2,5,3)
      DATA DENOM(46)/9/
      DATA (CF(I, 46),I=  1,  6) /   -8,   64,   -3,   24,    0,    0/
      DATA (CF(I, 46),I=  7, 12) /   -8,    1,   -8,    0,   -3,   -8/
      DATA (CF(I, 46),I= 13, 18) /    1,   -3,    0,    1,   -8,   -6/
      DATA (CF(I, 46),I= 19, 24) /  -24,   -8,   10,   24,    0,   -8/
      DATA (CF(I, 46),I= 25, 30) /   10,    1,   64,   -8,    0,    0/
      DATA (CF(I, 46),I= 31, 36) /    0,    0,   24,   24,   24,   -3/
      DATA (CF(I, 46),I= 37, 42) /   -8,   64,    1,   -8,   64,    0/
      DATA (CF(I, 46),I= 43, 48) /   24,    1,   64,  192,   21,   64/
C     1 T(6,4,3) T(7,2,5,1)
      DATA DENOM(47)/9/
      DATA (CF(I, 47),I=  1,  6) /   -8,    1,    0,    0,   -3,   24/
      DATA (CF(I, 47),I=  7, 12) /   -8,   64,   -8,   -3,    0,   -8/
      DATA (CF(I, 47),I= 13, 18) /    1,    0,   -3,    1,   -8,  -24/
      DATA (CF(I, 47),I= 19, 24) /   -6,   -8,   -8,    0,   24,   10/
      DATA (CF(I, 47),I= 25, 30) /   -8,   64,    1,   -8,   24,   24/
      DATA (CF(I, 47),I= 31, 36) /   24,   -3,    0,    0,    0,    0/
      DATA (CF(I, 47),I= 37, 42) /   10,    1,   64,   -8,    1,   24/
      DATA (CF(I, 47),I= 43, 48) /    0,   64,   64,   21,  192,   64/
C     1 T(6,5,1) T(7,2,4,3)
      DATA DENOM(48)/9/
      DATA (CF(I, 48),I=  1,  6) /    0,    0,   -8,    1,   -8,   64/
      DATA (CF(I, 48),I=  7, 12) /   -3,   24,   -3,   -8,   -8,    0/
      DATA (CF(I, 48),I= 13, 18) /    0,    1,    1,   -3,  -24,   -8/
      DATA (CF(I, 48),I= 19, 24) /   -8,   -6,    0,   -8,   10,   24/
      DATA (CF(I, 48),I= 25, 30) /   24,   24,   24,   -3,   -8,   64/
      DATA (CF(I, 48),I= 31, 36) /    1,   -8,   10,    1,   64,   -8/
      DATA (CF(I, 48),I= 37, 42) /    0,    0,    0,    0,   24,    1/
      DATA (CF(I, 48),I= 43, 48) /   64,    0,   21,   64,   64,  192/
C     1 T(6,5,3) T(7,2,4,1)
C     ----------
C     BEGIN CODE
C     ----------
      CALL IXXXXX(P(0,1),ZERO,NHEL(1),+1*IC(1),W(1,1))
      CALL VXXXXX(P(0,2),ZERO,NHEL(2),-1*IC(2),W(1,2))
      CALL IXXXXX(P(0,3),ZERO,NHEL(3),-1*IC(3),W(1,3))
      CALL OXXXXX(P(0,4),ZERO,NHEL(4),+1*IC(4),W(1,4))
      CALL OXXXXX(P(0,5),ZERO,NHEL(5),+1*IC(5),W(1,5))
      CALL VXXXXX(P(0,6),ZERO,NHEL(6),+1*IC(6),W(1,6))
      CALL VXXXXX(P(0,7),ZERO,NHEL(7),+1*IC(7),W(1,7))
      CALL FFV1_2(W(1,1),W(1,2),GC_11,ZERO,ZERO,W(1,8))
      CALL FFV1P0_3(W(1,3),W(1,4),GC_11,ZERO,ZERO,W(1,9))
      CALL FFV1P0_3(W(1,8),W(1,5),GC_11,ZERO,ZERO,W(1,10))
      CALL VVV1P0_1(W(1,9),W(1,6),GC_10,ZERO,ZERO,W(1,11))
C     Amplitude(s) for diagram number 1
      CALL VVV1_0(W(1,10),W(1,11),W(1,7),GC_10,AMP(1))
      CALL VVV1P0_1(W(1,9),W(1,7),GC_10,ZERO,ZERO,W(1,12))
C     Amplitude(s) for diagram number 2
      CALL VVV1_0(W(1,10),W(1,12),W(1,6),GC_10,AMP(2))
C     Amplitude(s) for diagram number 3
      CALL VVVV1_0(W(1,9),W(1,6),W(1,7),W(1,10),GC_12,AMP(3))
      CALL VVVV3_0(W(1,9),W(1,6),W(1,7),W(1,10),GC_12,AMP(4))
      CALL VVVV4_0(W(1,9),W(1,6),W(1,7),W(1,10),GC_12,AMP(5))
      CALL FFV1_2(W(1,8),W(1,6),GC_11,ZERO,ZERO,W(1,13))
      CALL FFV1_1(W(1,5),W(1,9),GC_11,ZERO,ZERO,W(1,14))
C     Amplitude(s) for diagram number 4
      CALL FFV1_0(W(1,13),W(1,14),W(1,7),GC_11,AMP(6))
C     Amplitude(s) for diagram number 5
      CALL FFV1_0(W(1,13),W(1,5),W(1,12),GC_11,AMP(7))
      CALL FFV1_2(W(1,8),W(1,7),GC_11,ZERO,ZERO,W(1,15))
C     Amplitude(s) for diagram number 6
      CALL FFV1_0(W(1,15),W(1,14),W(1,6),GC_11,AMP(8))
C     Amplitude(s) for diagram number 7
      CALL FFV1_0(W(1,15),W(1,5),W(1,11),GC_11,AMP(9))
      CALL FFV1_1(W(1,5),W(1,6),GC_11,ZERO,ZERO,W(1,16))
      CALL FFV1_2(W(1,8),W(1,9),GC_11,ZERO,ZERO,W(1,17))
C     Amplitude(s) for diagram number 8
      CALL FFV1_0(W(1,17),W(1,16),W(1,7),GC_11,AMP(10))
      CALL FFV1P0_3(W(1,8),W(1,16),GC_11,ZERO,ZERO,W(1,18))
C     Amplitude(s) for diagram number 9
      CALL VVV1_0(W(1,9),W(1,7),W(1,18),GC_10,AMP(11))
C     Amplitude(s) for diagram number 10
      CALL FFV1_0(W(1,15),W(1,16),W(1,9),GC_11,AMP(12))
      CALL FFV1_1(W(1,5),W(1,7),GC_11,ZERO,ZERO,W(1,19))
C     Amplitude(s) for diagram number 11
      CALL FFV1_0(W(1,17),W(1,19),W(1,6),GC_11,AMP(13))
      CALL FFV1P0_3(W(1,8),W(1,19),GC_11,ZERO,ZERO,W(1,20))
C     Amplitude(s) for diagram number 12
      CALL VVV1_0(W(1,9),W(1,6),W(1,20),GC_10,AMP(14))
C     Amplitude(s) for diagram number 13
      CALL FFV1_0(W(1,13),W(1,19),W(1,9),GC_11,AMP(15))
      CALL VVV1P0_1(W(1,6),W(1,7),GC_10,ZERO,ZERO,W(1,21))
C     Amplitude(s) for diagram number 14
      CALL FFV1_0(W(1,17),W(1,5),W(1,21),GC_11,AMP(16))
C     Amplitude(s) for diagram number 15
      CALL VVV1_0(W(1,9),W(1,21),W(1,10),GC_10,AMP(17))
      CALL FFV1_2(W(1,8),W(1,21),GC_11,ZERO,ZERO,W(1,17))
C     Amplitude(s) for diagram number 16
      CALL FFV1_0(W(1,17),W(1,5),W(1,9),GC_11,AMP(18))
      CALL FFV1_2(W(1,3),W(1,6),GC_11,ZERO,ZERO,W(1,17))
      CALL FFV1P0_3(W(1,17),W(1,4),GC_11,ZERO,ZERO,W(1,8))
C     Amplitude(s) for diagram number 17
      CALL VVV1_0(W(1,10),W(1,8),W(1,7),GC_10,AMP(19))
      CALL FFV1_2(W(1,17),W(1,7),GC_11,ZERO,ZERO,W(1,22))
C     Amplitude(s) for diagram number 18
      CALL FFV1_0(W(1,22),W(1,4),W(1,10),GC_11,AMP(20))
C     Amplitude(s) for diagram number 19
      CALL FFV1_0(W(1,15),W(1,5),W(1,8),GC_11,AMP(21))
      CALL FFV1_1(W(1,4),W(1,7),GC_11,ZERO,ZERO,W(1,23))
C     Amplitude(s) for diagram number 20
      CALL FFV1_0(W(1,17),W(1,23),W(1,10),GC_11,AMP(22))
C     Amplitude(s) for diagram number 21
      CALL FFV1_0(W(1,17),W(1,4),W(1,20),GC_11,AMP(23))
      CALL FFV1_2(W(1,3),W(1,7),GC_11,ZERO,ZERO,W(1,24))
      CALL FFV1P0_3(W(1,24),W(1,4),GC_11,ZERO,ZERO,W(1,25))
C     Amplitude(s) for diagram number 22
      CALL VVV1_0(W(1,10),W(1,25),W(1,6),GC_10,AMP(24))
      CALL FFV1_2(W(1,24),W(1,6),GC_11,ZERO,ZERO,W(1,26))
C     Amplitude(s) for diagram number 23
      CALL FFV1_0(W(1,26),W(1,4),W(1,10),GC_11,AMP(25))
C     Amplitude(s) for diagram number 24
      CALL FFV1_0(W(1,13),W(1,5),W(1,25),GC_11,AMP(26))
      CALL FFV1_1(W(1,4),W(1,6),GC_11,ZERO,ZERO,W(1,27))
C     Amplitude(s) for diagram number 25
      CALL FFV1_0(W(1,24),W(1,27),W(1,10),GC_11,AMP(27))
C     Amplitude(s) for diagram number 26
      CALL FFV1_0(W(1,24),W(1,4),W(1,18),GC_11,AMP(28))
      CALL FFV1P0_3(W(1,3),W(1,27),GC_11,ZERO,ZERO,W(1,28))
C     Amplitude(s) for diagram number 27
      CALL VVV1_0(W(1,10),W(1,28),W(1,7),GC_10,AMP(29))
      CALL FFV1_1(W(1,27),W(1,7),GC_11,ZERO,ZERO,W(1,29))
C     Amplitude(s) for diagram number 28
      CALL FFV1_0(W(1,3),W(1,29),W(1,10),GC_11,AMP(30))
C     Amplitude(s) for diagram number 29
      CALL FFV1_0(W(1,15),W(1,5),W(1,28),GC_11,AMP(31))
C     Amplitude(s) for diagram number 30
      CALL FFV1_0(W(1,3),W(1,27),W(1,20),GC_11,AMP(32))
      CALL FFV1P0_3(W(1,3),W(1,23),GC_11,ZERO,ZERO,W(1,20))
C     Amplitude(s) for diagram number 31
      CALL VVV1_0(W(1,10),W(1,20),W(1,6),GC_10,AMP(33))
      CALL FFV1_1(W(1,23),W(1,6),GC_11,ZERO,ZERO,W(1,15))
C     Amplitude(s) for diagram number 32
      CALL FFV1_0(W(1,3),W(1,15),W(1,10),GC_11,AMP(34))
C     Amplitude(s) for diagram number 33
      CALL FFV1_0(W(1,13),W(1,5),W(1,20),GC_11,AMP(35))
C     Amplitude(s) for diagram number 34
      CALL FFV1_0(W(1,3),W(1,23),W(1,18),GC_11,AMP(36))
      CALL FFV1_2(W(1,3),W(1,21),GC_11,ZERO,ZERO,W(1,18))
C     Amplitude(s) for diagram number 35
      CALL FFV1_0(W(1,18),W(1,4),W(1,10),GC_11,AMP(37))
      CALL FFV1_1(W(1,4),W(1,21),GC_11,ZERO,ZERO,W(1,13))
C     Amplitude(s) for diagram number 36
      CALL FFV1_0(W(1,3),W(1,13),W(1,10),GC_11,AMP(38))
      CALL FFV1P0_3(W(1,1),W(1,5),GC_11,ZERO,ZERO,W(1,10))
      CALL FFV1_2(W(1,3),W(1,2),GC_11,ZERO,ZERO,W(1,30))
      CALL FFV1_1(W(1,4),W(1,10),GC_11,ZERO,ZERO,W(1,31))
      CALL FFV1_2(W(1,30),W(1,6),GC_11,ZERO,ZERO,W(1,32))
C     Amplitude(s) for diagram number 37
      CALL FFV1_0(W(1,32),W(1,31),W(1,7),GC_11,AMP(39))
      CALL FFV1_2(W(1,30),W(1,7),GC_11,ZERO,ZERO,W(1,33))
C     Amplitude(s) for diagram number 38
      CALL FFV1_0(W(1,33),W(1,31),W(1,6),GC_11,AMP(40))
      CALL VVV1P0_1(W(1,10),W(1,6),GC_10,ZERO,ZERO,W(1,34))
      CALL FFV1P0_3(W(1,30),W(1,4),GC_11,ZERO,ZERO,W(1,35))
C     Amplitude(s) for diagram number 39
      CALL VVV1_0(W(1,34),W(1,35),W(1,7),GC_10,AMP(41))
C     Amplitude(s) for diagram number 40
      CALL FFV1_0(W(1,33),W(1,4),W(1,34),GC_11,AMP(42))
      CALL VVV1P0_1(W(1,10),W(1,7),GC_10,ZERO,ZERO,W(1,36))
C     Amplitude(s) for diagram number 41
      CALL VVV1_0(W(1,36),W(1,35),W(1,6),GC_10,AMP(43))
C     Amplitude(s) for diagram number 42
      CALL FFV1_0(W(1,32),W(1,4),W(1,36),GC_11,AMP(44))
      CALL VVVV1P0_1(W(1,10),W(1,6),W(1,7),GC_12,ZERO,ZERO,W(1,37))
      CALL VVVV3P0_1(W(1,10),W(1,6),W(1,7),GC_12,ZERO,ZERO,W(1,38))
      CALL VVVV4P0_1(W(1,10),W(1,6),W(1,7),GC_12,ZERO,ZERO,W(1,39))
C     Amplitude(s) for diagram number 43
      CALL FFV1_0(W(1,30),W(1,4),W(1,37),GC_11,AMP(45))
      CALL FFV1_0(W(1,30),W(1,4),W(1,38),GC_11,AMP(46))
      CALL FFV1_0(W(1,30),W(1,4),W(1,39),GC_11,AMP(47))
      CALL FFV1_2(W(1,30),W(1,10),GC_11,ZERO,ZERO,W(1,40))
C     Amplitude(s) for diagram number 44
      CALL FFV1_0(W(1,40),W(1,27),W(1,7),GC_11,AMP(48))
      CALL FFV1_1(W(1,27),W(1,10),GC_11,ZERO,ZERO,W(1,41))
C     Amplitude(s) for diagram number 45
      CALL FFV1_0(W(1,30),W(1,41),W(1,7),GC_11,AMP(49))
C     Amplitude(s) for diagram number 46
      CALL FFV1_0(W(1,30),W(1,27),W(1,36),GC_11,AMP(50))
C     Amplitude(s) for diagram number 47
      CALL FFV1_0(W(1,40),W(1,23),W(1,6),GC_11,AMP(51))
      CALL FFV1_1(W(1,23),W(1,10),GC_11,ZERO,ZERO,W(1,42))
C     Amplitude(s) for diagram number 48
      CALL FFV1_0(W(1,30),W(1,42),W(1,6),GC_11,AMP(52))
C     Amplitude(s) for diagram number 49
      CALL FFV1_0(W(1,30),W(1,23),W(1,34),GC_11,AMP(53))
C     Amplitude(s) for diagram number 50
      CALL FFV1_0(W(1,40),W(1,4),W(1,21),GC_11,AMP(54))
C     Amplitude(s) for diagram number 51
      CALL FFV1_0(W(1,30),W(1,31),W(1,21),GC_11,AMP(55))
      CALL VVV1P0_1(W(1,10),W(1,21),GC_10,ZERO,ZERO,W(1,40))
C     Amplitude(s) for diagram number 52
      CALL FFV1_0(W(1,30),W(1,4),W(1,40),GC_11,AMP(56))
      CALL FFV1_1(W(1,4),W(1,2),GC_11,ZERO,ZERO,W(1,43))
      CALL FFV1_2(W(1,3),W(1,10),GC_11,ZERO,ZERO,W(1,44))
      CALL FFV1_1(W(1,43),W(1,6),GC_11,ZERO,ZERO,W(1,45))
C     Amplitude(s) for diagram number 53
      CALL FFV1_0(W(1,44),W(1,45),W(1,7),GC_11,AMP(57))
      CALL FFV1_1(W(1,43),W(1,7),GC_11,ZERO,ZERO,W(1,46))
C     Amplitude(s) for diagram number 54
      CALL FFV1_0(W(1,44),W(1,46),W(1,6),GC_11,AMP(58))
      CALL FFV1P0_3(W(1,3),W(1,43),GC_11,ZERO,ZERO,W(1,47))
C     Amplitude(s) for diagram number 55
      CALL VVV1_0(W(1,34),W(1,47),W(1,7),GC_10,AMP(59))
C     Amplitude(s) for diagram number 56
      CALL FFV1_0(W(1,3),W(1,46),W(1,34),GC_11,AMP(60))
C     Amplitude(s) for diagram number 57
      CALL VVV1_0(W(1,36),W(1,47),W(1,6),GC_10,AMP(61))
C     Amplitude(s) for diagram number 58
      CALL FFV1_0(W(1,3),W(1,45),W(1,36),GC_11,AMP(62))
C     Amplitude(s) for diagram number 59
      CALL FFV1_0(W(1,3),W(1,43),W(1,37),GC_11,AMP(63))
      CALL FFV1_0(W(1,3),W(1,43),W(1,38),GC_11,AMP(64))
      CALL FFV1_0(W(1,3),W(1,43),W(1,39),GC_11,AMP(65))
      CALL FFV1_1(W(1,43),W(1,10),GC_11,ZERO,ZERO,W(1,48))
C     Amplitude(s) for diagram number 60
      CALL FFV1_0(W(1,17),W(1,48),W(1,7),GC_11,AMP(66))
      CALL FFV1_2(W(1,17),W(1,10),GC_11,ZERO,ZERO,W(1,49))
C     Amplitude(s) for diagram number 61
      CALL FFV1_0(W(1,49),W(1,43),W(1,7),GC_11,AMP(67))
C     Amplitude(s) for diagram number 62
      CALL FFV1_0(W(1,17),W(1,43),W(1,36),GC_11,AMP(68))
C     Amplitude(s) for diagram number 63
      CALL FFV1_0(W(1,24),W(1,48),W(1,6),GC_11,AMP(69))
      CALL FFV1_2(W(1,24),W(1,10),GC_11,ZERO,ZERO,W(1,50))
C     Amplitude(s) for diagram number 64
      CALL FFV1_0(W(1,50),W(1,43),W(1,6),GC_11,AMP(70))
C     Amplitude(s) for diagram number 65
      CALL FFV1_0(W(1,24),W(1,43),W(1,34),GC_11,AMP(71))
C     Amplitude(s) for diagram number 66
      CALL FFV1_0(W(1,3),W(1,48),W(1,21),GC_11,AMP(72))
C     Amplitude(s) for diagram number 67
      CALL FFV1_0(W(1,44),W(1,43),W(1,21),GC_11,AMP(73))
C     Amplitude(s) for diagram number 68
      CALL FFV1_0(W(1,3),W(1,43),W(1,40),GC_11,AMP(74))
      CALL VVV1P0_1(W(1,2),W(1,6),GC_10,ZERO,ZERO,W(1,48))
      CALL FFV1_1(W(1,4),W(1,48),GC_11,ZERO,ZERO,W(1,51))
C     Amplitude(s) for diagram number 69
      CALL FFV1_0(W(1,44),W(1,51),W(1,7),GC_11,AMP(75))
      CALL VVV1P0_1(W(1,48),W(1,7),GC_10,ZERO,ZERO,W(1,52))
C     Amplitude(s) for diagram number 70
      CALL FFV1_0(W(1,44),W(1,4),W(1,52),GC_11,AMP(76))
      CALL FFV1_2(W(1,3),W(1,48),GC_11,ZERO,ZERO,W(1,53))
C     Amplitude(s) for diagram number 71
      CALL FFV1_0(W(1,53),W(1,31),W(1,7),GC_11,AMP(77))
C     Amplitude(s) for diagram number 72
      CALL FFV1_0(W(1,3),W(1,31),W(1,52),GC_11,AMP(78))
C     Amplitude(s) for diagram number 73
      CALL FFV1_0(W(1,53),W(1,4),W(1,36),GC_11,AMP(79))
C     Amplitude(s) for diagram number 74
      CALL FFV1_0(W(1,3),W(1,51),W(1,36),GC_11,AMP(80))
C     Amplitude(s) for diagram number 75
      CALL VVVV1_0(W(1,10),W(1,48),W(1,9),W(1,7),GC_12,AMP(81))
      CALL VVVV3_0(W(1,10),W(1,48),W(1,9),W(1,7),GC_12,AMP(82))
      CALL VVVV4_0(W(1,10),W(1,48),W(1,9),W(1,7),GC_12,AMP(83))
      CALL VVV1P0_1(W(1,10),W(1,48),GC_10,ZERO,ZERO,W(1,54))
C     Amplitude(s) for diagram number 76
      CALL VVV1_0(W(1,9),W(1,7),W(1,54),GC_10,AMP(84))
      CALL VVV1P0_1(W(1,10),W(1,9),GC_10,ZERO,ZERO,W(1,55))
C     Amplitude(s) for diagram number 77
      CALL VVV1_0(W(1,48),W(1,7),W(1,55),GC_10,AMP(85))
C     Amplitude(s) for diagram number 78
      CALL VVV1_0(W(1,48),W(1,9),W(1,36),GC_10,AMP(86))
C     Amplitude(s) for diagram number 79
      CALL FFV1_0(W(1,24),W(1,4),W(1,54),GC_11,AMP(87))
C     Amplitude(s) for diagram number 80
      CALL FFV1_0(W(1,50),W(1,4),W(1,48),GC_11,AMP(88))
C     Amplitude(s) for diagram number 81
      CALL FFV1_0(W(1,24),W(1,31),W(1,48),GC_11,AMP(89))
C     Amplitude(s) for diagram number 82
      CALL FFV1_0(W(1,3),W(1,23),W(1,54),GC_11,AMP(90))
C     Amplitude(s) for diagram number 83
      CALL FFV1_0(W(1,44),W(1,23),W(1,48),GC_11,AMP(91))
C     Amplitude(s) for diagram number 84
      CALL FFV1_0(W(1,3),W(1,42),W(1,48),GC_11,AMP(92))
      CALL VVV1P0_1(W(1,2),W(1,7),GC_10,ZERO,ZERO,W(1,54))
      CALL FFV1_1(W(1,4),W(1,54),GC_11,ZERO,ZERO,W(1,56))
C     Amplitude(s) for diagram number 85
      CALL FFV1_0(W(1,44),W(1,56),W(1,6),GC_11,AMP(93))
      CALL VVV1P0_1(W(1,54),W(1,6),GC_10,ZERO,ZERO,W(1,57))
C     Amplitude(s) for diagram number 86
      CALL FFV1_0(W(1,44),W(1,4),W(1,57),GC_11,AMP(94))
      CALL FFV1_2(W(1,3),W(1,54),GC_11,ZERO,ZERO,W(1,58))
C     Amplitude(s) for diagram number 87
      CALL FFV1_0(W(1,58),W(1,31),W(1,6),GC_11,AMP(95))
C     Amplitude(s) for diagram number 88
      CALL FFV1_0(W(1,3),W(1,31),W(1,57),GC_11,AMP(96))
C     Amplitude(s) for diagram number 89
      CALL FFV1_0(W(1,58),W(1,4),W(1,34),GC_11,AMP(97))
C     Amplitude(s) for diagram number 90
      CALL FFV1_0(W(1,3),W(1,56),W(1,34),GC_11,AMP(98))
C     Amplitude(s) for diagram number 91
      CALL VVVV1_0(W(1,10),W(1,54),W(1,9),W(1,6),GC_12,AMP(99))
      CALL VVVV3_0(W(1,10),W(1,54),W(1,9),W(1,6),GC_12,AMP(100))
      CALL VVVV4_0(W(1,10),W(1,54),W(1,9),W(1,6),GC_12,AMP(101))
      CALL VVV1P0_1(W(1,10),W(1,54),GC_10,ZERO,ZERO,W(1,59))
C     Amplitude(s) for diagram number 92
      CALL VVV1_0(W(1,9),W(1,6),W(1,59),GC_10,AMP(102))
C     Amplitude(s) for diagram number 93
      CALL VVV1_0(W(1,54),W(1,6),W(1,55),GC_10,AMP(103))
C     Amplitude(s) for diagram number 94
      CALL VVV1_0(W(1,54),W(1,9),W(1,34),GC_10,AMP(104))
C     Amplitude(s) for diagram number 95
      CALL FFV1_0(W(1,17),W(1,4),W(1,59),GC_11,AMP(105))
C     Amplitude(s) for diagram number 96
      CALL FFV1_0(W(1,49),W(1,4),W(1,54),GC_11,AMP(106))
C     Amplitude(s) for diagram number 97
      CALL FFV1_0(W(1,17),W(1,31),W(1,54),GC_11,AMP(107))
C     Amplitude(s) for diagram number 98
      CALL FFV1_0(W(1,3),W(1,27),W(1,59),GC_11,AMP(108))
C     Amplitude(s) for diagram number 99
      CALL FFV1_0(W(1,44),W(1,27),W(1,54),GC_11,AMP(109))
C     Amplitude(s) for diagram number 100
      CALL FFV1_0(W(1,3),W(1,41),W(1,54),GC_11,AMP(110))
      CALL VVV1P0_1(W(1,10),W(1,2),GC_10,ZERO,ZERO,W(1,59))
C     Amplitude(s) for diagram number 101
      CALL VVV1_0(W(1,59),W(1,11),W(1,7),GC_10,AMP(111))
C     Amplitude(s) for diagram number 102
      CALL VVV1_0(W(1,59),W(1,12),W(1,6),GC_10,AMP(112))
C     Amplitude(s) for diagram number 103
      CALL VVVV1_0(W(1,9),W(1,6),W(1,7),W(1,59),GC_12,AMP(113))
      CALL VVVV3_0(W(1,9),W(1,6),W(1,7),W(1,59),GC_12,AMP(114))
      CALL VVVV4_0(W(1,9),W(1,6),W(1,7),W(1,59),GC_12,AMP(115))
      CALL VVV1P0_1(W(1,2),W(1,9),GC_10,ZERO,ZERO,W(1,60))
C     Amplitude(s) for diagram number 104
      CALL VVV1_0(W(1,34),W(1,60),W(1,7),GC_10,AMP(116))
C     Amplitude(s) for diagram number 105
      CALL VVV1_0(W(1,34),W(1,2),W(1,12),GC_10,AMP(117))
C     Amplitude(s) for diagram number 106
      CALL VVVV1_0(W(1,2),W(1,9),W(1,7),W(1,34),GC_12,AMP(118))
      CALL VVVV3_0(W(1,2),W(1,9),W(1,7),W(1,34),GC_12,AMP(119))
      CALL VVVV4_0(W(1,2),W(1,9),W(1,7),W(1,34),GC_12,AMP(120))
C     Amplitude(s) for diagram number 107
      CALL VVV1_0(W(1,36),W(1,60),W(1,6),GC_10,AMP(121))
C     Amplitude(s) for diagram number 108
      CALL VVV1_0(W(1,36),W(1,2),W(1,11),GC_10,AMP(122))
C     Amplitude(s) for diagram number 109
      CALL VVVV1_0(W(1,2),W(1,9),W(1,6),W(1,36),GC_12,AMP(123))
      CALL VVVV3_0(W(1,2),W(1,9),W(1,6),W(1,36),GC_12,AMP(124))
      CALL VVVV4_0(W(1,2),W(1,9),W(1,6),W(1,36),GC_12,AMP(125))
      CALL VVVV1P0_1(W(1,10),W(1,2),W(1,6),GC_12,ZERO,ZERO,W(1,61))
      CALL VVVV3P0_1(W(1,10),W(1,2),W(1,6),GC_12,ZERO,ZERO,W(1,62))
      CALL VVVV4P0_1(W(1,10),W(1,2),W(1,6),GC_12,ZERO,ZERO,W(1,63))
C     Amplitude(s) for diagram number 110
      CALL VVV1_0(W(1,9),W(1,7),W(1,61),GC_10,AMP(126))
      CALL VVV1_0(W(1,9),W(1,7),W(1,62),GC_10,AMP(127))
      CALL VVV1_0(W(1,9),W(1,7),W(1,63),GC_10,AMP(128))
      CALL VVVV1P0_1(W(1,10),W(1,2),W(1,7),GC_12,ZERO,ZERO,W(1,64))
      CALL VVVV3P0_1(W(1,10),W(1,2),W(1,7),GC_12,ZERO,ZERO,W(1,65))
      CALL VVVV4P0_1(W(1,10),W(1,2),W(1,7),GC_12,ZERO,ZERO,W(1,66))
C     Amplitude(s) for diagram number 111
      CALL VVV1_0(W(1,9),W(1,6),W(1,64),GC_10,AMP(129))
      CALL VVV1_0(W(1,9),W(1,6),W(1,65),GC_10,AMP(130))
      CALL VVV1_0(W(1,9),W(1,6),W(1,66),GC_10,AMP(131))
C     Amplitude(s) for diagram number 112
      CALL VVV1_0(W(1,2),W(1,9),W(1,37),GC_10,AMP(132))
      CALL VVV1_0(W(1,2),W(1,9),W(1,38),GC_10,AMP(133))
      CALL VVV1_0(W(1,2),W(1,9),W(1,39),GC_10,AMP(134))
C     Amplitude(s) for diagram number 113
      CALL VVVV1_0(W(1,10),W(1,2),W(1,9),W(1,21),GC_12,AMP(135))
      CALL VVVV3_0(W(1,10),W(1,2),W(1,9),W(1,21),GC_12,AMP(136))
      CALL VVVV4_0(W(1,10),W(1,2),W(1,9),W(1,21),GC_12,AMP(137))
C     Amplitude(s) for diagram number 114
      CALL VVV1_0(W(1,9),W(1,21),W(1,59),GC_10,AMP(138))
C     Amplitude(s) for diagram number 115
      CALL VVV1_0(W(1,2),W(1,21),W(1,55),GC_10,AMP(139))
C     Amplitude(s) for diagram number 116
      CALL VVV1_0(W(1,2),W(1,9),W(1,40),GC_10,AMP(140))
C     Amplitude(s) for diagram number 117
      CALL VVV1_0(W(1,59),W(1,8),W(1,7),GC_10,AMP(141))
C     Amplitude(s) for diagram number 118
      CALL FFV1_0(W(1,22),W(1,4),W(1,59),GC_11,AMP(142))
      CALL FFV1_2(W(1,17),W(1,2),GC_11,ZERO,ZERO,W(1,40))
C     Amplitude(s) for diagram number 119
      CALL FFV1_0(W(1,40),W(1,31),W(1,7),GC_11,AMP(143))
C     Amplitude(s) for diagram number 120
      CALL FFV1_0(W(1,22),W(1,31),W(1,2),GC_11,AMP(144))
C     Amplitude(s) for diagram number 121
      CALL FFV1_0(W(1,40),W(1,4),W(1,36),GC_11,AMP(145))
C     Amplitude(s) for diagram number 122
      CALL VVV1_0(W(1,36),W(1,2),W(1,8),GC_10,AMP(146))
C     Amplitude(s) for diagram number 123
      CALL FFV1_0(W(1,17),W(1,4),W(1,64),GC_11,AMP(147))
      CALL FFV1_0(W(1,17),W(1,4),W(1,65),GC_11,AMP(148))
      CALL FFV1_0(W(1,17),W(1,4),W(1,66),GC_11,AMP(149))
C     Amplitude(s) for diagram number 124
      CALL FFV1_0(W(1,17),W(1,23),W(1,59),GC_11,AMP(150))
C     Amplitude(s) for diagram number 125
      CALL FFV1_0(W(1,49),W(1,23),W(1,2),GC_11,AMP(151))
C     Amplitude(s) for diagram number 126
      CALL FFV1_0(W(1,17),W(1,42),W(1,2),GC_11,AMP(152))
C     Amplitude(s) for diagram number 127
      CALL VVV1_0(W(1,59),W(1,25),W(1,6),GC_10,AMP(153))
C     Amplitude(s) for diagram number 128
      CALL FFV1_0(W(1,26),W(1,4),W(1,59),GC_11,AMP(154))
      CALL FFV1_2(W(1,24),W(1,2),GC_11,ZERO,ZERO,W(1,42))
C     Amplitude(s) for diagram number 129
      CALL FFV1_0(W(1,42),W(1,31),W(1,6),GC_11,AMP(155))
C     Amplitude(s) for diagram number 130
      CALL FFV1_0(W(1,26),W(1,31),W(1,2),GC_11,AMP(156))
C     Amplitude(s) for diagram number 131
      CALL FFV1_0(W(1,42),W(1,4),W(1,34),GC_11,AMP(157))
C     Amplitude(s) for diagram number 132
      CALL VVV1_0(W(1,34),W(1,2),W(1,25),GC_10,AMP(158))
C     Amplitude(s) for diagram number 133
      CALL FFV1_0(W(1,24),W(1,4),W(1,61),GC_11,AMP(159))
      CALL FFV1_0(W(1,24),W(1,4),W(1,62),GC_11,AMP(160))
      CALL FFV1_0(W(1,24),W(1,4),W(1,63),GC_11,AMP(161))
C     Amplitude(s) for diagram number 134
      CALL FFV1_0(W(1,24),W(1,27),W(1,59),GC_11,AMP(162))
C     Amplitude(s) for diagram number 135
      CALL FFV1_0(W(1,50),W(1,27),W(1,2),GC_11,AMP(163))
C     Amplitude(s) for diagram number 136
      CALL FFV1_0(W(1,24),W(1,41),W(1,2),GC_11,AMP(164))
C     Amplitude(s) for diagram number 137
      CALL VVV1_0(W(1,59),W(1,28),W(1,7),GC_10,AMP(165))
C     Amplitude(s) for diagram number 138
      CALL FFV1_0(W(1,3),W(1,29),W(1,59),GC_11,AMP(166))
      CALL FFV1_1(W(1,27),W(1,2),GC_11,ZERO,ZERO,W(1,41))
C     Amplitude(s) for diagram number 139
      CALL FFV1_0(W(1,44),W(1,41),W(1,7),GC_11,AMP(167))
C     Amplitude(s) for diagram number 140
      CALL FFV1_0(W(1,44),W(1,29),W(1,2),GC_11,AMP(168))
C     Amplitude(s) for diagram number 141
      CALL FFV1_0(W(1,3),W(1,41),W(1,36),GC_11,AMP(169))
C     Amplitude(s) for diagram number 142
      CALL VVV1_0(W(1,36),W(1,2),W(1,28),GC_10,AMP(170))
C     Amplitude(s) for diagram number 143
      CALL FFV1_0(W(1,3),W(1,27),W(1,64),GC_11,AMP(171))
      CALL FFV1_0(W(1,3),W(1,27),W(1,65),GC_11,AMP(172))
      CALL FFV1_0(W(1,3),W(1,27),W(1,66),GC_11,AMP(173))
C     Amplitude(s) for diagram number 144
      CALL VVV1_0(W(1,59),W(1,20),W(1,6),GC_10,AMP(174))
C     Amplitude(s) for diagram number 145
      CALL FFV1_0(W(1,3),W(1,15),W(1,59),GC_11,AMP(175))
      CALL FFV1_1(W(1,23),W(1,2),GC_11,ZERO,ZERO,W(1,66))
C     Amplitude(s) for diagram number 146
      CALL FFV1_0(W(1,44),W(1,66),W(1,6),GC_11,AMP(176))
C     Amplitude(s) for diagram number 147
      CALL FFV1_0(W(1,44),W(1,15),W(1,2),GC_11,AMP(177))
C     Amplitude(s) for diagram number 148
      CALL FFV1_0(W(1,3),W(1,66),W(1,34),GC_11,AMP(178))
C     Amplitude(s) for diagram number 149
      CALL VVV1_0(W(1,34),W(1,2),W(1,20),GC_10,AMP(179))
C     Amplitude(s) for diagram number 150
      CALL FFV1_0(W(1,3),W(1,23),W(1,61),GC_11,AMP(180))
      CALL FFV1_0(W(1,3),W(1,23),W(1,62),GC_11,AMP(181))
      CALL FFV1_0(W(1,3),W(1,23),W(1,63),GC_11,AMP(182))
C     Amplitude(s) for diagram number 151
      CALL FFV1_0(W(1,18),W(1,4),W(1,59),GC_11,AMP(183))
C     Amplitude(s) for diagram number 152
      CALL FFV1_0(W(1,3),W(1,13),W(1,59),GC_11,AMP(184))
      CALL VVV1P0_1(W(1,2),W(1,21),GC_10,ZERO,ZERO,W(1,59))
C     Amplitude(s) for diagram number 153
      CALL FFV1_0(W(1,44),W(1,4),W(1,59),GC_11,AMP(185))
C     Amplitude(s) for diagram number 154
      CALL FFV1_0(W(1,44),W(1,13),W(1,2),GC_11,AMP(186))
C     Amplitude(s) for diagram number 155
      CALL FFV1_0(W(1,3),W(1,31),W(1,59),GC_11,AMP(187))
C     Amplitude(s) for diagram number 156
      CALL FFV1_0(W(1,18),W(1,31),W(1,2),GC_11,AMP(188))
      CALL VVVV1P0_1(W(1,2),W(1,6),W(1,7),GC_12,ZERO,ZERO,W(1,63))
      CALL VVVV3P0_1(W(1,2),W(1,6),W(1,7),GC_12,ZERO,ZERO,W(1,62))
      CALL VVVV4P0_1(W(1,2),W(1,6),W(1,7),GC_12,ZERO,ZERO,W(1,61))
C     Amplitude(s) for diagram number 157
      CALL FFV1_0(W(1,44),W(1,4),W(1,63),GC_11,AMP(189))
      CALL FFV1_0(W(1,44),W(1,4),W(1,62),GC_11,AMP(190))
      CALL FFV1_0(W(1,44),W(1,4),W(1,61),GC_11,AMP(191))
C     Amplitude(s) for diagram number 158
      CALL FFV1_0(W(1,3),W(1,31),W(1,63),GC_11,AMP(192))
      CALL FFV1_0(W(1,3),W(1,31),W(1,62),GC_11,AMP(193))
      CALL FFV1_0(W(1,3),W(1,31),W(1,61),GC_11,AMP(194))
C     Amplitude(s) for diagram number 159
      CALL VVV1_0(W(1,10),W(1,63),W(1,9),GC_10,AMP(195))
      CALL VVV1_0(W(1,10),W(1,62),W(1,9),GC_10,AMP(196))
      CALL VVV1_0(W(1,10),W(1,61),W(1,9),GC_10,AMP(197))
      CALL FFV1_2(W(1,1),W(1,6),GC_11,ZERO,ZERO,W(1,10))
      CALL FFV1P0_3(W(1,10),W(1,5),GC_11,ZERO,ZERO,W(1,31))
C     Amplitude(s) for diagram number 160
      CALL VVV1_0(W(1,31),W(1,35),W(1,7),GC_10,AMP(198))
C     Amplitude(s) for diagram number 161
      CALL FFV1_0(W(1,33),W(1,4),W(1,31),GC_11,AMP(199))
      CALL FFV1_2(W(1,10),W(1,7),GC_11,ZERO,ZERO,W(1,44))
C     Amplitude(s) for diagram number 162
      CALL FFV1_0(W(1,44),W(1,5),W(1,35),GC_11,AMP(200))
C     Amplitude(s) for diagram number 163
      CALL FFV1_0(W(1,30),W(1,23),W(1,31),GC_11,AMP(201))
      CALL FFV1P0_3(W(1,10),W(1,19),GC_11,ZERO,ZERO,W(1,34))
C     Amplitude(s) for diagram number 164
      CALL FFV1_0(W(1,30),W(1,4),W(1,34),GC_11,AMP(202))
C     Amplitude(s) for diagram number 165
      CALL VVV1_0(W(1,31),W(1,47),W(1,7),GC_10,AMP(203))
C     Amplitude(s) for diagram number 166
      CALL FFV1_0(W(1,3),W(1,46),W(1,31),GC_11,AMP(204))
C     Amplitude(s) for diagram number 167
      CALL FFV1_0(W(1,44),W(1,5),W(1,47),GC_11,AMP(205))
C     Amplitude(s) for diagram number 168
      CALL FFV1_0(W(1,24),W(1,43),W(1,31),GC_11,AMP(206))
C     Amplitude(s) for diagram number 169
      CALL FFV1_0(W(1,3),W(1,43),W(1,34),GC_11,AMP(207))
      CALL FFV1_1(W(1,5),W(1,2),GC_11,ZERO,ZERO,W(1,65))
      CALL FFV1P0_3(W(1,10),W(1,65),GC_11,ZERO,ZERO,W(1,64))
C     Amplitude(s) for diagram number 170
      CALL VVV1_0(W(1,9),W(1,7),W(1,64),GC_10,AMP(208))
      CALL FFV1_2(W(1,10),W(1,9),GC_11,ZERO,ZERO,W(1,36))
C     Amplitude(s) for diagram number 171
      CALL FFV1_0(W(1,36),W(1,65),W(1,7),GC_11,AMP(209))
C     Amplitude(s) for diagram number 172
      CALL FFV1_0(W(1,44),W(1,65),W(1,9),GC_11,AMP(210))
C     Amplitude(s) for diagram number 173
      CALL FFV1_0(W(1,24),W(1,4),W(1,64),GC_11,AMP(211))
C     Amplitude(s) for diagram number 174
      CALL FFV1_0(W(1,3),W(1,23),W(1,64),GC_11,AMP(212))
C     Amplitude(s) for diagram number 175
      CALL FFV1_0(W(1,58),W(1,4),W(1,31),GC_11,AMP(213))
C     Amplitude(s) for diagram number 176
      CALL FFV1_0(W(1,3),W(1,56),W(1,31),GC_11,AMP(214))
      CALL FFV1_2(W(1,10),W(1,54),GC_11,ZERO,ZERO,W(1,64))
C     Amplitude(s) for diagram number 177
      CALL FFV1_0(W(1,64),W(1,5),W(1,9),GC_11,AMP(215))
C     Amplitude(s) for diagram number 178
      CALL FFV1_0(W(1,36),W(1,5),W(1,54),GC_11,AMP(216))
C     Amplitude(s) for diagram number 179
      CALL VVV1_0(W(1,54),W(1,9),W(1,31),GC_10,AMP(217))
      CALL FFV1_2(W(1,10),W(1,2),GC_11,ZERO,ZERO,W(1,64))
C     Amplitude(s) for diagram number 180
      CALL FFV1_0(W(1,64),W(1,14),W(1,7),GC_11,AMP(218))
C     Amplitude(s) for diagram number 181
      CALL FFV1_0(W(1,64),W(1,5),W(1,12),GC_11,AMP(219))
C     Amplitude(s) for diagram number 182
      CALL VVV1_0(W(1,31),W(1,60),W(1,7),GC_10,AMP(220))
C     Amplitude(s) for diagram number 183
      CALL VVV1_0(W(1,31),W(1,2),W(1,12),GC_10,AMP(221))
C     Amplitude(s) for diagram number 184
      CALL VVVV1_0(W(1,2),W(1,9),W(1,7),W(1,31),GC_12,AMP(222))
      CALL VVVV3_0(W(1,2),W(1,9),W(1,7),W(1,31),GC_12,AMP(223))
      CALL VVVV4_0(W(1,2),W(1,9),W(1,7),W(1,31),GC_12,AMP(224))
C     Amplitude(s) for diagram number 185
      CALL FFV1_0(W(1,44),W(1,5),W(1,60),GC_11,AMP(225))
C     Amplitude(s) for diagram number 186
      CALL FFV1_0(W(1,44),W(1,14),W(1,2),GC_11,AMP(226))
C     Amplitude(s) for diagram number 187
      CALL FFV1_0(W(1,64),W(1,19),W(1,9),GC_11,AMP(227))
C     Amplitude(s) for diagram number 188
      CALL FFV1_0(W(1,36),W(1,19),W(1,2),GC_11,AMP(228))
C     Amplitude(s) for diagram number 189
      CALL VVV1_0(W(1,2),W(1,9),W(1,34),GC_10,AMP(229))
C     Amplitude(s) for diagram number 190
      CALL FFV1_0(W(1,64),W(1,5),W(1,25),GC_11,AMP(230))
C     Amplitude(s) for diagram number 191
      CALL FFV1_0(W(1,42),W(1,4),W(1,31),GC_11,AMP(231))
C     Amplitude(s) for diagram number 192
      CALL VVV1_0(W(1,31),W(1,2),W(1,25),GC_10,AMP(232))
C     Amplitude(s) for diagram number 193
      CALL FFV1_0(W(1,64),W(1,5),W(1,20),GC_11,AMP(233))
C     Amplitude(s) for diagram number 194
      CALL FFV1_0(W(1,3),W(1,66),W(1,31),GC_11,AMP(234))
C     Amplitude(s) for diagram number 195
      CALL VVV1_0(W(1,31),W(1,2),W(1,20),GC_10,AMP(235))
      CALL FFV1_2(W(1,1),W(1,7),GC_11,ZERO,ZERO,W(1,31))
      CALL FFV1P0_3(W(1,31),W(1,5),GC_11,ZERO,ZERO,W(1,64))
C     Amplitude(s) for diagram number 196
      CALL VVV1_0(W(1,64),W(1,35),W(1,6),GC_10,AMP(236))
C     Amplitude(s) for diagram number 197
      CALL FFV1_0(W(1,32),W(1,4),W(1,64),GC_11,AMP(237))
      CALL FFV1_2(W(1,31),W(1,6),GC_11,ZERO,ZERO,W(1,34))
C     Amplitude(s) for diagram number 198
      CALL FFV1_0(W(1,34),W(1,5),W(1,35),GC_11,AMP(238))
C     Amplitude(s) for diagram number 199
      CALL FFV1_0(W(1,30),W(1,27),W(1,64),GC_11,AMP(239))
      CALL FFV1P0_3(W(1,31),W(1,16),GC_11,ZERO,ZERO,W(1,36))
C     Amplitude(s) for diagram number 200
      CALL FFV1_0(W(1,30),W(1,4),W(1,36),GC_11,AMP(240))
C     Amplitude(s) for diagram number 201
      CALL VVV1_0(W(1,64),W(1,47),W(1,6),GC_10,AMP(241))
C     Amplitude(s) for diagram number 202
      CALL FFV1_0(W(1,3),W(1,45),W(1,64),GC_11,AMP(242))
C     Amplitude(s) for diagram number 203
      CALL FFV1_0(W(1,34),W(1,5),W(1,47),GC_11,AMP(243))
C     Amplitude(s) for diagram number 204
      CALL FFV1_0(W(1,17),W(1,43),W(1,64),GC_11,AMP(244))
C     Amplitude(s) for diagram number 205
      CALL FFV1_0(W(1,3),W(1,43),W(1,36),GC_11,AMP(245))
      CALL FFV1P0_3(W(1,31),W(1,65),GC_11,ZERO,ZERO,W(1,44))
C     Amplitude(s) for diagram number 206
      CALL VVV1_0(W(1,9),W(1,6),W(1,44),GC_10,AMP(246))
      CALL FFV1_2(W(1,31),W(1,9),GC_11,ZERO,ZERO,W(1,10))
C     Amplitude(s) for diagram number 207
      CALL FFV1_0(W(1,10),W(1,65),W(1,6),GC_11,AMP(247))
C     Amplitude(s) for diagram number 208
      CALL FFV1_0(W(1,34),W(1,65),W(1,9),GC_11,AMP(248))
C     Amplitude(s) for diagram number 209
      CALL FFV1_0(W(1,17),W(1,4),W(1,44),GC_11,AMP(249))
C     Amplitude(s) for diagram number 210
      CALL FFV1_0(W(1,3),W(1,27),W(1,44),GC_11,AMP(250))
C     Amplitude(s) for diagram number 211
      CALL FFV1_0(W(1,53),W(1,4),W(1,64),GC_11,AMP(251))
C     Amplitude(s) for diagram number 212
      CALL FFV1_0(W(1,3),W(1,51),W(1,64),GC_11,AMP(252))
      CALL FFV1_2(W(1,31),W(1,48),GC_11,ZERO,ZERO,W(1,44))
C     Amplitude(s) for diagram number 213
      CALL FFV1_0(W(1,44),W(1,5),W(1,9),GC_11,AMP(253))
C     Amplitude(s) for diagram number 214
      CALL FFV1_0(W(1,10),W(1,5),W(1,48),GC_11,AMP(254))
C     Amplitude(s) for diagram number 215
      CALL VVV1_0(W(1,48),W(1,9),W(1,64),GC_10,AMP(255))
      CALL FFV1_2(W(1,31),W(1,2),GC_11,ZERO,ZERO,W(1,44))
C     Amplitude(s) for diagram number 216
      CALL FFV1_0(W(1,44),W(1,14),W(1,6),GC_11,AMP(256))
C     Amplitude(s) for diagram number 217
      CALL FFV1_0(W(1,44),W(1,5),W(1,11),GC_11,AMP(257))
C     Amplitude(s) for diagram number 218
      CALL VVV1_0(W(1,64),W(1,60),W(1,6),GC_10,AMP(258))
C     Amplitude(s) for diagram number 219
      CALL VVV1_0(W(1,64),W(1,2),W(1,11),GC_10,AMP(259))
C     Amplitude(s) for diagram number 220
      CALL VVVV1_0(W(1,2),W(1,9),W(1,6),W(1,64),GC_12,AMP(260))
      CALL VVVV3_0(W(1,2),W(1,9),W(1,6),W(1,64),GC_12,AMP(261))
      CALL VVVV4_0(W(1,2),W(1,9),W(1,6),W(1,64),GC_12,AMP(262))
C     Amplitude(s) for diagram number 221
      CALL FFV1_0(W(1,34),W(1,5),W(1,60),GC_11,AMP(263))
C     Amplitude(s) for diagram number 222
      CALL FFV1_0(W(1,34),W(1,14),W(1,2),GC_11,AMP(264))
C     Amplitude(s) for diagram number 223
      CALL FFV1_0(W(1,44),W(1,16),W(1,9),GC_11,AMP(265))
C     Amplitude(s) for diagram number 224
      CALL FFV1_0(W(1,10),W(1,16),W(1,2),GC_11,AMP(266))
C     Amplitude(s) for diagram number 225
      CALL VVV1_0(W(1,2),W(1,9),W(1,36),GC_10,AMP(267))
C     Amplitude(s) for diagram number 226
      CALL FFV1_0(W(1,44),W(1,5),W(1,8),GC_11,AMP(268))
C     Amplitude(s) for diagram number 227
      CALL FFV1_0(W(1,40),W(1,4),W(1,64),GC_11,AMP(269))
C     Amplitude(s) for diagram number 228
      CALL VVV1_0(W(1,64),W(1,2),W(1,8),GC_10,AMP(270))
C     Amplitude(s) for diagram number 229
      CALL FFV1_0(W(1,44),W(1,5),W(1,28),GC_11,AMP(271))
C     Amplitude(s) for diagram number 230
      CALL FFV1_0(W(1,3),W(1,41),W(1,64),GC_11,AMP(272))
C     Amplitude(s) for diagram number 231
      CALL VVV1_0(W(1,64),W(1,2),W(1,28),GC_10,AMP(273))
      CALL FFV1P0_3(W(1,1),W(1,19),GC_11,ZERO,ZERO,W(1,64))
C     Amplitude(s) for diagram number 232
      CALL FFV1_0(W(1,30),W(1,27),W(1,64),GC_11,AMP(274))
      CALL FFV1P0_3(W(1,1),W(1,16),GC_11,ZERO,ZERO,W(1,44))
C     Amplitude(s) for diagram number 233
      CALL FFV1_0(W(1,30),W(1,23),W(1,44),GC_11,AMP(275))
C     Amplitude(s) for diagram number 234
      CALL VVV1_0(W(1,44),W(1,35),W(1,7),GC_10,AMP(276))
C     Amplitude(s) for diagram number 235
      CALL FFV1_0(W(1,33),W(1,4),W(1,44),GC_11,AMP(277))
      CALL FFV1_1(W(1,16),W(1,7),GC_11,ZERO,ZERO,W(1,33))
C     Amplitude(s) for diagram number 236
      CALL FFV1_0(W(1,1),W(1,33),W(1,35),GC_11,AMP(278))
C     Amplitude(s) for diagram number 237
      CALL VVV1_0(W(1,64),W(1,35),W(1,6),GC_10,AMP(279))
C     Amplitude(s) for diagram number 238
      CALL FFV1_0(W(1,32),W(1,4),W(1,64),GC_11,AMP(280))
      CALL FFV1_1(W(1,19),W(1,6),GC_11,ZERO,ZERO,W(1,32))
C     Amplitude(s) for diagram number 239
      CALL FFV1_0(W(1,1),W(1,32),W(1,35),GC_11,AMP(281))
      CALL FFV1_2(W(1,1),W(1,21),GC_11,ZERO,ZERO,W(1,30))
C     Amplitude(s) for diagram number 240
      CALL FFV1_0(W(1,30),W(1,5),W(1,35),GC_11,AMP(282))
      CALL FFV1_1(W(1,5),W(1,21),GC_11,ZERO,ZERO,W(1,36))
C     Amplitude(s) for diagram number 241
      CALL FFV1_0(W(1,1),W(1,36),W(1,35),GC_11,AMP(283))
C     Amplitude(s) for diagram number 242
      CALL FFV1_0(W(1,17),W(1,43),W(1,64),GC_11,AMP(284))
C     Amplitude(s) for diagram number 243
      CALL FFV1_0(W(1,24),W(1,43),W(1,44),GC_11,AMP(285))
C     Amplitude(s) for diagram number 244
      CALL VVV1_0(W(1,44),W(1,47),W(1,7),GC_10,AMP(286))
C     Amplitude(s) for diagram number 245
      CALL FFV1_0(W(1,3),W(1,46),W(1,44),GC_11,AMP(287))
C     Amplitude(s) for diagram number 246
      CALL FFV1_0(W(1,1),W(1,33),W(1,47),GC_11,AMP(288))
C     Amplitude(s) for diagram number 247
      CALL VVV1_0(W(1,64),W(1,47),W(1,6),GC_10,AMP(289))
C     Amplitude(s) for diagram number 248
      CALL FFV1_0(W(1,3),W(1,45),W(1,64),GC_11,AMP(290))
C     Amplitude(s) for diagram number 249
      CALL FFV1_0(W(1,1),W(1,32),W(1,47),GC_11,AMP(291))
C     Amplitude(s) for diagram number 250
      CALL FFV1_0(W(1,30),W(1,5),W(1,47),GC_11,AMP(292))
C     Amplitude(s) for diagram number 251
      CALL FFV1_0(W(1,1),W(1,36),W(1,47),GC_11,AMP(293))
      CALL FFV1P0_3(W(1,1),W(1,65),GC_11,ZERO,ZERO,W(1,47))
C     Amplitude(s) for diagram number 252
      CALL VVV1_0(W(1,47),W(1,11),W(1,7),GC_10,AMP(294))
C     Amplitude(s) for diagram number 253
      CALL VVV1_0(W(1,47),W(1,12),W(1,6),GC_10,AMP(295))
C     Amplitude(s) for diagram number 254
      CALL VVVV1_0(W(1,9),W(1,6),W(1,7),W(1,47),GC_12,AMP(296))
      CALL VVVV3_0(W(1,9),W(1,6),W(1,7),W(1,47),GC_12,AMP(297))
      CALL VVVV4_0(W(1,9),W(1,6),W(1,7),W(1,47),GC_12,AMP(298))
      CALL FFV1_2(W(1,1),W(1,9),GC_11,ZERO,ZERO,W(1,45))
      CALL FFV1_1(W(1,65),W(1,6),GC_11,ZERO,ZERO,W(1,46))
C     Amplitude(s) for diagram number 255
      CALL FFV1_0(W(1,45),W(1,46),W(1,7),GC_11,AMP(299))
      CALL FFV1_1(W(1,65),W(1,7),GC_11,ZERO,ZERO,W(1,43))
C     Amplitude(s) for diagram number 256
      CALL FFV1_0(W(1,45),W(1,43),W(1,6),GC_11,AMP(300))
C     Amplitude(s) for diagram number 257
      CALL FFV1_0(W(1,1),W(1,46),W(1,12),GC_11,AMP(301))
C     Amplitude(s) for diagram number 258
      CALL FFV1_0(W(1,1),W(1,43),W(1,11),GC_11,AMP(302))
C     Amplitude(s) for diagram number 259
      CALL VVV1_0(W(1,9),W(1,21),W(1,47),GC_10,AMP(303))
C     Amplitude(s) for diagram number 260
      CALL FFV1_0(W(1,45),W(1,65),W(1,21),GC_11,AMP(304))
C     Amplitude(s) for diagram number 261
      CALL FFV1_0(W(1,30),W(1,65),W(1,9),GC_11,AMP(305))
C     Amplitude(s) for diagram number 262
      CALL VVV1_0(W(1,47),W(1,8),W(1,7),GC_10,AMP(306))
C     Amplitude(s) for diagram number 263
      CALL FFV1_0(W(1,22),W(1,4),W(1,47),GC_11,AMP(307))
C     Amplitude(s) for diagram number 264
      CALL FFV1_0(W(1,1),W(1,43),W(1,8),GC_11,AMP(308))
C     Amplitude(s) for diagram number 265
      CALL FFV1_0(W(1,17),W(1,23),W(1,47),GC_11,AMP(309))
C     Amplitude(s) for diagram number 266
      CALL VVV1_0(W(1,47),W(1,25),W(1,6),GC_10,AMP(310))
C     Amplitude(s) for diagram number 267
      CALL FFV1_0(W(1,26),W(1,4),W(1,47),GC_11,AMP(311))
C     Amplitude(s) for diagram number 268
      CALL FFV1_0(W(1,1),W(1,46),W(1,25),GC_11,AMP(312))
C     Amplitude(s) for diagram number 269
      CALL FFV1_0(W(1,24),W(1,27),W(1,47),GC_11,AMP(313))
C     Amplitude(s) for diagram number 270
      CALL VVV1_0(W(1,47),W(1,28),W(1,7),GC_10,AMP(314))
C     Amplitude(s) for diagram number 271
      CALL FFV1_0(W(1,3),W(1,29),W(1,47),GC_11,AMP(315))
C     Amplitude(s) for diagram number 272
      CALL FFV1_0(W(1,1),W(1,43),W(1,28),GC_11,AMP(316))
C     Amplitude(s) for diagram number 273
      CALL VVV1_0(W(1,47),W(1,20),W(1,6),GC_10,AMP(317))
C     Amplitude(s) for diagram number 274
      CALL FFV1_0(W(1,3),W(1,15),W(1,47),GC_11,AMP(318))
C     Amplitude(s) for diagram number 275
      CALL FFV1_0(W(1,1),W(1,46),W(1,20),GC_11,AMP(319))
C     Amplitude(s) for diagram number 276
      CALL FFV1_0(W(1,18),W(1,4),W(1,47),GC_11,AMP(320))
C     Amplitude(s) for diagram number 277
      CALL FFV1_0(W(1,3),W(1,13),W(1,47),GC_11,AMP(321))
      CALL FFV1_2(W(1,1),W(1,48),GC_11,ZERO,ZERO,W(1,47))
C     Amplitude(s) for diagram number 278
      CALL FFV1_0(W(1,47),W(1,14),W(1,7),GC_11,AMP(322))
C     Amplitude(s) for diagram number 279
      CALL FFV1_0(W(1,47),W(1,5),W(1,12),GC_11,AMP(323))
      CALL FFV1_1(W(1,5),W(1,48),GC_11,ZERO,ZERO,W(1,13))
C     Amplitude(s) for diagram number 280
      CALL FFV1_0(W(1,45),W(1,13),W(1,7),GC_11,AMP(324))
C     Amplitude(s) for diagram number 281
      CALL FFV1_0(W(1,45),W(1,5),W(1,52),GC_11,AMP(325))
C     Amplitude(s) for diagram number 282
      CALL FFV1_0(W(1,1),W(1,13),W(1,12),GC_11,AMP(326))
C     Amplitude(s) for diagram number 283
      CALL FFV1_0(W(1,1),W(1,14),W(1,52),GC_11,AMP(327))
C     Amplitude(s) for diagram number 284
      CALL FFV1_0(W(1,47),W(1,19),W(1,9),GC_11,AMP(328))
C     Amplitude(s) for diagram number 285
      CALL FFV1_0(W(1,45),W(1,19),W(1,48),GC_11,AMP(329))
C     Amplitude(s) for diagram number 286
      CALL VVV1_0(W(1,48),W(1,9),W(1,64),GC_10,AMP(330))
C     Amplitude(s) for diagram number 287
      CALL FFV1_0(W(1,47),W(1,5),W(1,25),GC_11,AMP(331))
C     Amplitude(s) for diagram number 288
      CALL FFV1_0(W(1,1),W(1,13),W(1,25),GC_11,AMP(332))
C     Amplitude(s) for diagram number 289
      CALL FFV1_0(W(1,47),W(1,5),W(1,20),GC_11,AMP(333))
C     Amplitude(s) for diagram number 290
      CALL FFV1_0(W(1,1),W(1,13),W(1,20),GC_11,AMP(334))
C     Amplitude(s) for diagram number 291
      CALL FFV1_0(W(1,53),W(1,4),W(1,64),GC_11,AMP(335))
C     Amplitude(s) for diagram number 292
      CALL FFV1_0(W(1,3),W(1,51),W(1,64),GC_11,AMP(336))
      CALL FFV1_2(W(1,1),W(1,54),GC_11,ZERO,ZERO,W(1,51))
C     Amplitude(s) for diagram number 293
      CALL FFV1_0(W(1,51),W(1,14),W(1,6),GC_11,AMP(337))
C     Amplitude(s) for diagram number 294
      CALL FFV1_0(W(1,51),W(1,5),W(1,11),GC_11,AMP(338))
      CALL FFV1_1(W(1,5),W(1,54),GC_11,ZERO,ZERO,W(1,53))
C     Amplitude(s) for diagram number 295
      CALL FFV1_0(W(1,45),W(1,53),W(1,6),GC_11,AMP(339))
C     Amplitude(s) for diagram number 296
      CALL FFV1_0(W(1,45),W(1,5),W(1,57),GC_11,AMP(340))
C     Amplitude(s) for diagram number 297
      CALL FFV1_0(W(1,1),W(1,53),W(1,11),GC_11,AMP(341))
C     Amplitude(s) for diagram number 298
      CALL FFV1_0(W(1,1),W(1,14),W(1,57),GC_11,AMP(342))
C     Amplitude(s) for diagram number 299
      CALL FFV1_0(W(1,51),W(1,16),W(1,9),GC_11,AMP(343))
C     Amplitude(s) for diagram number 300
      CALL FFV1_0(W(1,45),W(1,16),W(1,54),GC_11,AMP(344))
C     Amplitude(s) for diagram number 301
      CALL VVV1_0(W(1,54),W(1,9),W(1,44),GC_10,AMP(345))
C     Amplitude(s) for diagram number 302
      CALL FFV1_0(W(1,51),W(1,5),W(1,8),GC_11,AMP(346))
C     Amplitude(s) for diagram number 303
      CALL FFV1_0(W(1,1),W(1,53),W(1,8),GC_11,AMP(347))
C     Amplitude(s) for diagram number 304
      CALL FFV1_0(W(1,51),W(1,5),W(1,28),GC_11,AMP(348))
C     Amplitude(s) for diagram number 305
      CALL FFV1_0(W(1,1),W(1,53),W(1,28),GC_11,AMP(349))
C     Amplitude(s) for diagram number 306
      CALL FFV1_0(W(1,58),W(1,4),W(1,44),GC_11,AMP(350))
C     Amplitude(s) for diagram number 307
      CALL FFV1_0(W(1,3),W(1,56),W(1,44),GC_11,AMP(351))
      CALL FFV1_1(W(1,16),W(1,2),GC_11,ZERO,ZERO,W(1,56))
C     Amplitude(s) for diagram number 308
      CALL FFV1_0(W(1,45),W(1,56),W(1,7),GC_11,AMP(352))
C     Amplitude(s) for diagram number 309
      CALL FFV1_0(W(1,45),W(1,33),W(1,2),GC_11,AMP(353))
C     Amplitude(s) for diagram number 310
      CALL VVV1_0(W(1,44),W(1,60),W(1,7),GC_10,AMP(354))
C     Amplitude(s) for diagram number 311
      CALL VVV1_0(W(1,44),W(1,2),W(1,12),GC_10,AMP(355))
C     Amplitude(s) for diagram number 312
      CALL VVVV1_0(W(1,2),W(1,9),W(1,7),W(1,44),GC_12,AMP(356))
      CALL VVVV3_0(W(1,2),W(1,9),W(1,7),W(1,44),GC_12,AMP(357))
      CALL VVVV4_0(W(1,2),W(1,9),W(1,7),W(1,44),GC_12,AMP(358))
C     Amplitude(s) for diagram number 313
      CALL FFV1_0(W(1,1),W(1,33),W(1,60),GC_11,AMP(359))
C     Amplitude(s) for diagram number 314
      CALL FFV1_0(W(1,1),W(1,56),W(1,12),GC_11,AMP(360))
      CALL FFV1_1(W(1,19),W(1,2),GC_11,ZERO,ZERO,W(1,12))
C     Amplitude(s) for diagram number 315
      CALL FFV1_0(W(1,45),W(1,12),W(1,6),GC_11,AMP(361))
C     Amplitude(s) for diagram number 316
      CALL FFV1_0(W(1,45),W(1,32),W(1,2),GC_11,AMP(362))
C     Amplitude(s) for diagram number 317
      CALL VVV1_0(W(1,64),W(1,60),W(1,6),GC_10,AMP(363))
C     Amplitude(s) for diagram number 318
      CALL VVV1_0(W(1,64),W(1,2),W(1,11),GC_10,AMP(364))
C     Amplitude(s) for diagram number 319
      CALL VVVV1_0(W(1,2),W(1,9),W(1,6),W(1,64),GC_12,AMP(365))
      CALL VVVV3_0(W(1,2),W(1,9),W(1,6),W(1,64),GC_12,AMP(366))
      CALL VVVV4_0(W(1,2),W(1,9),W(1,6),W(1,64),GC_12,AMP(367))
C     Amplitude(s) for diagram number 320
      CALL FFV1_0(W(1,1),W(1,32),W(1,60),GC_11,AMP(368))
C     Amplitude(s) for diagram number 321
      CALL FFV1_0(W(1,1),W(1,12),W(1,11),GC_11,AMP(369))
C     Amplitude(s) for diagram number 322
      CALL FFV1_0(W(1,45),W(1,5),W(1,59),GC_11,AMP(370))
C     Amplitude(s) for diagram number 323
      CALL FFV1_0(W(1,45),W(1,36),W(1,2),GC_11,AMP(371))
C     Amplitude(s) for diagram number 324
      CALL FFV1_0(W(1,30),W(1,5),W(1,60),GC_11,AMP(372))
C     Amplitude(s) for diagram number 325
      CALL FFV1_0(W(1,30),W(1,14),W(1,2),GC_11,AMP(373))
C     Amplitude(s) for diagram number 326
      CALL FFV1_0(W(1,1),W(1,36),W(1,60),GC_11,AMP(374))
C     Amplitude(s) for diagram number 327
      CALL FFV1_0(W(1,1),W(1,14),W(1,59),GC_11,AMP(375))
C     Amplitude(s) for diagram number 328
      CALL FFV1_0(W(1,40),W(1,4),W(1,64),GC_11,AMP(376))
C     Amplitude(s) for diagram number 329
      CALL VVV1_0(W(1,64),W(1,2),W(1,8),GC_10,AMP(377))
C     Amplitude(s) for diagram number 330
      CALL FFV1_0(W(1,1),W(1,12),W(1,8),GC_11,AMP(378))
C     Amplitude(s) for diagram number 331
      CALL FFV1_0(W(1,42),W(1,4),W(1,44),GC_11,AMP(379))
C     Amplitude(s) for diagram number 332
      CALL VVV1_0(W(1,44),W(1,2),W(1,25),GC_10,AMP(380))
C     Amplitude(s) for diagram number 333
      CALL FFV1_0(W(1,1),W(1,56),W(1,25),GC_11,AMP(381))
C     Amplitude(s) for diagram number 334
      CALL FFV1_0(W(1,3),W(1,41),W(1,64),GC_11,AMP(382))
C     Amplitude(s) for diagram number 335
      CALL VVV1_0(W(1,64),W(1,2),W(1,28),GC_10,AMP(383))
C     Amplitude(s) for diagram number 336
      CALL FFV1_0(W(1,1),W(1,12),W(1,28),GC_11,AMP(384))
C     Amplitude(s) for diagram number 337
      CALL FFV1_0(W(1,3),W(1,66),W(1,44),GC_11,AMP(385))
C     Amplitude(s) for diagram number 338
      CALL VVV1_0(W(1,44),W(1,2),W(1,20),GC_10,AMP(386))
C     Amplitude(s) for diagram number 339
      CALL FFV1_0(W(1,1),W(1,56),W(1,20),GC_11,AMP(387))
      CALL FFV1_2(W(1,1),W(1,63),GC_11,ZERO,ZERO,W(1,56))
      CALL FFV1_2(W(1,1),W(1,62),GC_11,ZERO,ZERO,W(1,20))
      CALL FFV1_2(W(1,1),W(1,61),GC_11,ZERO,ZERO,W(1,44))
C     Amplitude(s) for diagram number 340
      CALL FFV1_0(W(1,56),W(1,5),W(1,9),GC_11,AMP(388))
      CALL FFV1_0(W(1,20),W(1,5),W(1,9),GC_11,AMP(389))
      CALL FFV1_0(W(1,44),W(1,5),W(1,9),GC_11,AMP(390))
C     Amplitude(s) for diagram number 341
      CALL FFV1_0(W(1,45),W(1,5),W(1,63),GC_11,AMP(391))
      CALL FFV1_0(W(1,45),W(1,5),W(1,62),GC_11,AMP(392))
      CALL FFV1_0(W(1,45),W(1,5),W(1,61),GC_11,AMP(393))
      JAMP(1)=+1D0/2D0*(-AMP(2)-AMP(5)-AMP(4)+AMP(10)+IMAG1*AMP(11)
     $ -IMAG1*AMP(16)+AMP(17)+IMAG1*AMP(24)+AMP(25)+AMP(28)-IMAG1
     $ *AMP(37)+AMP(59)+AMP(65)-AMP(63)+AMP(69)-IMAG1*AMP(71)-IMAG1
     $ *AMP(72)-AMP(74)-IMAG1*AMP(112)-IMAG1*AMP(115)-IMAG1*AMP(114)
     $ +IMAG1*AMP(116)+IMAG1*AMP(117)-IMAG1*AMP(120)+IMAG1*AMP(118)
     $ -IMAG1*AMP(128)-IMAG1*AMP(127)+IMAG1*AMP(134)-IMAG1*AMP(132)
     $ -IMAG1*AMP(137)+IMAG1*AMP(135)+IMAG1*AMP(138)-IMAG1*AMP(140)
     $ -AMP(153)+IMAG1*AMP(154)+AMP(158)-AMP(161)-AMP(160)+AMP(183)
     $ +AMP(285)+IMAG1*AMP(286)+AMP(288)-IMAG1*AMP(293)-AMP(354)
     $ -AMP(355)+AMP(358)-AMP(356)+IMAG1*AMP(359)+AMP(374)+IMAG1
     $ *AMP(380))
      JAMP(2)=+1D0/2D0*(-AMP(1)+AMP(5)-AMP(3)+AMP(13)+IMAG1*AMP(14)
     $ +IMAG1*AMP(16)-AMP(17)+IMAG1*AMP(19)+AMP(20)+AMP(23)+IMAG1
     $ *AMP(37)+AMP(61)+AMP(63)+AMP(64)+AMP(66)-IMAG1*AMP(68)+IMAG1
     $ *AMP(72)+AMP(74)-IMAG1*AMP(111)+IMAG1*AMP(115)-IMAG1*AMP(113)
     $ +IMAG1*AMP(121)+IMAG1*AMP(122)-IMAG1*AMP(125)+IMAG1*AMP(123)
     $ -IMAG1*AMP(131)-IMAG1*AMP(130)+IMAG1*AMP(132)+IMAG1*AMP(133)
     $ +IMAG1*AMP(137)-IMAG1*AMP(135)-IMAG1*AMP(138)+IMAG1*AMP(140)
     $ -AMP(141)+IMAG1*AMP(142)+AMP(146)-AMP(149)-AMP(148)-AMP(183)
     $ +AMP(284)+IMAG1*AMP(289)+AMP(291)+IMAG1*AMP(293)-AMP(363)
     $ -AMP(364)+AMP(367)-AMP(365)+IMAG1*AMP(368)-AMP(374)+IMAG1
     $ *AMP(377))
      JAMP(3)=+1D0/2D0*(-1D0/3D0*AMP(238)-1D0/3D0*AMP(240)-1D0/3D0
     $ *AMP(243)-1D0/3D0*AMP(245)-1D0/3D0*AMP(278)+1D0/3D0*IMAG1
     $ *AMP(282)+1D0/3D0*IMAG1*AMP(283)-1D0/3D0*AMP(288)+1D0/3D0*IMAG1
     $ *AMP(292)+1D0/3D0*IMAG1*AMP(293))
      JAMP(4)=+1D0/2D0*(-1D0/3D0*AMP(200)-1D0/3D0*AMP(202)-1D0/3D0
     $ *AMP(205)-1D0/3D0*AMP(207)-1D0/3D0*AMP(281)-1D0/3D0*IMAG1
     $ *AMP(282)-1D0/3D0*IMAG1*AMP(283)-1D0/3D0*AMP(291)-1D0/3D0*IMAG1
     $ *AMP(292)-1D0/3D0*IMAG1*AMP(293))
      JAMP(5)=+1D0/2D0*(-1D0/3D0*AMP(25)-1D0/3D0*AMP(27)-1D0/3D0
     $ *AMP(30)+1D0/3D0*IMAG1*AMP(37)+1D0/3D0*IMAG1*AMP(38)-1D0/3D0
     $ *AMP(311)-1D0/3D0*AMP(313)-1D0/3D0*AMP(315)+1D0/3D0*IMAG1
     $ *AMP(320)+1D0/3D0*IMAG1*AMP(321))
      JAMP(6)=+1D0/2D0*(-1D0/3D0*AMP(20)-1D0/3D0*AMP(22)-1D0/3D0
     $ *AMP(34)-1D0/3D0*IMAG1*AMP(37)-1D0/3D0*IMAG1*AMP(38)-1D0/3D0
     $ *AMP(307)-1D0/3D0*AMP(309)-1D0/3D0*AMP(318)-1D0/3D0*IMAG1
     $ *AMP(320)-1D0/3D0*IMAG1*AMP(321))
      JAMP(7)=+1D0/2D0*(+AMP(43)+AMP(45)+AMP(46)+AMP(48)+IMAG1*AMP(50)
     $ -IMAG1*AMP(54)+AMP(56)+IMAG1*AMP(111)-IMAG1*AMP(115)+IMAG1
     $ *AMP(113)-IMAG1*AMP(121)-IMAG1*AMP(122)+IMAG1*AMP(125)-IMAG1
     $ *AMP(123)+IMAG1*AMP(131)+IMAG1*AMP(130)-IMAG1*AMP(132)-IMAG1
     $ *AMP(133)-IMAG1*AMP(137)+IMAG1*AMP(135)+IMAG1*AMP(138)-IMAG1
     $ *AMP(140)-AMP(165)-IMAG1*AMP(166)+AMP(170)-AMP(173)-AMP(172)
     $ -AMP(184)-IMAG1*AMP(236)+AMP(238)+AMP(239)-IMAG1*AMP(246)
     $ +AMP(248)+AMP(250)-AMP(258)-AMP(259)+AMP(262)-AMP(260)-IMAG1
     $ *AMP(263)-IMAG1*AMP(273)-IMAG1*AMP(282)-AMP(294)+AMP(298)
     $ -AMP(296)-AMP(303)-IMAG1*AMP(305)-IMAG1*AMP(314)+AMP(315)-IMAG1
     $ *AMP(321)-AMP(372))
      JAMP(8)=+1D0/2D0*(+AMP(41)+AMP(47)-AMP(45)+AMP(51)+IMAG1*AMP(53)
     $ +IMAG1*AMP(54)-AMP(56)+IMAG1*AMP(112)+IMAG1*AMP(115)+IMAG1
     $ *AMP(114)-IMAG1*AMP(116)-IMAG1*AMP(117)+IMAG1*AMP(120)-IMAG1
     $ *AMP(118)+IMAG1*AMP(128)+IMAG1*AMP(127)-IMAG1*AMP(134)+IMAG1
     $ *AMP(132)+IMAG1*AMP(137)-IMAG1*AMP(135)-IMAG1*AMP(138)+IMAG1
     $ *AMP(140)-AMP(174)-IMAG1*AMP(175)+AMP(179)-AMP(182)-AMP(181)
     $ +AMP(184)-IMAG1*AMP(198)+AMP(200)+AMP(201)-IMAG1*AMP(208)
     $ +AMP(210)+AMP(212)-AMP(220)-AMP(221)+AMP(224)-AMP(222)-IMAG1
     $ *AMP(225)-IMAG1*AMP(235)+IMAG1*AMP(282)-AMP(295)-AMP(298)
     $ -AMP(297)+AMP(303)+IMAG1*AMP(305)-IMAG1*AMP(317)+AMP(318)+IMAG1
     $ *AMP(321)+AMP(372))
      JAMP(9)=+1D0/2D0*(-AMP(59)-AMP(61)-IMAG1*AMP(62)-AMP(65)-AMP(64)
     $ +AMP(70)+IMAG1*AMP(71)-AMP(80)-IMAG1*AMP(83)+IMAG1*AMP(81)
     $ +IMAG1*AMP(84)-IMAG1*AMP(86)+AMP(87)-IMAG1*AMP(88)-IMAG1
     $ *AMP(116)-IMAG1*AMP(117)+IMAG1*AMP(120)-IMAG1*AMP(118)-IMAG1
     $ *AMP(121)-IMAG1*AMP(124)-IMAG1*AMP(123)+IMAG1*AMP(126)+IMAG1
     $ *AMP(127)-IMAG1*AMP(134)-IMAG1*AMP(133)-AMP(158)+AMP(159)
     $ +AMP(160)+IMAG1*AMP(203)+AMP(206)+AMP(207)+IMAG1*AMP(219)
     $ -AMP(220)-AMP(221)+AMP(224)-AMP(222)+AMP(227)+IMAG1*AMP(229)
     $ +AMP(230)+IMAG1*AMP(232)-IMAG1*AMP(289)+AMP(290)+AMP(323)-IMAG1
     $ *AMP(328)+AMP(330)-IMAG1*AMP(331)-IMAG1*AMP(336)+AMP(363)
     $ +AMP(366)+AMP(365))
      JAMP(10)=+1D0/2D0*(-1D0/3D0*AMP(242)-1D0/3D0*AMP(244)+1D0/3D0
     $ *IMAG1*AMP(251)+1D0/3D0*IMAG1*AMP(252)-1D0/3D0*AMP(269)-1D0/3D0
     $ *AMP(284)-1D0/3D0*AMP(290)+1D0/3D0*IMAG1*AMP(335)+1D0/3D0*IMAG1
     $ *AMP(336)-1D0/3D0*AMP(376))
      JAMP(11)=+1D0/2D0*(-1D0/3D0*AMP(211)-1D0/3D0*AMP(212)-1D0/3D0
     $ *AMP(230)-1D0/3D0*AMP(233)-1D0/3D0*AMP(312)-1D0/3D0*AMP(319)
     $ +1D0/3D0*IMAG1*AMP(331)+1D0/3D0*IMAG1*AMP(332)+1D0/3D0*IMAG1
     $ *AMP(333)+1D0/3D0*IMAG1*AMP(334))
      JAMP(12)=+1D0/2D0*(+AMP(79)-IMAG1*AMP(83)+IMAG1*AMP(81)+IMAG1
     $ *AMP(84)-IMAG1*AMP(86)-AMP(90)-IMAG1*AMP(92)-IMAG1*AMP(111)
     $ -IMAG1*AMP(112)-IMAG1*AMP(114)-IMAG1*AMP(113)+IMAG1*AMP(122)
     $ -IMAG1*AMP(125)-IMAG1*AMP(124)-IMAG1*AMP(128)+IMAG1*AMP(126)
     $ -IMAG1*AMP(131)-IMAG1*AMP(130)-AMP(141)+IMAG1*AMP(145)+AMP(146)
     $ -AMP(149)-AMP(148)-IMAG1*AMP(150)+AMP(152)+AMP(174)+AMP(182)
     $ -AMP(180)+IMAG1*AMP(246)+AMP(247)+AMP(249)-IMAG1*AMP(251)-IMAG1
     $ *AMP(254)-AMP(255)+AMP(259)-AMP(262)-AMP(261)+AMP(269)-IMAG1
     $ *AMP(270)+AMP(294)+AMP(295)+AMP(297)+AMP(296)-IMAG1*AMP(301)
     $ -IMAG1*AMP(306)+AMP(309)+IMAG1*AMP(317)+AMP(319)-AMP(326)-IMAG1
     $ *AMP(334))
      JAMP(13)=+1D0/2D0*(+AMP(57)+AMP(61)+IMAG1*AMP(62)+AMP(63)+AMP(64)
     $ -IMAG1*AMP(73)+AMP(74)-IMAG1*AMP(75)-AMP(76)+AMP(80)+IMAG1
     $ *AMP(83)+IMAG1*AMP(82)+IMAG1*AMP(85)+IMAG1*AMP(86)+IMAG1
     $ *AMP(121)+IMAG1*AMP(124)+IMAG1*AMP(123)+IMAG1*AMP(132)+IMAG1
     $ *AMP(133)+IMAG1*AMP(137)+IMAG1*AMP(136)+IMAG1*AMP(139)+IMAG1
     $ *AMP(140)-AMP(185)+AMP(191)-AMP(189)+IMAG1*AMP(197)-IMAG1
     $ *AMP(195)-IMAG1*AMP(241)+AMP(242)+AMP(243)-IMAG1*AMP(252)-IMAG1
     $ *AMP(253)+AMP(255)+AMP(258)+AMP(261)+AMP(260)+IMAG1*AMP(263)
     $ +AMP(264)-IMAG1*AMP(292)-AMP(327)+AMP(372)-IMAG1*AMP(373)
     $ -AMP(375)-AMP(388)+AMP(390))
      JAMP(14)=+1D0/2D0*(-1D0/3D0*AMP(57)-1D0/3D0*AMP(69)-1D0/3D0
     $ *AMP(70)+1D0/3D0*IMAG1*AMP(72)+1D0/3D0*IMAG1*AMP(73)+1D0/3D0
     $ *IMAG1*AMP(75)+1D0/3D0*AMP(76)+1D0/3D0*AMP(78)+1D0/3D0*IMAG1
     $ *AMP(88)+1D0/3D0*IMAG1*AMP(89)-1D0/3D0*AMP(156)+1D0/3D0*AMP(185)
     $ +1D0/3D0*AMP(187)+1D0/3D0*IMAG1*AMP(188)-1D0/3D0*AMP(191)+1D0
     $ /3D0*AMP(189)-1D0/3D0*AMP(194)+1D0/3D0*AMP(192))
      JAMP(15)=+1D0/2D0*(-1D0/3D0*AMP(247)-1D0/3D0*AMP(248)+1D0/3D0
     $ *IMAG1*AMP(253)+1D0/3D0*IMAG1*AMP(254)-1D0/3D0*AMP(264)-1D0/3D0
     $ *AMP(299)+1D0/3D0*IMAG1*AMP(304)+1D0/3D0*IMAG1*AMP(305)+1D0/3D0
     $ *IMAG1*AMP(324)+1D0/3D0*AMP(325)+1D0/3D0*AMP(327)+1D0/3D0
     $ *AMP(370)+1D0/3D0*IMAG1*AMP(373)+1D0/3D0*AMP(375)+1D0/3D0
     $ *AMP(388)-1D0/3D0*AMP(390)-1D0/3D0*AMP(393)+1D0/3D0*AMP(391))
      JAMP(16)=+1D0/2D0*(-AMP(78)-IMAG1*AMP(82)-IMAG1*AMP(81)-IMAG1
     $ *AMP(84)-IMAG1*AMP(85)-AMP(87)-IMAG1*AMP(89)+IMAG1*AMP(112)
     $ +IMAG1*AMP(115)+IMAG1*AMP(114)+IMAG1*AMP(128)-IMAG1*AMP(126)
     $ -IMAG1*AMP(136)-IMAG1*AMP(135)-IMAG1*AMP(138)-IMAG1*AMP(139)
     $ +AMP(153)-IMAG1*AMP(154)+AMP(156)+AMP(161)-AMP(159)-AMP(183)
     $ -AMP(187)-IMAG1*AMP(188)+AMP(194)-AMP(192)-IMAG1*AMP(197)+IMAG1
     $ *AMP(195)-AMP(295)-AMP(298)-AMP(297)+AMP(299)+IMAG1*AMP(301)
     $ +AMP(303)-IMAG1*AMP(304)+IMAG1*AMP(310)+AMP(311)+AMP(312)-IMAG1
     $ *AMP(320)-IMAG1*AMP(324)-AMP(325)+AMP(326)-IMAG1*AMP(332)
     $ -AMP(370)+AMP(393)-AMP(391))
      JAMP(17)=+1D0/2D0*(-AMP(59)-IMAG1*AMP(60)-AMP(61)-AMP(65)-AMP(64)
     $ +AMP(67)+IMAG1*AMP(68)-AMP(98)-IMAG1*AMP(101)+IMAG1*AMP(99)
     $ +IMAG1*AMP(102)-IMAG1*AMP(104)+AMP(105)-IMAG1*AMP(106)-IMAG1
     $ *AMP(116)-IMAG1*AMP(119)-IMAG1*AMP(118)-IMAG1*AMP(121)-IMAG1
     $ *AMP(122)+IMAG1*AMP(125)-IMAG1*AMP(123)+IMAG1*AMP(129)+IMAG1
     $ *AMP(130)-IMAG1*AMP(134)-IMAG1*AMP(133)-AMP(146)+AMP(147)
     $ +AMP(148)+IMAG1*AMP(241)+AMP(244)+AMP(245)+IMAG1*AMP(257)
     $ -AMP(258)-AMP(259)+AMP(262)-AMP(260)+AMP(265)+IMAG1*AMP(267)
     $ +AMP(268)+IMAG1*AMP(270)-IMAG1*AMP(286)+AMP(287)+AMP(338)-IMAG1
     $ *AMP(343)+AMP(345)-IMAG1*AMP(346)-IMAG1*AMP(351)+AMP(354)
     $ +AMP(357)+AMP(356))
      JAMP(18)=+1D0/2D0*(-1D0/3D0*AMP(204)-1D0/3D0*AMP(206)+1D0/3D0
     $ *IMAG1*AMP(213)+1D0/3D0*IMAG1*AMP(214)-1D0/3D0*AMP(231)-1D0/3D0
     $ *AMP(285)-1D0/3D0*AMP(287)+1D0/3D0*IMAG1*AMP(350)+1D0/3D0*IMAG1
     $ *AMP(351)-1D0/3D0*AMP(379))
      JAMP(19)=+1D0/2D0*(-1D0/3D0*AMP(249)-1D0/3D0*AMP(250)-1D0/3D0
     $ *AMP(268)-1D0/3D0*AMP(271)-1D0/3D0*AMP(308)-1D0/3D0*AMP(316)
     $ +1D0/3D0*IMAG1*AMP(346)+1D0/3D0*IMAG1*AMP(347)+1D0/3D0*IMAG1
     $ *AMP(348)+1D0/3D0*IMAG1*AMP(349))
      JAMP(20)=+1D0/2D0*(+AMP(97)-IMAG1*AMP(101)+IMAG1*AMP(99)+IMAG1
     $ *AMP(102)-IMAG1*AMP(104)-AMP(108)-IMAG1*AMP(110)-IMAG1*AMP(111)
     $ -IMAG1*AMP(112)-IMAG1*AMP(114)-IMAG1*AMP(113)+IMAG1*AMP(117)
     $ -IMAG1*AMP(120)-IMAG1*AMP(119)-IMAG1*AMP(128)-IMAG1*AMP(127)
     $ -IMAG1*AMP(131)+IMAG1*AMP(129)-AMP(153)+IMAG1*AMP(157)+AMP(158)
     $ -AMP(161)-AMP(160)-IMAG1*AMP(162)+AMP(164)+AMP(165)+AMP(173)
     $ -AMP(171)+IMAG1*AMP(208)+AMP(209)+AMP(211)-IMAG1*AMP(213)-IMAG1
     $ *AMP(216)-AMP(217)+AMP(221)-AMP(224)-AMP(223)+AMP(231)-IMAG1
     $ *AMP(232)+AMP(294)+AMP(295)+AMP(297)+AMP(296)-IMAG1*AMP(302)
     $ -IMAG1*AMP(310)+AMP(313)+IMAG1*AMP(314)+AMP(316)-AMP(341)-IMAG1
     $ *AMP(349))
      JAMP(21)=+1D0/2D0*(+AMP(58)+AMP(59)+IMAG1*AMP(60)+AMP(65)-AMP(63)
     $ +IMAG1*AMP(73)-AMP(74)-IMAG1*AMP(93)-AMP(94)+AMP(98)+IMAG1
     $ *AMP(101)+IMAG1*AMP(100)+IMAG1*AMP(103)+IMAG1*AMP(104)+IMAG1
     $ *AMP(116)+IMAG1*AMP(119)+IMAG1*AMP(118)+IMAG1*AMP(134)-IMAG1
     $ *AMP(132)-IMAG1*AMP(137)-IMAG1*AMP(136)-IMAG1*AMP(139)-IMAG1
     $ *AMP(140)+AMP(185)+AMP(189)+AMP(190)+IMAG1*AMP(195)+IMAG1
     $ *AMP(196)-IMAG1*AMP(203)+AMP(204)+AMP(205)-IMAG1*AMP(214)-IMAG1
     $ *AMP(215)+AMP(217)+AMP(220)+AMP(223)+AMP(222)+IMAG1*AMP(225)
     $ +AMP(226)+IMAG1*AMP(292)-AMP(342)-AMP(372)+IMAG1*AMP(373)
     $ +AMP(375)+AMP(388)+AMP(389))
      JAMP(22)=+1D0/2D0*(-1D0/3D0*AMP(58)-1D0/3D0*AMP(66)-1D0/3D0
     $ *AMP(67)-1D0/3D0*IMAG1*AMP(72)-1D0/3D0*IMAG1*AMP(73)+1D0/3D0
     $ *IMAG1*AMP(93)+1D0/3D0*AMP(94)+1D0/3D0*AMP(96)+1D0/3D0*IMAG1
     $ *AMP(106)+1D0/3D0*IMAG1*AMP(107)-1D0/3D0*AMP(144)-1D0/3D0
     $ *AMP(185)-1D0/3D0*AMP(187)-1D0/3D0*IMAG1*AMP(188)-1D0/3D0
     $ *AMP(189)-1D0/3D0*AMP(190)-1D0/3D0*AMP(192)-1D0/3D0*AMP(193))
      JAMP(23)=+1D0/2D0*(-1D0/3D0*AMP(209)-1D0/3D0*AMP(210)+1D0/3D0
     $ *IMAG1*AMP(215)+1D0/3D0*IMAG1*AMP(216)-1D0/3D0*AMP(226)-1D0/3D0
     $ *AMP(300)-1D0/3D0*IMAG1*AMP(304)-1D0/3D0*IMAG1*AMP(305)+1D0/3D0
     $ *IMAG1*AMP(339)+1D0/3D0*AMP(340)+1D0/3D0*AMP(342)-1D0/3D0
     $ *AMP(370)-1D0/3D0*IMAG1*AMP(373)-1D0/3D0*AMP(375)-1D0/3D0
     $ *AMP(388)-1D0/3D0*AMP(389)-1D0/3D0*AMP(391)-1D0/3D0*AMP(392))
      JAMP(24)=+1D0/2D0*(-AMP(96)-IMAG1*AMP(100)-IMAG1*AMP(99)-IMAG1
     $ *AMP(102)-IMAG1*AMP(103)-AMP(105)-IMAG1*AMP(107)+IMAG1*AMP(111)
     $ -IMAG1*AMP(115)+IMAG1*AMP(113)+IMAG1*AMP(131)-IMAG1*AMP(129)
     $ +IMAG1*AMP(136)+IMAG1*AMP(135)+IMAG1*AMP(138)+IMAG1*AMP(139)
     $ +AMP(141)-IMAG1*AMP(142)+AMP(144)+AMP(149)-AMP(147)+AMP(183)
     $ +AMP(187)+IMAG1*AMP(188)+AMP(192)+AMP(193)-IMAG1*AMP(195)-IMAG1
     $ *AMP(196)-AMP(294)+AMP(298)-AMP(296)+AMP(300)+IMAG1*AMP(302)
     $ -AMP(303)+IMAG1*AMP(304)+IMAG1*AMP(306)+AMP(307)+AMP(308)+IMAG1
     $ *AMP(320)-IMAG1*AMP(339)-AMP(340)+AMP(341)-IMAG1*AMP(347)
     $ +AMP(370)+AMP(391)+AMP(392))
      JAMP(25)=+1D0/2D0*(+AMP(78)+IMAG1*AMP(82)+IMAG1*AMP(81)+IMAG1
     $ *AMP(84)+IMAG1*AMP(85)+AMP(87)+IMAG1*AMP(89)-IMAG1*AMP(95)
     $ +AMP(96)-AMP(97)+IMAG1*AMP(101)+IMAG1*AMP(100)+IMAG1*AMP(103)
     $ +IMAG1*AMP(104)-IMAG1*AMP(117)+IMAG1*AMP(120)+IMAG1*AMP(119)
     $ +IMAG1*AMP(126)+IMAG1*AMP(127)+AMP(155)-IMAG1*AMP(157)-AMP(158)
     $ +AMP(159)+AMP(160)-AMP(194)-AMP(193)+IMAG1*AMP(197)+IMAG1
     $ *AMP(196)+IMAG1*AMP(324)+AMP(325)-AMP(326)+IMAG1*AMP(332)
     $ +AMP(340)-IMAG1*AMP(344)-AMP(345)-IMAG1*AMP(350)+AMP(352)
     $ +AMP(355)-AMP(358)-AMP(357)+IMAG1*AMP(360)+AMP(379)-IMAG1
     $ *AMP(380)+AMP(381)-AMP(393)-AMP(392))
      JAMP(26)=+1D0/2D0*(+AMP(40)+AMP(41)-IMAG1*AMP(42)+AMP(47)-AMP(45)
     $ -IMAG1*AMP(55)-AMP(56)+IMAG1*AMP(95)-AMP(96)+AMP(97)-IMAG1
     $ *AMP(101)-IMAG1*AMP(100)-IMAG1*AMP(103)-IMAG1*AMP(104)-IMAG1
     $ *AMP(116)-IMAG1*AMP(119)-IMAG1*AMP(118)-IMAG1*AMP(134)+IMAG1
     $ *AMP(132)+IMAG1*AMP(137)+IMAG1*AMP(136)+IMAG1*AMP(139)+IMAG1
     $ *AMP(140)+AMP(187)+AMP(192)+AMP(193)-IMAG1*AMP(195)-IMAG1
     $ *AMP(196)+IMAG1*AMP(276)+AMP(277)+AMP(278)-IMAG1*AMP(283)
     $ -AMP(340)+IMAG1*AMP(344)+AMP(345)+IMAG1*AMP(350)+AMP(353)
     $ +AMP(354)+AMP(357)+AMP(356)-IMAG1*AMP(359)+AMP(370)-IMAG1
     $ *AMP(371)-AMP(374)+AMP(391)+AMP(392))
      JAMP(27)=+1D0/2D0*(-IMAG1*AMP(77)+AMP(78)-AMP(79)+IMAG1*AMP(83)
     $ +IMAG1*AMP(82)+IMAG1*AMP(85)+IMAG1*AMP(86)+AMP(96)+IMAG1
     $ *AMP(100)+IMAG1*AMP(99)+IMAG1*AMP(102)+IMAG1*AMP(103)+AMP(105)
     $ +IMAG1*AMP(107)-IMAG1*AMP(122)+IMAG1*AMP(125)+IMAG1*AMP(124)
     $ +IMAG1*AMP(129)+IMAG1*AMP(130)+AMP(143)-IMAG1*AMP(145)-AMP(146)
     $ +AMP(147)+AMP(148)-AMP(194)-AMP(193)+IMAG1*AMP(197)+IMAG1
     $ *AMP(196)+AMP(325)-IMAG1*AMP(329)-AMP(330)-IMAG1*AMP(335)+IMAG1
     $ *AMP(339)+AMP(340)-AMP(341)+IMAG1*AMP(347)+AMP(361)+AMP(364)
     $ -AMP(367)-AMP(366)+IMAG1*AMP(369)+AMP(376)-IMAG1*AMP(377)
     $ +AMP(378)-AMP(393)-AMP(392))
      JAMP(28)=+1D0/2D0*(+AMP(39)+AMP(43)-IMAG1*AMP(44)+AMP(45)+AMP(46)
     $ +IMAG1*AMP(55)+AMP(56)+IMAG1*AMP(77)-AMP(78)+AMP(79)-IMAG1
     $ *AMP(83)-IMAG1*AMP(82)-IMAG1*AMP(85)-IMAG1*AMP(86)-IMAG1
     $ *AMP(121)-IMAG1*AMP(124)-IMAG1*AMP(123)-IMAG1*AMP(132)-IMAG1
     $ *AMP(133)-IMAG1*AMP(137)-IMAG1*AMP(136)-IMAG1*AMP(139)-IMAG1
     $ *AMP(140)-AMP(187)+AMP(194)-AMP(192)-IMAG1*AMP(197)+IMAG1
     $ *AMP(195)+IMAG1*AMP(279)+AMP(280)+AMP(281)+IMAG1*AMP(283)
     $ -AMP(325)+IMAG1*AMP(329)+AMP(330)+IMAG1*AMP(335)+AMP(362)
     $ +AMP(363)+AMP(366)+AMP(365)-IMAG1*AMP(368)-AMP(370)+IMAG1
     $ *AMP(371)+AMP(374)+AMP(393)-AMP(391))
      JAMP(29)=+1D0/2D0*(-1D0/3D0*IMAG1*AMP(253)-1D0/3D0*IMAG1*AMP(254)
     $ -1D0/3D0*AMP(256)-1D0/3D0*AMP(265)-1D0/3D0*AMP(266)-1D0/3D0
     $ *IMAG1*AMP(324)-1D0/3D0*AMP(325)-1D0/3D0*AMP(327)+1D0/3D0*IMAG1
     $ *AMP(337)-1D0/3D0*AMP(340)-1D0/3D0*AMP(342)+1D0/3D0*IMAG1
     $ *AMP(343)+1D0/3D0*IMAG1*AMP(344)-1D0/3D0*AMP(352)+1D0/3D0
     $ *AMP(389)+1D0/3D0*AMP(390)+1D0/3D0*AMP(393)+1D0/3D0*AMP(392))
      JAMP(30)=+1D0/2D0*(-1D0/3D0*AMP(8)-1D0/3D0*AMP(10)-1D0/3D0
     $ *AMP(12)+1D0/3D0*IMAG1*AMP(16)+1D0/3D0*IMAG1*AMP(18)-1D0/3D0
     $ *IMAG1*AMP(337)+1D0/3D0*AMP(340)+1D0/3D0*AMP(342)-1D0/3D0*IMAG1
     $ *AMP(343)-1D0/3D0*IMAG1*AMP(344)-1D0/3D0*AMP(353)-1D0/3D0
     $ *AMP(370)+1D0/3D0*IMAG1*AMP(371)-1D0/3D0*AMP(375)-1D0/3D0
     $ *AMP(388)-1D0/3D0*AMP(389)-1D0/3D0*AMP(391)-1D0/3D0*AMP(392))
      JAMP(31)=+1D0/2D0*(-1D0/3D0*IMAG1*AMP(215)-1D0/3D0*IMAG1*AMP(216)
     $ -1D0/3D0*AMP(218)-1D0/3D0*AMP(227)-1D0/3D0*AMP(228)+1D0/3D0
     $ *IMAG1*AMP(322)-1D0/3D0*AMP(325)-1D0/3D0*AMP(327)+1D0/3D0*IMAG1
     $ *AMP(328)+1D0/3D0*IMAG1*AMP(329)-1D0/3D0*IMAG1*AMP(339)-1D0/3D0
     $ *AMP(340)-1D0/3D0*AMP(342)-1D0/3D0*AMP(361)+1D0/3D0*AMP(389)
     $ +1D0/3D0*AMP(390)+1D0/3D0*AMP(393)+1D0/3D0*AMP(392))
      JAMP(32)=+1D0/2D0*(-1D0/3D0*AMP(6)-1D0/3D0*AMP(13)-1D0/3D0
     $ *AMP(15)-1D0/3D0*IMAG1*AMP(16)-1D0/3D0*IMAG1*AMP(18)-1D0/3D0
     $ *IMAG1*AMP(322)+1D0/3D0*AMP(325)+1D0/3D0*AMP(327)-1D0/3D0*IMAG1
     $ *AMP(328)-1D0/3D0*IMAG1*AMP(329)-1D0/3D0*AMP(362)+1D0/3D0
     $ *AMP(370)-1D0/3D0*IMAG1*AMP(371)+1D0/3D0*AMP(375)+1D0/3D0
     $ *AMP(388)-1D0/3D0*AMP(390)-1D0/3D0*AMP(393)+1D0/3D0*AMP(391))
      JAMP(33)=+1D0/2D0*(-1D0/3D0*IMAG1*AMP(75)-1D0/3D0*AMP(76)-1D0
     $ /3D0*AMP(78)-1D0/3D0*IMAG1*AMP(88)-1D0/3D0*IMAG1*AMP(89)-1D0
     $ /3D0*AMP(94)+1D0/3D0*IMAG1*AMP(95)-1D0/3D0*AMP(96)+1D0/3D0
     $ *IMAG1*AMP(109)+1D0/3D0*IMAG1*AMP(110)-1D0/3D0*AMP(155)-1D0/3D0
     $ *AMP(163)-1D0/3D0*AMP(164)-1D0/3D0*AMP(167)+1D0/3D0*AMP(191)
     $ +1D0/3D0*AMP(190)+1D0/3D0*AMP(194)+1D0/3D0*AMP(193))
      JAMP(34)=+1D0/2D0*(-1D0/3D0*AMP(40)-1D0/3D0*AMP(48)-1D0/3D0
     $ *AMP(49)+1D0/3D0*IMAG1*AMP(54)+1D0/3D0*IMAG1*AMP(55)+1D0/3D0
     $ *AMP(94)-1D0/3D0*IMAG1*AMP(95)+1D0/3D0*AMP(96)-1D0/3D0*IMAG1
     $ *AMP(109)-1D0/3D0*IMAG1*AMP(110)-1D0/3D0*AMP(168)-1D0/3D0
     $ *AMP(185)+1D0/3D0*IMAG1*AMP(186)-1D0/3D0*AMP(187)-1D0/3D0
     $ *AMP(189)-1D0/3D0*AMP(190)-1D0/3D0*AMP(192)-1D0/3D0*AMP(193))
      JAMP(35)=+1D0/2D0*(-1D0/3D0*AMP(76)+1D0/3D0*IMAG1*AMP(77)-1D0
     $ /3D0*AMP(78)+1D0/3D0*IMAG1*AMP(91)+1D0/3D0*IMAG1*AMP(92)-1D0
     $ /3D0*IMAG1*AMP(93)-1D0/3D0*AMP(94)-1D0/3D0*AMP(96)-1D0/3D0
     $ *IMAG1*AMP(106)-1D0/3D0*IMAG1*AMP(107)-1D0/3D0*AMP(143)-1D0/3D0
     $ *AMP(151)-1D0/3D0*AMP(152)-1D0/3D0*AMP(176)+1D0/3D0*AMP(191)
     $ +1D0/3D0*AMP(190)+1D0/3D0*AMP(194)+1D0/3D0*AMP(193))
      JAMP(36)=+1D0/2D0*(-1D0/3D0*AMP(39)-1D0/3D0*AMP(51)-1D0/3D0
     $ *AMP(52)-1D0/3D0*IMAG1*AMP(54)-1D0/3D0*IMAG1*AMP(55)+1D0/3D0
     $ *AMP(76)-1D0/3D0*IMAG1*AMP(77)+1D0/3D0*AMP(78)-1D0/3D0*IMAG1
     $ *AMP(91)-1D0/3D0*IMAG1*AMP(92)-1D0/3D0*AMP(177)+1D0/3D0*AMP(185)
     $ -1D0/3D0*IMAG1*AMP(186)+1D0/3D0*AMP(187)-1D0/3D0*AMP(191)+1D0
     $ /3D0*AMP(189)-1D0/3D0*AMP(194)+1D0/3D0*AMP(192))
      JAMP(37)=+1D0/2D0*(+IMAG1*AMP(75)+AMP(76)-AMP(80)-IMAG1*AMP(83)
     $ -IMAG1*AMP(82)-IMAG1*AMP(85)-IMAG1*AMP(86)+AMP(94)-IMAG1
     $ *AMP(100)-IMAG1*AMP(99)-IMAG1*AMP(102)-IMAG1*AMP(103)+AMP(108)
     $ -IMAG1*AMP(109)+IMAG1*AMP(122)-IMAG1*AMP(125)-IMAG1*AMP(124)
     $ -IMAG1*AMP(129)-IMAG1*AMP(130)+AMP(167)+IMAG1*AMP(169)-AMP(170)
     $ +AMP(171)+AMP(172)-AMP(191)-AMP(190)-IMAG1*AMP(197)-IMAG1
     $ *AMP(196)+IMAG1*AMP(252)+IMAG1*AMP(253)-AMP(255)+AMP(256)-IMAG1
     $ *AMP(257)+AMP(259)-AMP(262)-AMP(261)+AMP(271)+AMP(272)+IMAG1
     $ *AMP(273)+AMP(327)-IMAG1*AMP(337)-AMP(338)+AMP(342)-IMAG1
     $ *AMP(348)-AMP(389)-AMP(390))
      JAMP(38)=+1D0/2D0*(-AMP(1)+AMP(5)-AMP(3)+AMP(8)-IMAG1*AMP(9)
     $ -AMP(17)-IMAG1*AMP(18)-IMAG1*AMP(29)+AMP(30)+AMP(31)-IMAG1
     $ *AMP(38)-AMP(94)+IMAG1*AMP(100)+IMAG1*AMP(99)+IMAG1*AMP(102)
     $ +IMAG1*AMP(103)-AMP(108)+IMAG1*AMP(109)-IMAG1*AMP(111)+IMAG1
     $ *AMP(115)-IMAG1*AMP(113)-IMAG1*AMP(131)+IMAG1*AMP(129)-IMAG1
     $ *AMP(136)-IMAG1*AMP(135)-IMAG1*AMP(138)-IMAG1*AMP(139)+AMP(165)
     $ +IMAG1*AMP(166)+AMP(168)+AMP(173)-AMP(171)+AMP(184)+AMP(185)
     $ -IMAG1*AMP(186)+AMP(189)+AMP(190)+IMAG1*AMP(195)+IMAG1*AMP(196)
     $ +IMAG1*AMP(337)+AMP(338)-AMP(342)+IMAG1*AMP(348)+AMP(375)
     $ +AMP(388)+AMP(389))
      JAMP(39)=+1D0/2D0*(+AMP(76)-IMAG1*AMP(82)-IMAG1*AMP(81)-IMAG1
     $ *AMP(84)-IMAG1*AMP(85)+AMP(90)-IMAG1*AMP(91)+IMAG1*AMP(93)
     $ +AMP(94)-AMP(98)-IMAG1*AMP(101)-IMAG1*AMP(100)-IMAG1*AMP(103)
     $ -IMAG1*AMP(104)+IMAG1*AMP(117)-IMAG1*AMP(120)-IMAG1*AMP(119)
     $ -IMAG1*AMP(126)-IMAG1*AMP(127)+AMP(176)+IMAG1*AMP(178)-AMP(179)
     $ +AMP(180)+AMP(181)-AMP(191)-AMP(190)-IMAG1*AMP(197)-IMAG1
     $ *AMP(196)+IMAG1*AMP(214)+IMAG1*AMP(215)-AMP(217)+AMP(218)-IMAG1
     $ *AMP(219)+AMP(221)-AMP(224)-AMP(223)+AMP(233)+AMP(234)+IMAG1
     $ *AMP(235)-IMAG1*AMP(322)-AMP(323)+AMP(327)-IMAG1*AMP(333)
     $ +AMP(342)-AMP(389)-AMP(390))
      JAMP(40)=+1D0/2D0*(-AMP(2)-AMP(5)-AMP(4)+AMP(6)-IMAG1*AMP(7)
     $ +AMP(17)+IMAG1*AMP(18)-IMAG1*AMP(33)+AMP(34)+AMP(35)+IMAG1
     $ *AMP(38)-AMP(76)+IMAG1*AMP(82)+IMAG1*AMP(81)+IMAG1*AMP(84)
     $ +IMAG1*AMP(85)-AMP(90)+IMAG1*AMP(91)-IMAG1*AMP(112)-IMAG1
     $ *AMP(115)-IMAG1*AMP(114)-IMAG1*AMP(128)+IMAG1*AMP(126)+IMAG1
     $ *AMP(136)+IMAG1*AMP(135)+IMAG1*AMP(138)+IMAG1*AMP(139)+AMP(174)
     $ +IMAG1*AMP(175)+AMP(177)+AMP(182)-AMP(180)-AMP(184)-AMP(185)
     $ +IMAG1*AMP(186)+AMP(191)-AMP(189)+IMAG1*AMP(197)-IMAG1*AMP(195)
     $ +IMAG1*AMP(322)+AMP(323)-AMP(327)+IMAG1*AMP(333)-AMP(375)
     $ -AMP(388)+AMP(390))
      JAMP(41)=+1D0/2D0*(+AMP(1)+AMP(2)+AMP(4)+AMP(3)+IMAG1*AMP(7)
     $ -IMAG1*AMP(14)+AMP(15)-IMAG1*AMP(24)+AMP(26)+AMP(27)+IMAG1
     $ *AMP(29)+AMP(32)+AMP(80)+IMAG1*AMP(83)-IMAG1*AMP(81)-IMAG1
     $ *AMP(84)+IMAG1*AMP(86)-AMP(87)+IMAG1*AMP(88)+IMAG1*AMP(111)
     $ +IMAG1*AMP(112)+IMAG1*AMP(114)+IMAG1*AMP(113)-IMAG1*AMP(122)
     $ +IMAG1*AMP(125)+IMAG1*AMP(124)+IMAG1*AMP(128)-IMAG1*AMP(126)
     $ +IMAG1*AMP(131)+IMAG1*AMP(130)+AMP(153)+AMP(161)-AMP(159)+IMAG1
     $ *AMP(162)+AMP(163)-AMP(165)-IMAG1*AMP(169)+AMP(170)-AMP(173)
     $ -AMP(172)-AMP(323)+IMAG1*AMP(328)-AMP(330)+IMAG1*AMP(331)+IMAG1
     $ *AMP(336)+AMP(364)-AMP(367)-AMP(366)+AMP(382)+IMAG1*AMP(383))
      JAMP(42)=+1D0/2D0*(-1D0/3D0*AMP(237)-1D0/3D0*AMP(239)-1D0/3D0
     $ *IMAG1*AMP(251)-1D0/3D0*IMAG1*AMP(252)-1D0/3D0*AMP(272)-1D0/3D0
     $ *AMP(274)-1D0/3D0*AMP(280)-1D0/3D0*IMAG1*AMP(335)-1D0/3D0*IMAG1
     $ *AMP(336)-1D0/3D0*AMP(382))
      JAMP(43)=+1D0/2D0*(-1D0/3D0*AMP(26)-1D0/3D0*AMP(28)-1D0/3D0
     $ *AMP(35)-1D0/3D0*AMP(36)-1D0/3D0*IMAG1*AMP(331)-1D0/3D0*IMAG1
     $ *AMP(332)-1D0/3D0*IMAG1*AMP(333)-1D0/3D0*IMAG1*AMP(334)-1D0/3D0
     $ *AMP(381)-1D0/3D0*AMP(387))
      JAMP(44)=+1D0/2D0*(-AMP(41)-AMP(43)+IMAG1*AMP(44)-AMP(47)-AMP(46)
     $ +AMP(52)-IMAG1*AMP(53)-AMP(79)+IMAG1*AMP(83)-IMAG1*AMP(81)
     $ -IMAG1*AMP(84)+IMAG1*AMP(86)+AMP(90)+IMAG1*AMP(92)+IMAG1
     $ *AMP(116)+IMAG1*AMP(117)-IMAG1*AMP(120)+IMAG1*AMP(118)+IMAG1
     $ *AMP(121)+IMAG1*AMP(124)+IMAG1*AMP(123)-IMAG1*AMP(126)-IMAG1
     $ *AMP(127)+IMAG1*AMP(134)+IMAG1*AMP(133)-AMP(179)+AMP(180)
     $ +AMP(181)+IMAG1*AMP(236)+AMP(237)+AMP(240)+IMAG1*AMP(251)+IMAG1
     $ *AMP(254)+AMP(255)+AMP(258)+AMP(261)+AMP(260)+AMP(266)-IMAG1
     $ *AMP(267)+AMP(275)-IMAG1*AMP(276)+AMP(326)+IMAG1*AMP(334)
     $ -AMP(354)-AMP(355)+AMP(358)-AMP(356)-IMAG1*AMP(360)-IMAG1
     $ *AMP(386)+AMP(387))
      JAMP(45)=+1D0/2D0*(-AMP(41)+IMAG1*AMP(42)-AMP(43)-AMP(47)-AMP(46)
     $ +AMP(49)-IMAG1*AMP(50)-AMP(97)+IMAG1*AMP(101)-IMAG1*AMP(99)
     $ -IMAG1*AMP(102)+IMAG1*AMP(104)+AMP(108)+IMAG1*AMP(110)+IMAG1
     $ *AMP(116)+IMAG1*AMP(119)+IMAG1*AMP(118)+IMAG1*AMP(121)+IMAG1
     $ *AMP(122)-IMAG1*AMP(125)+IMAG1*AMP(123)-IMAG1*AMP(129)-IMAG1
     $ *AMP(130)+IMAG1*AMP(134)+IMAG1*AMP(133)-AMP(170)+AMP(171)
     $ +AMP(172)+IMAG1*AMP(198)+AMP(199)+AMP(202)+IMAG1*AMP(213)+IMAG1
     $ *AMP(216)+AMP(217)+AMP(220)+AMP(223)+AMP(222)+AMP(228)-IMAG1
     $ *AMP(229)+AMP(274)-IMAG1*AMP(279)+AMP(341)+IMAG1*AMP(349)
     $ -AMP(363)-AMP(364)+AMP(367)-AMP(365)-IMAG1*AMP(369)-IMAG1
     $ *AMP(383)+AMP(384))
      JAMP(46)=+1D0/2D0*(-1D0/3D0*AMP(21)-1D0/3D0*AMP(23)-1D0/3D0
     $ *AMP(31)-1D0/3D0*AMP(32)-1D0/3D0*IMAG1*AMP(346)-1D0/3D0*IMAG1
     $ *AMP(347)-1D0/3D0*IMAG1*AMP(348)-1D0/3D0*IMAG1*AMP(349)-1D0/3D0
     $ *AMP(378)-1D0/3D0*AMP(384))
      JAMP(47)=+1D0/2D0*(-1D0/3D0*AMP(199)-1D0/3D0*AMP(201)-1D0/3D0
     $ *IMAG1*AMP(213)-1D0/3D0*IMAG1*AMP(214)-1D0/3D0*AMP(234)-1D0/3D0
     $ *AMP(275)-1D0/3D0*AMP(277)-1D0/3D0*IMAG1*AMP(350)-1D0/3D0*IMAG1
     $ *AMP(351)-1D0/3D0*AMP(385))
      JAMP(48)=+1D0/2D0*(+AMP(1)+AMP(2)+AMP(4)+AMP(3)+IMAG1*AMP(9)
     $ -IMAG1*AMP(11)+AMP(12)-IMAG1*AMP(19)+AMP(21)+AMP(22)+IMAG1
     $ *AMP(33)+AMP(36)+AMP(98)+IMAG1*AMP(101)-IMAG1*AMP(99)-IMAG1
     $ *AMP(102)+IMAG1*AMP(104)-AMP(105)+IMAG1*AMP(106)+IMAG1*AMP(111)
     $ +IMAG1*AMP(112)+IMAG1*AMP(114)+IMAG1*AMP(113)-IMAG1*AMP(117)
     $ +IMAG1*AMP(120)+IMAG1*AMP(119)+IMAG1*AMP(128)+IMAG1*AMP(127)
     $ +IMAG1*AMP(131)-IMAG1*AMP(129)+AMP(141)+AMP(149)-AMP(147)+IMAG1
     $ *AMP(150)+AMP(151)-AMP(174)-IMAG1*AMP(178)+AMP(179)-AMP(182)
     $ -AMP(181)-AMP(338)+IMAG1*AMP(343)-AMP(345)+IMAG1*AMP(346)+IMAG1
     $ *AMP(351)+AMP(355)-AMP(358)-AMP(357)+AMP(385)+IMAG1*AMP(386))

C...VINCIA: Leading Color for Diagonal Entry ICOL
      ug_dxdugg = CF(ICOL,ICOL)*JAMP(ICOL)
     &         *DCONJG(JAMP(ICOL))/DENOM(ICOL)
C...VINCIA: Absorb subleading color proportional to FSLC = LC/Sum(LC)
      IF (MCMODE.EQ.0) RETURN
      IF (MCMODE.EQ.1.AND.ug_dxdugg.LE.ZERO) RETURN
        ZLCSUM = 0D0
        DO I = 1, NCOLOR
          ZLCSUM = ZLCSUM + CF(I,I)*JAMP(I)*DCONJG(JAMP(I))/DENOM(I)
        ENDDO
C...VINCIA: MCMODE = 2 returns full colour-summed ME
        IF (MCMODE.EQ.2) ug_dxdugg = ZLCSUM
C...VINCIA: Fraction of subleading color to absorb into this permutation
        FSLC = ug_dxdugg/ZLCSUM
C...VINCIA: Sum over subleading contributions multiplied by FSLC
      DO I = 1, NCOLOR
        ZTEMP = (0.D0,0.D0)
        DO J = 1, NCOLOR
          IF (I.NE.J) ZTEMP = ZTEMP + CF(J,I)*JAMP(J)
        ENDDO
        ug_dxdugg = ug_dxdugg+FSLC*ZTEMP*DCONJG(JAMP(I))/DENOM(I)
      ENDDO

      END

      SUBROUTINE GETug_dxdugg(MCMODE,ICOL,P, ALPHAS, NHEL ,ANS)
      IMPLICIT NONE
C     
C     CONSTANT
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=7)
C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION ANS, P(0:3,NEXTERNAL)
C...VINCIA: Define MCMODE and ICOL variables
C...  MCMODE = 0 : Leading Colour = LC[icol]
C...  MCMODE = 1 : Vincia Colour  = FC * LC[icol]/sum(LC)
C...  MCMODE = 2 : Full Colour    = FC (-> normal MG mode)
      INTEGER MCMODE, ICOL
      INTEGER NHEL
      DOUBLE PRECISION ALPHAS
      DOUBLE PRECISION PI
CF2PY INTENT(OUT) :: ANS
CF2PY INTENT(IN) :: NHEL
CF2PY INTENT(IN) :: P(0:3,NEXTERNAL)
CF2PY INTENT(IN) :: ALPHAS
C     ROUTINE FOR F2PY to read the benchmark point.    
C     the include file with the values of the parameters and masses 
      INCLUDE 'coupl.inc'

      PI = 3.141592653589793D0
      G = 2* DSQRT(ALPHAS*PI)
C...VINCIA: only static MG couplings are interfaced
C      CALL UPDATE_AS_PARAM()
      IF (NHEL.NE.0) THEN
        CALL SHELug_dxdugg(MCMODE,ICOL,P, NHEL, ANS)
      ELSE
        CALL Sug_dxdugg(MCMODE,ICOL,P, ANS)
      ENDIF
      RETURN
      END


